#include"AcqData.h"


PtrSysteme SystemeAcquis = NULL;
HINSTANCE HandleSysteme =NULL;      //Handle pour Carte d'acquisition       

Type_SystemePresent* SystemePresent;
Type_RenvoyerSysteme* RenvoyerSysteme;
Type_LireInfos* LireInfos;
Type_OkEtatSysteme* OkEtatSysteme;
Type_ProgrammerEtatSysteme* ProgrammerEtatSysteme;
Type_EcrireTempo* EcrireTempo;
Type_LireTempo* LireTempo;
Type_FermetureDLL* FermetureDLL;

Type_ProgrammerTimer* ProgrammerTimer;
Type_ValiderTimer* ValiderTimer;
Type_DevaliderTimer* DevaliderTimer;
Type_LireTimer* LireTimer;

Type_LimitesCalibreEA* LimitesCalibreEA;
Type_LireCalibreEA* LireCalibreEA;
Type_EcrireCalibreEA* EcrireCalibreEA;
Type_LireGain* LireGain;
Type_EcrireGain* EcrireGain;
Type_LireEA_Entier* LireEA_Entier;
Type_LireEA_Reel* LireEA_Reel;
Type_BinVoltEA* BinVoltEA;
Type_VoltBinEA* VoltBinEA;

Type_LimitesCalibreSA* LimitesCalibreSA;
Type_LireCalibreSA* LireCalibreSA;
Type_EcrireCalibreSA* EcrireCalibreSA;
Type_EcrireSA_Entier* EcrireSA_Entier;
Type_EcrireSA_Reel* EcrireSA_Reel;
Type_BinVoltSA* BinVoltSA;
Type_VoltBinSA* VoltBinSA;
Type_LirePort* LirePort;
Type_EcrirePort* EcrirePort;

Type_LireBit* LireBit;
Type_EcrireBit* EcrireBit;
Type_LireSensPort* LireSensPort;
Type_ProgrammerSensPort* ProgrammerSensPort;

Type_PreparerAcquisition* PreparerAcquisition;
Type_AcquerirTable* AcquerirTable;
Type_ProgrammerDeclenchement* ProgrammerDeclenchement;
Type_Declencher* Declencher;
Type_PreparerEmission* PreparerEmission;
Type_EmettreSorties* EmettreSorties;


/******************************************************************************
 *            procdures de chargement du driver de Systeme                   *
 ******************************************************************************/

BOOL ChargerDLLSysteme(PCHAR NomSysteme)
{
#define ExtDLL  ".DLL"
char Librairie[200]="";

SystemeAcquis = NULL ;

if (NomSysteme == "") return FALSE;
strcpy(Librairie,NomSysteme);
strupr(Librairie);
if (strstr(NomSysteme,ExtDLL)) strcat(Librairie,ExtDLL);


if (!(HandleSysteme=LoadLibrary(Librairie))) return FALSE;

SetLastError(0);
SystemePresent=(Type_SystemePresent*) GetProcAddress(HandleSysteme,"SystemePresent");
RenvoyerSysteme=(Type_RenvoyerSysteme*) GetProcAddress(HandleSysteme,"RenvoyerSysteme");
LireInfos=(Type_LireInfos*) GetProcAddress(HandleSysteme,"LireInfos");
OkEtatSysteme=(Type_OkEtatSysteme*) GetProcAddress(HandleSysteme,"OkEtatSysteme");
ProgrammerEtatSysteme=(Type_ProgrammerEtatSysteme*) GetProcAddress(HandleSysteme,"ProgrammerEtatSysteme");
EcrireTempo=(Type_EcrireTempo*) GetProcAddress(HandleSysteme,"EcrireTempo");
LireTempo=(Type_LireTempo*) GetProcAddress(HandleSysteme,"LireTempo");
FermetureDLL=(Type_FermetureDLL*) GetProcAddress(HandleSysteme,"FermetureDLL");

ProgrammerTimer=(Type_ProgrammerTimer*) GetProcAddress(HandleSysteme,"ProgrammerTimer");
ValiderTimer=(Type_ValiderTimer*) GetProcAddress(HandleSysteme,"ValiderTimer");
DevaliderTimer=(Type_DevaliderTimer*) GetProcAddress(HandleSysteme,"DevaliderTimer");
LireTimer=(Type_LireTimer*) GetProcAddress(HandleSysteme,"LireTimer");

LimitesCalibreEA=(Type_LimitesCalibreEA*) GetProcAddress(HandleSysteme,"LimitesCalibreEA");
LireCalibreEA=(Type_LireCalibreEA*) GetProcAddress(HandleSysteme,"LireCalibreEA");
EcrireCalibreEA=(Type_EcrireCalibreEA*) GetProcAddress(HandleSysteme,"EcrireCalibreEA");
LireGain=(Type_LireGain*) GetProcAddress(HandleSysteme,"LireGain");
EcrireGain=(Type_EcrireGain*) GetProcAddress(HandleSysteme,"EcrireGain");
LireEA_Entier=(Type_LireEA_Entier*) GetProcAddress(HandleSysteme,"LireEA_Entier");
LireEA_Reel=(Type_LireEA_Reel*) GetProcAddress(HandleSysteme,"LireEA_Reel");
BinVoltEA=(Type_BinVoltEA*) GetProcAddress(HandleSysteme,"BinVoltEA");
VoltBinEA=(Type_VoltBinEA*) GetProcAddress(HandleSysteme,"VoltBinEA");

LimitesCalibreSA=(Type_LimitesCalibreSA*) GetProcAddress(HandleSysteme,"LimitesCalibreSA");
LireCalibreSA=(Type_LireCalibreSA*) GetProcAddress(HandleSysteme,"LireCalibreSA");
EcrireCalibreSA=(Type_EcrireCalibreSA*) GetProcAddress(HandleSysteme,"EcrireCalibreSA");
EcrireSA_Entier=(Type_EcrireSA_Entier*) GetProcAddress(HandleSysteme,"EcrireSA_Entier");
EcrireSA_Reel=(Type_EcrireSA_Reel*) GetProcAddress(HandleSysteme,"EcrireSA_Reel");
BinVoltSA=(Type_BinVoltSA*) GetProcAddress(HandleSysteme,"BinVoltSA");
VoltBinSA=(Type_VoltBinSA*) GetProcAddress(HandleSysteme,"VoltBinSA");
LirePort=(Type_LirePort*) GetProcAddress(HandleSysteme,"LirePort");
EcrirePort=(Type_EcrirePort*) GetProcAddress(HandleSysteme,"EcrirePort");

LireBit=(Type_LireBit*) GetProcAddress(HandleSysteme,"LireBit");
EcrireBit=(Type_EcrireBit*) GetProcAddress(HandleSysteme,"EcrireBit");
LireSensPort=(Type_LireSensPort*) GetProcAddress(HandleSysteme,"LireSensPort");
ProgrammerSensPort=(Type_ProgrammerSensPort*) GetProcAddress(HandleSysteme,"ProgrammerSensPort");

PreparerAcquisition=(Type_PreparerAcquisition*) GetProcAddress(HandleSysteme,"PreparerAcquisition");
AcquerirTable=(Type_AcquerirTable*) GetProcAddress(HandleSysteme,"AcquerirTable");
ProgrammerDeclenchement=(Type_ProgrammerDeclenchement*) GetProcAddress(HandleSysteme,"ProgrammerDeclenchement");
Declencher=(Type_Declencher*) GetProcAddress(HandleSysteme,"Declencher");
PreparerEmission=(Type_PreparerEmission*) GetProcAddress(HandleSysteme,"PreparerEmission");
EmettreSorties=(Type_EmettreSorties*) GetProcAddress(HandleSysteme,"EmettreSorties");

if (GetLastError()) return FALSE;

SystemeAcquis=RenvoyerSysteme();
return SystemePresent();
}


void SupprimerDLLSysteme(void)
{
if (HandleSysteme>0)
	{
	if ((&FermetureDLL)!=0) FermetureDLL;
	while (!FreeLibrary(HandleSysteme));
	}
}