
#include<stdio.h>
#include<windows.h>

	//constantes pour l'octet tat du systeme
#define ca_CalibresGlobal	0x100
#define ca_ModeDiffProg		0x200
#define ca_InhiberTimer		0x01
#define ca_ModeDiff			0x02
#define ca_Arret			0x80


	//Constantes pour la lecture des informations sur le systeme
#define ca_Entree			1
#define ca_Sortie			2
#define ca_Port				3
#define ca_CalibreEntree	4
#define ca_CalibreSortie	5
#define ca_Gain				6


	//Constantes pour le sens d'une entre/sortie logique (Port)
#define ca_PortEnEntree			0
#define ca_PortEnSortie			1
#define ca_PortEnEntreeSortie	2
#define ca_PortEnSortieEntree	3
#define ca_PortInhibe			4
#define ca_PortInexistant		5


	//constantes gnrales
#define MaxPortsLogiques	4       //   Nb maximum grable d'E/S logiques
#define MaxiVoiesGerables	8		//   Nb maximum grable d'entres analogiques
#define MaxiSortiesGerables 2		//   Nb maximum grable de sorties analogiques
#define NPMaximum			10000	//   Nb maximum de valeurs que l'on peut acqurir
#define TotalVoiesSorties	10		//   MaxiVoiesGerables+MaxiSortiesGerables
#define CodeSynchroExterne  70      //   code pour la synchronisation externe


	//type de table des entres/sorties analogiques en service
typedef __int8 TTableVoie[TotalVoiesSorties];
typedef TTableVoie *PtrTableVoie;


	//type de table de l'ensemble des valeurs acquises
//typedef int TypeTableVal[TotalVoiesSorties*NPMaximum];
typedef short TypeTableVal[TotalVoiesSorties*NPMaximum];
typedef TypeTableVal *PtrTableVal;
     
typedef void(TypeProcTache)(int);

	//type dcrivant le systeme d'acquisition
class TSysteme
	{
	public:

	char  dummy1;					// inutilise
	char  NomSysteme[20];			// nom de la carte
	char  dummy2;					// inutilise
	char  NomConstructeur[15];		// nom du constructeur de la carte
	WORD  OctetEtat;				// octet d'tat de la carte
	int   AdrBase1;					// adresse de base de la carte
    int   AdrBase2;					// seconde adresse de base de la carte
    BYTE  VoieDebut;				// n de premire entre analogique
    BYTE  VoieFin;                  // n de dernire entre analogique
    BYTE  SortieDebut;              // n de premire sortie analogique
    BYTE  SortieFin;				// n de dernire sortie analogique
    BYTE  NbDeBits;					// Nb de bits de la carte
    BYTE  MaxCalibreEntree;			// Nb de calibres d'entre
    BYTE  MaxCalibreSortie;			// Nb de calibres de sortie
    BYTE  MaxGain;					// Nb de gains programmables
    BYTE  MaxPorts;					// Nb maxi de ports logiques d'entre
	} ;

typedef TSysteme *PtrSysteme ;

typedef BOOL (CALLBACK Type_SystemePresent)(void);
typedef PtrSysteme (CALLBACK Type_RenvoyerSysteme)(void);
typedef PCHAR (CALLBACK Type_LireInfos)(int,int,int);
typedef BOOL (CALLBACK Type_OkEtatSysteme)(WORD);
typedef void (CALLBACK Type_ProgrammerEtatSysteme)(int,BOOL);
typedef int	(CALLBACK Type_LireTempo)(void);
typedef void (CALLBACK Type_EcrireTempo)(int);
typedef void (CALLBACK Type_FermetureDLL)(void);


   //routines pour le timer
typedef void (CALLBACK Type_ProgrammerTimer)(int);
typedef void (CALLBACK Type_ValiderTimer)(void);
typedef void (CALLBACK Type_DevaliderTimer)(void);
typedef BYTE (CALLBACK Type_LireTimer)(void);


   //routines pour les entres analogiques
typedef void (CALLBACK Type_LimitesCalibreEA)(BYTE,BYTE,double*,double*);
typedef BYTE (CALLBACK Type_LireCalibreEA)(BYTE);
typedef void (CALLBACK Type_EcrireCalibreEA)(BYTE,BYTE);
typedef WORD (CALLBACK Type_LireGain)(BYTE);
typedef void (CALLBACK Type_EcrireGain)(BYTE,BYTE);
typedef int (CALLBACK Type_LireEA_Entier)(BYTE,BYTE);
typedef double (CALLBACK Type_LireEA_Reel)(BYTE,BYTE);
typedef double (CALLBACK Type_BinVoltEA)(int,int);
typedef int (CALLBACK Type_VoltBinEA)(double,int);


	//routines pour les sorties analogiques
typedef void (CALLBACK Type_LimitesCalibreSA)(BYTE,BYTE,double*,double*);
typedef BYTE (CALLBACK Type_LireCalibreSA)(BYTE);
typedef void (CALLBACK Type_EcrireCalibreSA)(int,int);
typedef void (CALLBACK Type_EcrireSA_Entier)(BYTE,int);
typedef void (CALLBACK Type_EcrireSA_Reel)(BYTE,double);
typedef double (CALLBACK Type_BinVoltSA)(int,int);
typedef int (CALLBACK Type_VoltBinSA)(double,int);


    //routines pour les entres/sorties logiques
typedef BYTE (CALLBACK Type_LirePort)(BYTE);
typedef void (CALLBACK Type_EcrirePort)(BYTE,BYTE);
typedef BYTE (CALLBACK Type_LireBit)(BYTE,BYTE);
typedef void (CALLBACK Type_EcrireBit)(BYTE,BYTE,BOOL);
typedef BYTE (CALLBACK Type_LireSensPort)(BYTE);
typedef BOOL (CALLBACK Type_ProgrammerSensPort)(BYTE,BYTE);


    //routines volues
typedef void (CALLBACK Type_PreparerAcquisition)(int,int,double,PtrTableVoie,TypeProcTache);
typedef int (CALLBACK Type_AcquerirTable)(PtrTableVal,int*);
typedef void (CALLBACK Type_ProgrammerDeclenchement)(BYTE,double,BYTE);
typedef BOOL (CALLBACK Type_Declencher)(void);
typedef void (CALLBACK Type_PreparerEmission)(int,int,int,PtrTableVoie,TypeProcTache);
typedef void (CALLBACK Type_EmettreSorties)(PtrTableVal);



/******************************************************************************
 *            procdures de chargement du driver de Systeme                   *
 ******************************************************************************/

extern PtrSysteme SystemeAcquis;

BOOL ChargerDLLSysteme(PCHAR NomSysteme);
void SupprimerDLLSysteme(void);

extern Type_SystemePresent* SystemePresent;
extern Type_RenvoyerSysteme* RenvoyerSysteme;
extern Type_LireInfos* LireInfos;
extern Type_OkEtatSysteme* OkEtatSysteme;
extern Type_ProgrammerEtatSysteme* ProgrammerEtatSysteme;
extern Type_EcrireTempo* EcrireTempo;
extern Type_LireTempo* LireTempo;
extern Type_FermetureDLL* FermetureDLL;

extern Type_ProgrammerTimer* ProgrammerTimer;
extern Type_ValiderTimer* ValiderTimer;
extern Type_DevaliderTimer* DevaliderTimer;
extern Type_LireTimer* LireTimer;

extern Type_LimitesCalibreEA* LimitesCalibreEA;
extern Type_LireCalibreEA* LireCalibreEA;
extern Type_EcrireCalibreEA* EcrireCalibreEA;
extern Type_LireGain* LireGain;
extern Type_EcrireGain* EcrireGain;
extern Type_LireEA_Entier* LireEA_Entier;
extern Type_LireEA_Reel* LireEA_Reel;
extern Type_BinVoltEA* BinVoltEA;
extern Type_VoltBinEA* VoltBinEA;

extern Type_LimitesCalibreSA* LimitesCalibreSA;
extern Type_LireCalibreSA* LireCalibreSA;
extern Type_EcrireCalibreSA* EcrireCalibreSA;
extern Type_EcrireSA_Entier* EcrireSA_Entier;
extern Type_EcrireSA_Reel* EcrireSA_Reel;
extern Type_BinVoltSA* BinVoltSA;
extern Type_VoltBinSA* VoltBinSA;
extern Type_LirePort* LirePort;
extern Type_EcrirePort* EcrirePort;

extern Type_LireBit* LireBit;
extern Type_EcrireBit* EcrireBit;
extern Type_LireSensPort* LireSensPort;
extern Type_ProgrammerSensPort* ProgrammerSensPort;

extern Type_PreparerAcquisition* PreparerAcquisition;
extern Type_AcquerirTable* AcquerirTable;
extern Type_ProgrammerDeclenchement* ProgrammerDeclenchement;
extern Type_Declencher* Declencher;
extern Type_PreparerEmission* PreparerEmission;
extern Type_EmettreSorties* EmettreSorties;