// BkDoc.cpp : implementation of the CBkDoc class
#include "stdafx.h"
#include "Bk.h"
#include "BkDoc.h"
#include "Regres.h"
#include "Accro.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CBkDoc
IMPLEMENT_DYNCREATE(CBkDoc, CDocument)

BEGIN_MESSAGE_MAP(CBkDoc, CDocument)
	//{{AFX_MSG_MAP(CBkDoc)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
CBkDoc::CBkDoc()
{
	m_pApp=((CBkApp*)AfxGetApp());
	//Coordonnes souris____________________
	m_iDx=0;
	m_iDy=0;
	m_fDx=0;
	m_fDy=0;
	m_iX=-1;
	m_iY=-1;
	//Dimensions initiales fentre en mm____
	m_fLarg=280;
	m_fHaut=195;
	//Fentre graphique
	m_fXmi=-m_fLarg/2;
	m_fYmi=-m_fHaut/2;
	m_fXma=m_fLarg/2;
	m_fYma=m_fHaut/2;
	//Dcalage d'origine, chelles et facteurs d'chelle
	m_fXori=0;
	m_fYori=0;
	m_fEchx=1;
	m_fEchy=1;
	m_fFactx=1;
	m_fFacty=1;  
	//Tableau_______________________________
  m_iNbMax=601;	//Nb. de lignes du tableau
	m_iNbCol=6;	//Nb. de colonnes du tableau		
  m_iNb=0;//Aucune acquisition de faite pour l'instant
  m_fT=new float[m_iNbMax][6];//6: m_iNbCol
	Init_m_fT();
	m_iTypeGr=0;
	//Rgressions polynomiales______________
	m_pReg=new CRegres();
	//Classe accrochage au graphique
	m_pAc=new CAccro(this,m_iNbCol);
}
//________________________________________
CBkDoc::~CBkDoc()
{
	delete[] m_fT;
	delete m_pReg;
	delete m_pAc;}
//________________________________________
BOOL CBkDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	return TRUE;
}
//////////////////////////////////////////
// CBkDoc serialization
void CBkDoc::Serialize(CArchive& ar)
{
	short i,j;
	if (ar.IsStoring())
	{
		//Types reconnus:
		//CObject*,SIZE and CSize,float,WORD,CString,POINT and CPoint,DWORD,BYTE,RECT and CRect,double,
		//LONG,CTime and CTimeSpan
		
		//Oprations de sauvegarde
		ar<<(short)m_iTypeGr;           
		ar<<(short)m_iNb;           
		ar<<(short)m_iNbMax;
		ar<<(short)m_iNbCol;           
		for (i=0;i<m_iNb;i++)
		{
			for (j=0;j<m_iNbCol;j++)
			{
				ar<<m_fT[i][j];
			}
		} 
		//Paramtres rgressions
		for (i=0;i<3;i++)
		{
			for (j=0;j<9;j++)
			{
				ar << m_pReg->m_fa[i][j];
			}
			for (j=0;j<2;j++)
			{
				ar << m_pReg->m_fP1[i][j];			
				ar << m_pReg->m_fP2[i][j];
				ar << (short)m_pReg->m_iNoColX[i][j];
				ar << (short)m_pReg->m_iNoColY[i][j];
		 		ar << (short)m_pReg->m_iNoPt[i][j];
				ar << (short)m_pReg->m_OKPt[i][j];
			}
	 		ar << (short)m_pReg->m_iNoBtn[i];
			ar << (short)m_pReg->m_iType[i];
	 		ar << (short)m_pReg->m_OKCalcul[i];
	 		ar << (short)m_pReg->m_OKTrace[i];
		}
	}
	else
	{
		//Oprations de lecture
		ar>>(short&)m_iTypeGr;           
		ar>>(short&)m_iNb;
		ar>>(short&)m_iNbMax;
		ar>>(short&)m_iNbCol;
		for (i=0;i<m_iNb;i++)
		{
			for (j=0;j<m_iNbCol;j++)
			{
				ar>>m_fT[i][j];
			}
		}
		//Paramtres rgressions
		for (i=0;i<3;i++)
		{
			for (j=0;j<9;j++)
			{
				ar >> m_pReg->m_fa[i][j];
			}
			for (j=0;j<2;j++)
			{
				ar >> m_pReg->m_fP1[i][j];			
				ar >> m_pReg->m_fP2[i][j];
				ar >> (short&)m_pReg->m_iNoColX[i][j];
				ar >> (short&)m_pReg->m_iNoColY[i][j];
		 		ar >> (short&)m_pReg->m_iNoPt[i][j];
				ar >> (short&)m_pReg->m_OKPt[i][j];
			}
	 		ar >> (short&)m_pReg->m_iNoBtn[i];
			ar >> (short&)m_pReg->m_iType[i];
	 		ar >> (short&)m_pReg->m_OKCalcul[i];
	 		ar >> (short&)m_pReg->m_OKTrace[i];
		}
	}
}
//////////////////////////////////////////
// CBkDoc diagnostics
#ifdef _DEBUG
void CBkDoc::AssertValid() const
{
	CDocument::AssertValid();
}
void CBkDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG
//////////////////////////////////////////
// CBkDoc commands
void CBkDoc::Init_m_fT(void)
{
	short i,j;
	for (i=0;i<m_iNbMax;i++)
	{
		for (j=0;j<m_iNbCol;j++)
		{
			m_fT[i][j]=1e10;
		}
	}
	m_iNb=0;
}
//________________________________________
