// depdlg.cpp : implementation file
#include "stdafx.h"
#include "bk.h"
#include "bkdoc.h"
#include "depdlg.h"   
#include "mm2000.h"    

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CDepDlg dialog
CDepDlg::CDepDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDepDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDepDlg)
	m_lCte = 0;
	m_fVit = 0;
	m_sXpos = "";
	m_sYpos = "";
	//}}AFX_DATA_INIT
}
//________________________________________
void CDepDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDepDlg)
	DDX_Control(pDX, IDRESET, m_btnReset);
	DDX_Control(pDX, IDCANCEL, m_btnCancel);
	DDX_Control(pDX, IDC_VA, m_btnVa);
	DDX_Control(pDX, IDC_GH, m_btnGH);
	DDX_Control(pDX, IDC_DH, m_btnDH);
	DDX_Control(pDX, IDC_STOP, m_btnStop);
	DDX_Control(pDX, IDC_Y_PLUS, m_btnYplus);
	DDX_Control(pDX, IDC_Y_MOINS, m_btnYmoins);
	DDX_Control(pDX, IDC_X_PLUS, m_btnXplus);
	DDX_Control(pDX, IDC_X_MOINS, m_btnXmoins);
	DDX_Text(pDX, IDC_CTE, m_lCte);
	DDX_Text(pDX, IDC_VIT, m_fVit);
	DDX_Text(pDX, IDC_X, m_sXpos);
	DDX_Text(pDX, IDC_Y, m_sYpos);
	//}}AFX_DATA_MAP
}
//________________________________________
BEGIN_MESSAGE_MAP(CDepDlg, CDialog)
	//{{AFX_MSG_MAP(CDepDlg)
	ON_EN_KILLFOCUS(IDC_VIT, OnKillfocusVit)
	ON_EN_KILLFOCUS(IDC_CTE, OnKillfocusCte)
	ON_EN_CHANGE(IDC_X, OnChangeX)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_BN_CLICKED(IDC_DH, OnDh)
	ON_BN_CLICKED(IDC_GH, OnGh)
	ON_BN_CLICKED(IDC_VA, OnVa)
	ON_BN_CLICKED(IDC_X_MOINS, OnXMoins)
	ON_BN_CLICKED(IDC_X_PLUS, OnXPlus)
	ON_BN_CLICKED(IDC_Y_MOINS, OnYMoins)
	ON_BN_CLICKED(IDC_Y_PLUS, OnYPlus)
	ON_BN_CLICKED(IDRESET, OnReset)
	ON_EN_CHANGE(IDC_Y, OnChangeY)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_STOP, OnStop)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CDepDlg message handlers
BOOL CDepDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	m_pApp=((CBkApp*)AfxGetApp());
	CMDIChildWnd *pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) m_pDoc=(CBkDoc*)pChild->GetActiveDocument(); else m_pDoc=NULL;
	float x,y;
	//Pas d'axe en mouvement
	m_cNoAxeMvt=0;

	m_pMM2000=new CMM2000();

	m_lCte=m_pMM2000->m_lCte;  
	m_fVit=m_pMM2000->m_fVit;          

	//On invalide le bouton STOP
	m_btnStop.EnableWindow(FALSE);

	x=m_pMM2000->TP(1);
	y=m_pMM2000->TP(2);
	if (x==1e10)
	{
		m_sXpos="?";
		m_sYpos="?";
		m_btnXplus.EnableWindow(FALSE);
		m_btnXmoins.EnableWindow(FALSE);
		m_btnYplus.EnableWindow(FALSE);
		m_btnYmoins.EnableWindow(FALSE);
		m_btnDH.EnableWindow(FALSE);
		m_btnGH.EnableWindow(FALSE);
		m_btnVa.EnableWindow(FALSE);      
		m_btnReset.EnableWindow(FALSE);      

	}
	else
	{
		//On initialise
		m_pMM2000->SV(0,m_fVit);
		m_sXpos.Format("%6.2f",x);
		m_sYpos.Format("%6.2f",y);
	}
	UpdateData(FALSE);
	return TRUE;
}
//________________________________________
void CDepDlg::OnStop()
{
	//Clic sur le bouton Stop
	//On supprime le timer de vrification des butes et d'affichage position
	KillTimer(1);
	//On arrte le dplacement en cours: Stop
	if (m_cNoAxeMvt!=0)
	{
		m_pMM2000->ST(0);
		//m_pMM2000->WS(0);
		Sleep(200);
		//Affichage de la position courante
		m_sXpos.Format("%6.2f",m_pMM2000->TP(1));
		m_sYpos.Format("%6.2f",m_pMM2000->TP(2));
		//On invalide le bouton STOP		
		m_btnStop.EnableWindow(FALSE);      
		//On valide les autres boutons
		m_btnXplus.EnableWindow(TRUE);
		m_btnXmoins.EnableWindow(TRUE);
		m_btnYplus.EnableWindow(TRUE);
		m_btnYmoins.EnableWindow(TRUE);
		m_btnDH.EnableWindow(TRUE);
		m_btnGH.EnableWindow(TRUE);
		m_btnVa.EnableWindow(TRUE);      
		m_btnCancel.EnableWindow(TRUE);      
		UpdateData(FALSE);
	}
	//Plus d'axe en mouvement
	m_cNoAxeMvt=0;
}
//________________________________________
void CDepDlg::OnKillfocusVit()
{
	//Modification de la vitesse
	UpdateData(TRUE);
	//Vitesse maxi: 100 mm/min
	if (m_fVit>20) m_fVit=20;
	if (m_fVit<1) m_fVit=1;
	UpdateData(FALSE);                     
	m_pMM2000->m_fVit=m_fVit;
}
//________________________________________
void CDepDlg::OnKillfocusCte()
{
	//Modification de la constante
	UpdateData(TRUE);
	if (m_lCte<1) m_lCte=1;
	UpdateData(FALSE);                     
	m_pMM2000->m_lCte=m_lCte;  
}
//________________________________________
void CDepDlg::OnChangeX()
{
	//Prise en compte de Xpos
	UpdateData(TRUE);
}
//________________________________________
void CDepDlg::OnChangeY()
{
	//Prise en compte de Ypos
	UpdateData(TRUE);
}
//________________________________________
void CDepDlg::OnDh()
{
	float x,y;
	//Define Home
	m_pMM2000->DH(0);
	//Affichage de la position courante
	x=0;
	y=0;
	if (x==1e10)
	{
		m_sXpos="?";
		m_sYpos="?";
	}
	else
	{
		m_sXpos.Format("%6.2f",x);
		m_sYpos.Format("%6.2f",y);
	}
	UpdateData(FALSE);
}
//________________________________________
void CDepDlg::OnGh()
{
	//Go Home                           
	//On invalide les boutons
	m_btnGH.EnableWindow(FALSE);
	m_btnXplus.EnableWindow(FALSE);
	m_btnXmoins.EnableWindow(FALSE);
	m_btnYplus.EnableWindow(FALSE);
	m_btnYmoins.EnableWindow(FALSE);
	m_btnVa.EnableWindow(FALSE);      
	m_btnCancel.EnableWindow(FALSE);      
	//On dfinit la vitesse
	m_pMM2000->SV(0,m_fVit);
	//On se dplace             
	m_pMM2000->GH(0);
	SetTimer(1,40,NULL);
}
//________________________________________
void CDepDlg::OnVa()
{
	//Dplacement vers la position demande
	float x,y;
	int i,j;
	i=sscanf(m_sXpos,"%f",&x);
	j=sscanf(m_sYpos,"%f",&y);
	if (i==1 && j==1)
	{
		//On invalide les boutons
		m_btnXplus.EnableWindow(FALSE);
		m_btnXmoins.EnableWindow(FALSE);
		m_btnYplus.EnableWindow(FALSE);
		m_btnYmoins.EnableWindow(FALSE);
		m_btnDH.EnableWindow(FALSE);
		m_btnGH.EnableWindow(FALSE);
		m_btnStop.EnableWindow(FALSE);      
		m_btnVa.EnableWindow(FALSE);      
		m_btnCancel.EnableWindow(FALSE);      
		//On dfinit la vitesse
		m_pMM2000->SV(0,m_fVit);
		//On se dplace             
		m_pMM2000->MA(1,x);
		m_pMM2000->MA(2,y);
		SetTimer(1,40,NULL);
	} 
}
//________________________________________
void CDepDlg::OnXMoins()
{
	//On valide/invalide les boutons
	m_btnXplus.EnableWindow(FALSE);
	m_btnXmoins.EnableWindow(FALSE);
	m_btnYplus.EnableWindow(FALSE);
	m_btnYmoins.EnableWindow(FALSE);
	m_btnDH.EnableWindow(FALSE);
	m_btnVa.EnableWindow(FALSE);      
	m_btnGH.EnableWindow(FALSE);
	m_btnCancel.EnableWindow(FALSE);      
	m_btnStop.EnableWindow(TRUE);      
	m_cNoAxeMvt=1;
	//On dfinit la vitesse
	m_pMM2000->SV(1,m_fVit);
	//On se dplace             
	m_pMM2000->MR(1,-200.00);
	//Dmarre le timer pour affichage coordonnes
	SetTimer(1,40,NULL);
}
//________________________________________
void CDepDlg::OnXPlus()
{
	//On valide/invalide les boutons
	m_btnXplus.EnableWindow(FALSE);
	m_btnXmoins.EnableWindow(FALSE);
	m_btnYplus.EnableWindow(FALSE);
	m_btnYmoins.EnableWindow(FALSE);
	m_btnDH.EnableWindow(FALSE);
	m_btnVa.EnableWindow(FALSE);      
	m_btnGH.EnableWindow(FALSE);
	m_btnCancel.EnableWindow(FALSE);      
	m_btnStop.EnableWindow(TRUE);      
	m_cNoAxeMvt=1;
	//On dfinit la vitesse
	m_pMM2000->SV(1,m_fVit);
	//On se dplace             
	m_pMM2000->MR(1,200.00);
	//Dmarre le timer pour affichage coordonnes
	SetTimer(1,40,NULL);
}
//________________________________________
void CDepDlg::OnYMoins()
{
	//On valide/invalide les boutons
	m_btnXplus.EnableWindow(FALSE);
	m_btnXmoins.EnableWindow(FALSE);
	m_btnYplus.EnableWindow(FALSE);
	m_btnYmoins.EnableWindow(FALSE);
	m_btnDH.EnableWindow(FALSE);
	m_btnVa.EnableWindow(FALSE);      
	m_btnGH.EnableWindow(FALSE);
	m_btnCancel.EnableWindow(FALSE);      
	m_btnStop.EnableWindow(TRUE);      
	m_cNoAxeMvt=2;
	//On dfinit la vitesse
	m_pMM2000->SV(2,m_fVit);
	//On se dplace             
	m_pMM2000->MR(2,-100.00);//Timer -> surveillance butes
	//Dmarre le timer pour affichage coordonnes
	SetTimer(1,40,NULL);
}
//________________________________________
void CDepDlg::OnYPlus()
{
	//On valide/invalide les boutons
	m_btnXplus.EnableWindow(FALSE);
	m_btnXmoins.EnableWindow(FALSE);
	m_btnYplus.EnableWindow(FALSE);
	m_btnYmoins.EnableWindow(FALSE);
	m_btnDH.EnableWindow(FALSE);
	m_btnVa.EnableWindow(FALSE);      
	m_btnGH.EnableWindow(FALSE);
	m_btnCancel.EnableWindow(FALSE);      
	m_btnStop.EnableWindow(TRUE);      
	m_cNoAxeMvt=2;
	//On dfinit la vitesse
	m_pMM2000->SV(2,m_fVit);
	//On se dplace             
	m_pMM2000->MA(2,200.00);
	//Dmarre le timer pour affichage coordonnes
	SetTimer(1,40,NULL);
}
//________________________________________
void CDepDlg::OnReset()
{
	//Appui sur le bouton Reset
	//m_pMM2000->RT(0);//Reset axes avec paramtres d'asservissement par dfaut
	/*
	m_btnGH.EnableWindow(TRUE);
	m_btnDH.EnableWindow(TRUE);
	m_btnXplus.EnableWindow(TRUE);
	m_btnXmoins.EnableWindow(TRUE);
	m_btnYplus.EnableWindow(TRUE);
	m_btnYmoins.EnableWindow(TRUE);
	m_btnVa.EnableWindow(TRUE);      
	m_btnStop.EnableWindow(FALSE);
	*/
	//Affichage de la position courante
	m_sXpos.Format("%6.2f",m_pMM2000->TP(1));
	Sleep(300);
	m_sYpos.Format("%6.2f",m_pMM2000->TP(2));
	UpdateData(FALSE);
}
//________________________________________
void CDepDlg::OnTimer(UINT nIDEvent)
{
	//Affichage de la position courante des axes
	if (m_pMM2000->MT(0))
	{
		KillTimer(1);
		m_btnGH.EnableWindow(TRUE);
		m_btnDH.EnableWindow(TRUE);
		m_btnXplus.EnableWindow(TRUE);
		m_btnXmoins.EnableWindow(TRUE);
		m_btnYplus.EnableWindow(TRUE);
		m_btnYmoins.EnableWindow(TRUE);
		m_btnVa.EnableWindow(TRUE);      
		m_btnStop.EnableWindow(FALSE);
		m_btnCancel.EnableWindow(TRUE);
	
	}
	m_sXpos.Format("%6.2f",m_pMM2000->TP(1));
	m_sYpos.Format("%6.2f",m_pMM2000->TP(2));
	UpdateData(FALSE);
	CDialog::OnTimer(nIDEvent);
}
//________________________________________
void CDepDlg::OnCancel()
{
	delete m_pMM2000;
	CDialog::OnCancel();
}
//_________________________________________________
void CDepDlg::OnOK()
{
	//Supprim
	//CDialog::OnOK();
}
