// Dessin.cpp : implementation file
//
#include "stdafx.h"
#include "bk.h"
#include "Dessin.h"
#include "BkDoc.h"
#include "Regres.h"
#include "GeoAna.h"
#include <math.h>
#include <sys/timeb.h>
#include <locale.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//__________________________________________________
CDessin::CDessin(class CDC* pDC)
{                       
	m_pApp=(CBkApp*)AfxGetApp();
	if (pDC->IsPrinting())
		m_ech=1440.0/25.4;//1 twip = 1/1440e de pouce!
	else
		m_ech=100;

	m_pDC=pDC;
	m_pDoc=NULL;
	if (AfxGetApp()->m_pMainWnd)
	{
		CFrameWnd *pFrame=(CFrameWnd *)(AfxGetApp()->m_pMainWnd);
		m_pDoc=(CBkDoc*)pFrame->GetActiveDocument();
	}
	m_fHautTexte=3.8;//Hauteur rfrence du TextOut en mm
	echx=1;
	echy=1;
	xori=0;
	yori=0;
	factx=1;
	facty=1;
	xmi=m_pDoc->m_fXmi;
	ymi=m_pDoc->m_fYmi;
	xma=m_pDoc->m_fXma;
	yma=m_pDoc->m_fYma;  
	//Pour trac graphes...
	if (m_pDoc->m_iNb>0)
	{
		Nb=m_pDoc->m_iNb;
		//Initialisation des graphes  tracer et des noms abs/ord
		for (short i=0;i<m_pDoc->m_iNbCol;i++)
		{
			for (short j=0;j<2;j++)
			{
				iD_Axes[j][i]=-1;
				iN_Axes[j][i]="";
			}
		}
	}
	//Pas de zoom par dfaut
	InitZoom();
}
//__________________________________________________
CDessin::~CDessin()
{
	//Mise  jour des paramtres de trac
	if (m_pDoc->m_iNb>0)
	{
		m_pDoc->m_fXmi=xmi;	
		m_pDoc->m_fYmi=ymi;	
		m_pDoc->m_fXma=xma;	
		m_pDoc->m_fYma=yma;	
		//Mise  jour des chelles pour affichage coordonnes  l'aide de la souris
		m_pDoc->m_fEchx=echx;	
		m_pDoc->m_fEchy=echy;	
		//Mise  jour du dcalage d'origine pour affichage coordonnes  l'aide de la souris
		m_pDoc->m_fXori=xori;	
		m_pDoc->m_fYori=yori;	
		//Mise  jour du fact. puissance de 10 pour affichage coordonnes  l'aide de la souris
		m_pDoc->m_fFactx=factx;	
		m_pDoc->m_fFacty=facty;	 
	}
}
//__________________________________________________
void CDessin::MoveTo(float x,float y)
{
	m_pDC->MoveTo((int)(x*m_ech),(int)(y*m_ech));
}
//__________________________________________________
void CDessin::LineTo(float x,float y)
{
	m_pDC->LineTo((int)(x*m_ech),(int)(y*m_ech));
}
//__________________________________________________
void CDessin::Line(float xd,float yd,float xa,float ya)
{
	m_pDC->MoveTo((int)(xd*m_ech),(int)(yd*m_ech));
	m_pDC->LineTo((int)(xa*m_ech),(int)(ya*m_ech));
}
//__________________________________________________
void CDessin::Arc(float xg,float yb,float xd,float yh,float x1, float y1,float x2,float y2)
{
	m_pDC->Arc((int)(xg*m_ech),(int)(yb*m_ech),(int)(xd*m_ech),(int)(yh*m_ech),(int)(x1*m_ech),(int)(y1*m_ech),(int)(x2*m_ech),(int)(y2*m_ech));
}
//__________________________________________________
void CDessin::Arc(float xc,float yc,float ray,float xd,float yd,float xa,float ya)
{
  short
  	x1,x2,x3,x4,y1,y2,y3,y4;
  x1=(int)((xc-ray)*m_ech);	
  y1=(int)((yc+ray)*m_ech);	
  x2=(int)((xc+ray)*m_ech);	
  y2=(int)((yc-ray)*m_ech);	
  x3=(int)(xd*m_ech);	
  y3=(int)(yd*m_ech);	
  x4=(int)(xa*m_ech);	
  y4=(int)(ya*m_ech);	
	m_pDC->Arc(x1,y1,x2,y2,x3,y3,x4,y4);
}
//__________________________________________________
void CDessin::Circle(float xc,float yc,float ray)
{
  short
  	x1,x2,x3,x4,y1,y2,y3,y4;
  x1=(int)((xc-ray)*m_ech);	
  y1=(int)((yc+ray)*m_ech);	
  x2=(int)((xc+ray)*m_ech);	
  y2=(int)((yc-ray)*m_ech);	
  x3=(int)((xc-ray)*m_ech);	
  y3=(int)((yc)*m_ech);	
  x4=(int)((xc-ray)*m_ech);	
  y4=(int)((yc)*m_ech);	
	m_pDC->Arc(x1,y1,x2,y2,x3,y3,x4,y4);
}
//__________________________________________________
void CDessin::TextOut(float x,float y,CString s)
{
	m_pDC->TextOut((int)(x*m_ech),(int)(y*m_ech),s);     
}
//__________________________________________________
void CDessin::Rectangle(float xg,float yb,float xd,float yh)
{
	m_pDC->Rectangle((int)(xg*m_ech),(int)(yh*m_ech),(int)(xd*m_ech),(int)(yb*m_ech));
}   
//__________________________________________________
void CDessin::Fleche(float xp,float yp,float a,float l)
{
  const 
  	float PI=(float)(4*atan(1)),
  	ang=(float)(15.0*PI/180);
  a=a+PI;
	m_pDC->MoveTo((int)((xp+l*cos(a+ang))*m_ech),(int)((yp+l*sin(a+ang))*m_ech));
	m_pDC->LineTo((int)(xp*m_ech),(int)(yp*m_ech));
	m_pDC->LineTo((int)((xp+l*cos(a-ang))*m_ech),(int)((yp+l*sin(a-ang))*m_ech));
}
//________________________________________
//Attention m_fT doit tre de 6 colonnes !
char CDessin::Graphe6(void)
{    
  CPen 
  	plumeC,       
  	plumeD,
  	plumeX,
  	plumeY,
  	plumeM,
  	plumeR,
  	plumeI,
  	plumeJ,
  	*m_pOldPen;
	CFont 
		fntC,  
		fntD,
		*m_pOldFont;
	COLORREF clrOld;	
  
  short
  	i,j,k,
		nb[6]={0,0,0,0,0,0}; 
  float
  	r,
  	x,y,xd,yd,xa,ya,
		xmin=1e10,ymin=1e10,xmax=-1e10,ymax=-1e10,
		larg,haut,  //Dimensions de la fenetre
		pasx,pasy;	
	long
		cc[6]={RGB(255,0,0),RGB(0,0,255),RGB(0,255,0),RGB(61,190,200),RGB(192,58,203),RGB(213,217,45)};	
	CString	s;	             
	BOOL ok;		
			
	for(i=0;i<Nb;i++)
	{                    
		for (j=0;j<6;j++)
		{
			//Absisses
			if (iD_Axes[0][j]!=-1 && iD_Axes[1][j]!=-1) 
			{
				//Ce couple abs/ord est  tracer
				if (m_pDoc->m_fT[i][iD_Axes[0][j]]>m_fZoomXmi && m_pDoc->m_fT[i][iD_Axes[0][j]]<m_fZoomXma && m_pDoc->m_fT[i][iD_Axes[1][j]]>m_fZoomYmi && m_pDoc->m_fT[i][iD_Axes[1][j]]<m_fZoomYma) 
				{
					if (m_pDoc->m_fT[i][iD_Axes[0][j]]<xmin) xmin=m_pDoc->m_fT[i][iD_Axes[0][j]];
					if (m_pDoc->m_fT[i][iD_Axes[0][j]]>xmax) xmax=m_pDoc->m_fT[i][iD_Axes[0][j]];
					if (m_pDoc->m_fT[i][iD_Axes[1][j]]<ymin) ymin=m_pDoc->m_fT[i][iD_Axes[1][j]];
					if (m_pDoc->m_fT[i][iD_Axes[1][j]]>ymax) ymax=m_pDoc->m_fT[i][iD_Axes[1][j]];
					nb[j]++;
				}
			}
		}
	}
	ok=FALSE;
	for (k=0;k<6;k++)
	{
		if (iD_Axes[0][k]!=-1 && iD_Axes[1][k]!=-1 && nb[k]>=2) ok=TRUE;
	}
	if (!ok) return 1;
	//Calcul des chelles, prvoir ventuellement une marge...
	larg=xma-xmi;
	haut=yma-ymi;
  //Si les valeurs sont constantes
	if (fabs(ymax-ymin)<1e-8)
	{
		ymax=(float)(ymax+0.01);
		ymin=(float)(ymin-0.01);
	}
	if (fabs(xmax-xmin)<1e-8)
	{
		xmax=(float)(xmax+0.01);
		xmin=(float)(xmin-0.01);
	}                                
	echx=(larg-70)/(xmax-xmin);                    
	echy=(haut-70)/(ymax-ymin);
	//Calcul pasx
	pasx=1e-10;
	do
	{
		pasx=pasx*10;
	}                              
	while	(echx*pasx<=1);
	pasx=pasx*5;
	//Calcul pasy
	pasy=1e-10;
	do
	{
		pasy=pasy*10;
	}           
	while	(echy*pasy<=1);		
	pasy=pasy*10;
	//Rajustement en fonction du nombre de divisions de l'axe
	i=(int)((xmax-xmin)/pasx);
	if (i<=2) pasx=pasx/4;
	else
	if (i<=5) pasx=pasx/2;
	if (i>12) pasx=pasx*2;

	j=(int)((ymax-ymin)/pasy);
	if (j<=2) pasy=pasy/4;
	else
	if (j<=5) pasy=pasy/2;
	//Recherche facteurs axes x et y
	if (fabs(xmin)>fabs(xmax))
		x=xmin;
	else
		x=xmax;
	if (x!=0)
	{
		factx=1e-10;
		do
		{
			factx=factx*10;
		}
		while (fabs(x*factx)<1);	
	}	                           
	else
		factx=1;

	if (fabs(ymin)>fabs(ymax))
		y=ymin;
	else
		y=ymax;

	if (y!=0)
	{
		facty=1e-10;
		do
		{
			facty=facty*10;
		}
		while (fabs(y*facty)<1);	
	}	                           
	else
		facty=1;
	//Calcul xori et yori
	xori=0;yori=0;
	if ((xmin<=0) && (xmax>=0))
		xori=0;
	else
	{
		//xori=xmin;	
		if (xmin>0)
		{
			//On encadre dans le sens positif
			xori=0;
			do
			{
				xori=xori+pasx;
			}
			while (xori<xmin);
			xori=xori-pasx;
		}
		else
		{
			//On encadre dans le sens ngatif
			xori=0;
			do
			{
				xori=xori-pasx;
			}
			while (xori>xmin);
			xori=xori+pasx;
		}
	}	
	if ((ymin<=0) && (ymax>=0))
		yori=0;
	else
	{
		if (ymin>0)
		{
			//On encadre dans le sens positif
			yori=0;
			do
			{
				yori=yori+pasy;
			}
			while (yori<ymin);
			yori=yori-pasy;
		}
		else
		{
			//On encadre dans le sens ngatif
			yori=0;
			do
			{
				yori=yori-pasy;
			}
			while (yori>ymin);
			yori=yori+pasy;
		}

  }
	//Dplacement de l'origine de la fenetre graphique    
	if (xori!=0)
		xmi=-40;		
	else
		xmi=xmin*echx-40;		
	xma=xmi+larg;		
	if (yori!=0)
		ymi=-30;		
	else
		ymi=ymin*echy-30;		
	yma=ymi+haut;
	echx=echx*0.95;
	echy=echy*0.95;
  //Dcalage axes
  m_pDC->SetWindowOrg((int)(m_ech*xmi),(int)(m_ech*yma));
  plumeC.CreatePen(PS_SOLID,(int)(0.20*m_ech),RGB(0,0,0));
	m_pOldPen=m_pDC->SelectObject(&plumeC);        
  Rectangle(xmi,ymi,xma,yma);
	fntC.CreateFont((int)(m_ech*m_fHautTexte*0.8),0,0,0,FW_MEDIUM,FALSE,FALSE,FALSE,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,"Arial");
	m_pOldFont=m_pDC->SelectObject(&fntC);	  
	m_pDC->SetTextAlign(TA_LEFT);							
	clrOld=m_pDC->SetTextColor(RGB(0,0,255));
  TextOut((float)(xmi+0.5),(float)(ymi+4.5),"B.K. - Lyce J. Mermoz - 68300 ST.-LOUIS");
	//Date et heure
	CTime t;
	setlocale(LC_TIME,"French");
	t=CTime::GetCurrentTime();   
	s=t.Format("%A, %d %B %Y - %H:%M:%S");
	m_pDC->SetTextAlign(TA_RIGHT);							
	TextOut((float)(xma-0.8),(float)(ymi+4.5),s);

	//Dtermination zone de trac
	xa=pasx;
	while(xa*echx<=(xma-5))
	{
		xa=xa+pasx;
	}
	xa=xa-pasx;
	xa=xa*echx;
	
	xd=-pasx;
	while(xd*echx>=(xmi+5))
	{
		xd=xd-pasx;
	}
	xd=xd+pasx;
	xd=xd*echx;
  ya=pasy;
  while (ya*echy<=(yma-5))
  {                        
  	ya=ya+pasy;
  }     
  ya=ya-pasy;                  
  ya=ya*echy;
  yd=-pasy;
  while (yd*echy>=(ymi+5))
  {                        
  	yd=yd-pasy;
  } 
  yd=yd+pasy;
  yd=yd*echy;
  //Cadre autour de la zone 
  Rectangle(xd,yd,xa,ya);
	//Trac des axes  
	Line(xd,0,xa,0);
	Line(0,yd,0,ya);
  plumeD.CreatePen(PS_SOLID,(int)(0*m_ech),RGB(127,127,127));
	m_pDC->SelectObject(&plumeD);        
	fntD.CreateFont((int)(m_ech*m_fHautTexte),0,0,0,FW_MEDIUM,FALSE,FALSE,FALSE,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,"Arial");
	m_pDC->SelectObject(&fntD);	  
	m_pDC->SetTextAlign(TA_CENTER);							
	m_pDC->SetTextColor(RGB(0,0,0));
  //Division axe x
  x=pasx;
  while (x*echx<=(xma-5))
  {           
  	r=x*echx;
  	s.Format("%1.2f",(x+xori)*factx);
  	TextOut(r,-2.5,s);  
  	Line(r,yd,r,-7.00);
  	Line(r,0.0,r,ya);
    x=x+pasx;
  }                   
  x=-pasx;
  while (x*echx>=(xmi+5))
  {           
  	r=x*echx;
  	s.Format("%1.2f",(x+xori)*factx);
  	TextOut(r,-2.5,s);  
  	Line(r,yd,r,-7.00);
  	Line(r,0.0,r,ya);
    x=x-pasx;
  }                      
	//Division axe y
	m_pDC->SetTextAlign(TA_RIGHT);							
	y=0;
	while(y*echy<=(yma-5))
	{          
  	r=y*echy;
  	s.Format("%1.2f",(y+yori)*facty);
  	TextOut(-2.00,(float)(r+2.0),s);  
  	if (xd<-15) Line(xd,r,-10,r);
  	Line(0.0,r,xa,r);
		y=y+pasy;
	}		  
	y=-pasy;
	while(y*echy>=(ymi+5))
	{          
  	r=y*echy;
  	s.Format("%1.2f",(y+yori)*facty);
  	TextOut(-2.00,(float)(r+2.0),s);  
  	if (xd<-15) Line(xd,r,-10,r);
  	Line(0.0,r,xa,r);
		y=y-pasy;
	}		                  
	//Ecriture des chelles
	//Toujours fonteD
	m_pDC->SetTextAlign(TA_BASELINE);							
	s.Format("Echx:%7.2e / Echy:%7.2e",echx,echy);
	TextOut((float)(xd+1.50),(float)(yma-5.00),s);  
	//Ecriture du titre
	//Toujours fonteD
	m_pDC->SetTextAlign(TA_CENTER);							
	TextOut((float)((xmi+xma)/2),(float)(yma-30.0),Titre);  
	//Ecriture facteurs axes x et noms axes abscisses
	//Toujours fonteD
	m_pDC->SetTextAlign(TA_RIGHT | TA_BOTTOM);							
	r=1.0;          
	for (k=0;k<6;k++)
	{
		if (iD_Axes[0][k]!=-1 && iN_Axes[0][k].GetLength()!=0)
		{
			m_pDC->SetTextColor(cc[k]);
			s.Format("%s*%5.0e",iN_Axes[0][k],1/factx);
			TextOut(xa-1.0,r,s);
			r=r+5.0;
		}
	}

	//Ecriture facteurs axes y et noms axes ordonnes
	//Toujours fonteD
	m_pDC->SetTextAlign(TA_BASELINE);							
	r=ya-5.0;
	for (k=0;k<6;k++)
	{
		if (iD_Axes[1][k]!=-1)
		{
			m_pDC->SetTextColor(cc[k]);
			s.Format("%s*%5.0e",iN_Axes[1][k],1/facty);
			TextOut(3.0,r,s);
			r=r-5.0;
		}
	}
	//Trac graphe                    
  plumeX.CreatePen(PS_SOLID,(int)(0.30*m_ech),cc[0]);
  plumeY.CreatePen(PS_SOLID,(int)(0.30*m_ech),cc[1]);
  plumeM.CreatePen(PS_SOLID,(int)(0.30*m_ech),cc[2]);
  plumeR.CreatePen(PS_SOLID,(int)(0.30*m_ech),cc[3]);
  plumeI.CreatePen(PS_SOLID,(int)(0.30*m_ech),cc[4]);
  plumeJ.CreatePen(PS_SOLID,(int)(0.30*m_ech),cc[5]);

	for (k=0;k<6;k++)
	{
		if (iD_Axes[0][k]!=-1 && iD_Axes[1][k]!=-1)
		{
			for (i=1;i<Nb;i++)
			{
				xd=m_pDoc->m_fT[i-1][iD_Axes[0][k]];
				yd=m_pDoc->m_fT[i-1][iD_Axes[1][k]];
				xa=m_pDoc->m_fT[i][iD_Axes[0][k]];
				ya=m_pDoc->m_fT[i][iD_Axes[1][k]];
				if (xd>m_fZoomXmi && yd>m_fZoomYmi && xa<m_fZoomXma && ya<m_fZoomYma)
				{
					xd=(xd-xori)*echx;
					yd=(yd-yori)*echy;
					xa=(xa-xori)*echx;
					ya=(ya-yori)*echy;
					switch (k)
					{
						case 0:
							m_pDC->SelectObject(&plumeX);        
						break;
						case 1:
							m_pDC->SelectObject(&plumeY);        
						break;
						case 2:
							m_pDC->SelectObject(&plumeM);        
						break;
						case 3:
							m_pDC->SelectObject(&plumeR);        
						break;
						case 4:
							m_pDC->SelectObject(&plumeI);        
						break;
						case 5:
							m_pDC->SelectObject(&plumeJ);        
						break;
					}
					if ((xd>xmi+5)&&(xd<xma-5)&&(yd>ymi+5)&&(yd<yma-5)&&(xa>xmi+5)&&(xa<xma-5)&&(ya>ymi+5)&&(ya<yma-5))
					{
						Line(xd,yd,xa,ya);
					}
				}
			}
		}
	}

	m_pDC->SelectObject(m_pOldPen);        
	plumeX.DeleteObject();        
	plumeY.DeleteObject();        
	plumeM.DeleteObject();        
	plumeR.DeleteObject();        
	plumeI.DeleteObject();        
	plumeJ.DeleteObject();        
	plumeC.DeleteObject();        
	plumeD.DeleteObject();                          
	m_pDC->SelectObject(m_pOldFont);        
	fntC.DeleteObject();
	fntD.DeleteObject();
	m_pDC->SetTextColor(clrOld);
	return 0;
} 
//__________________________________________________
//Nouveau 20/12/02: Nb. colonnes du graphe  spcifier dans NbCol...
//Nouveau 20/12/02: type&1 -> 0: Nuage de points, 1:barres
//									type&2 -> 0: Couleur standard, 2: couleur lambda
/*
short CDessin::Graphe(short type)
{    
	const short NbCol=5;//Doit tre compris dans [2,10] 
  CPen 
  	plumeC,       
  	plumeD,
  	plume[NbCol],
  	*m_pOldPen;
	CFont 
		fntC,  
		fntD,
		*m_pOldFont;
	COLORREF clrOld;	
  short
  	i,j,k,
		nb[NbCol]; 
  float
  	r,
  	x,y,xd,yd,xa,ya,
		xmin=1e10,ymin=1e10,xmax=-1e10,ymax=-1e10,
		larg,haut,  //Dimensions de la fenetre
		pasx,pasy;	
	long
		cc[NbCol];	
	CString	s;	             
	BOOL ok;		
	for (j=0;j<NbCol;j++)
	{	
		nb[j]=0;
		//cc[j]=RGB(j*127,j*63,j*200);
	}
	cc[0]=RGB(255,0,0);cc[1]=RGB(0,0,255);cc[2]=RGB(0,255,0);cc[3]=RGB(61,190,200);cc[4]=RGB(192,58,203);
	cc[5]=RGB(213,217,45);cc[6]=RGB(237,104,24);cc[7]=RGB(169,92,164);cc[8]=RGB(128,0,0);cc[9]=RGB(0,0,128);
	for(i=0;i<Nb;i++)
	{                    
		for (j=0;j<NbCol;j++)
		{
			//Absisses
			if (iD_Axes[0][j]!=-1 && iD_Axes[1][j]!=-1) 
			{
				//Ce couple abs/ord est  tracer
				if (m_pDoc->m_fT[i][iD_Axes[0][j]]>m_fZoomXmi && m_pDoc->m_fT[i][iD_Axes[0][j]]<m_fZoomXma && m_pDoc->m_fT[i][iD_Axes[1][j]]>m_fZoomYmi && m_pDoc->m_fT[i][iD_Axes[1][j]]<m_fZoomYma) 
				{
					if (m_pDoc->m_fT[i][iD_Axes[0][j]]<xmin) xmin=m_pDoc->m_fT[i][iD_Axes[0][j]];
					if (m_pDoc->m_fT[i][iD_Axes[0][j]]>xmax) xmax=m_pDoc->m_fT[i][iD_Axes[0][j]];
					if (m_pDoc->m_fT[i][iD_Axes[1][j]]<ymin) ymin=m_pDoc->m_fT[i][iD_Axes[1][j]];
					if (m_pDoc->m_fT[i][iD_Axes[1][j]]>ymax) ymax=m_pDoc->m_fT[i][iD_Axes[1][j]];
					nb[j]++;
				}
			}
		}
	}
	ok=FALSE;
	for (k=0;k<NbCol;k++)
	{
		if (iD_Axes[0][k]!=-1 && iD_Axes[1][k]!=-1 && nb[k]>=2) ok=TRUE;
	}
	if (!ok) return 1;
	//Calcul des chelles, prvoir ventuellement une marge...
	larg=xma-xmi;
	haut=yma-ymi;
  //Si les valeurs sont constantes
	if (fabs(ymax-ymin)<1e-8)
	{
		ymax=(float)(ymax+0.01);
		ymin=(float)(ymin-0.01);
	}
	if (fabs(xmax-xmin)<1e-8)
	{
		xmax=(float)(xmax+0.01);
		xmin=(float)(xmin-0.01);
	}                                
	echx=(larg-70)/(xmax-xmin);                    
	echy=(haut-70)/(ymax-ymin);
	if (type &4)
	{
		if (echx<echy) echy=echx; else echx=echy;
	}
	//Calcul pasx
	pasx=1e-10;
	do
	{
		pasx=pasx*10;
	}                              
	while	(echx*pasx<=1);
	pasx=pasx*5;


	//Calcul pasy
	pasy=1e-10;
	do
	{
		pasy=pasy*10;
	}           
	while	(echy*pasy<=1);		
	pasy=pasy*10;
	//Rajustement en fonction du nombre de divisions de l'axe
	i=(int)((xmax-xmin)/pasx);
	if (i<=2) pasx=pasx/4;
	else
	if (i<=5) pasx=pasx/2;
	if (i>12) pasx=pasx*2;

	j=(int)((ymax-ymin)/pasy);
	if (j<=2) pasy=pasy/4;
	else
	if (j<=5) pasy=pasy/2;
	//Recherche facteurs axes x et y
	if (fabs(xmin)>fabs(xmax))
		x=xmin;
	else
		x=xmax;
	if (x!=0)
	{
		factx=1e-10;
		do
		{
			factx=factx*10;
		}
		while (fabs(x*factx)<1);	
	}	                           
	else
		factx=1;

	if (fabs(ymin)>fabs(ymax))
		y=ymin;
	else
		y=ymax;

	if (y!=0)
	{
		facty=1e-10;
		do
		{
			facty=facty*10;
		}
		while (fabs(y*facty)<1);	
	}	                           
	else
		facty=1;
	//Calcul xori et yori
	xori=0;yori=0;
	if ((xmin<=0) && (xmax>=0))
		xori=0;
	else
	{
		//xori=xmin;	
		if (xmin>0)
		{
			//On encadre dans le sens positif
			xori=0;
			do
			{
				xori=xori+pasx;
			}
			while (xori<xmin);
			xori=xori-pasx;
		}
		else
		{
			//On encadre dans le sens ngatif
			xori=0;
			do
			{
				xori=xori-pasx;
			}
			while (xori>xmin);
			xori=xori+pasx;
		}
	}	
	if ((ymin<=0) && (ymax>=0))
		yori=0;
	else
	{
		if (ymin>0)
		{
			//On encadre dans le sens positif
			yori=0;
			do
			{
				yori=yori+pasy;
			}
			while (yori<ymin);
			yori=yori-pasy;
		}
		else
		{
			//On encadre dans le sens ngatif
			yori=0;
			do
			{
				yori=yori-pasy;
			}
			while (yori>ymin);
			yori=yori+pasy;
		}

  }
	//Dplacement de l'origine de la fenetre graphique    
	if (xori!=0)
		xmi=-40;		
	else
		xmi=xmin*echx-40;		
	xma=xmi+larg;		
	if (yori!=0)
		ymi=-30;		
	else
		ymi=ymin*echy-30;		
	yma=ymi+haut;

	//Rajout le 20/12/02 pour viter graphe en dehors zone de trac...
	echx=echx*0.95;
	echy=echy*0.95;

  //Dcalage axes
  m_pDC->SetWindowOrg((int)(m_ech*xmi),(int)(m_ech*yma));

	fntC.CreateFont((int)(m_ech*m_fHautTexte*0.8),0,0,0,FW_MEDIUM,FALSE,FALSE,FALSE,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,"Arial");
	m_pOldFont=m_pDC->SelectObject(&fntC);	  
	m_pDC->SetTextAlign(TA_LEFT);							
	clrOld=m_pDC->SetTextColor(RGB(0,0,255));
  plumeC.CreatePen(PS_SOLID,(int)(0.20*m_ech),RGB(0,0,0));
	m_pOldPen=m_pDC->SelectObject(&plumeC);        
  Rectangle(xmi,ymi,xma,yma);
	//Dtermination zone de trac
	xa=pasx;
	while(xa*echx<=(xma-5))
	{
		xa=xa+pasx;
	}
	xa=xa-pasx;
	xa=xa*echx;
	
	xd=-pasx;
	while(xd*echx>=(xmi+5))
	{
		xd=xd-pasx;
	}
	xd=xd+pasx;
	xd=xd*echx;
  ya=pasy;
  while (ya*echy<=(yma-5))
  {                        
  	ya=ya+pasy;
  }     
  ya=ya-pasy;                  
  ya=ya*echy;
  yd=-pasy;
  while (yd*echy>=(ymi+5))
  {                        
  	yd=yd-pasy;
  } 
  yd=yd+pasy;
  yd=yd*echy;
  //Cadre autour de la zone 
  Rectangle(xd,yd,xa,ya);

  TextOut((float)(xmi+0.5),(float)(ymi+4.5),"B.K. - Lyce J. Mermoz - 68300 ST.-LOUIS");
	//Date et heure
	CTime t;
	setlocale(LC_TIME,"French");
	t=CTime::GetCurrentTime();   
	s=t.Format("%A, %d %B %Y - %H:%M:%S");
	m_pDC->SetTextAlign(TA_RIGHT);							
	TextOut((float)(xma-1.0),(float)(ymi+4.5),s);
	//Trac des axes  
	Line(xd,0,xa,0);
	Line(0,yd,0,ya);
  plumeD.CreatePen(PS_SOLID,(int)(0*m_ech),RGB(127,127,127));
	m_pDC->SelectObject(&plumeD);        
	fntD.CreateFont((int)(m_ech*m_fHautTexte),0,0,0,FW_MEDIUM,FALSE,FALSE,FALSE,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,"Arial");
	m_pDC->SelectObject(&fntD);	  
	m_pDC->SetTextAlign(TA_CENTER);							
	m_pDC->SetTextColor(RGB(0,0,0));
  //Division axe x
  x=pasx;
  while (x*echx<=(xma-5))
  {           
  	r=x*echx;
  	s.Format("%1.2f",(x+xori)*factx);
  	TextOut(r,-2.5,s);  
  	Line(r,yd,r,-7.00);
  	Line(r,0.0,r,ya);
    x=x+pasx;
  }                   
  x=-pasx;
  while (x*echx>=(xmi+5))
  {           
  	r=x*echx;
  	s.Format("%1.2f",(x+xori)*factx);
  	TextOut(r,-2.5,s);  
  	Line(r,yd,r,-7.00);
  	Line(r,0.0,r,ya);
    x=x-pasx;
  }                      
	//Division axe y
	m_pDC->SetTextAlign(TA_RIGHT);							
	y=0;
	while(y*echy<=(yma-5))
	{          
  	r=y*echy;
  	s.Format("%1.2f",(y+yori)*facty);
  	TextOut(-2.00,(float)(r+2.0),s);  
  	if (xd<-15) Line(xd,r,-10,r);
  	Line(0.0,r,xa,r);
		y=y+pasy;
	}		  
	y=-pasy;
	while(y*echy>=(ymi+5))
	{          
  	r=y*echy;
  	s.Format("%1.2f",(y+yori)*facty);
  	TextOut(-2.00,(float)(r+2.0),s);  
  	if (xd<-15) Line(xd,r,-10,r);
  	Line(0.0,r,xa,r);
		y=y-pasy;
	}		                  
	//Ecriture des chelles
	//Toujours fonteD
	m_pDC->SetTextAlign(TA_BASELINE);							
	s.Format("Echx:%7.2e / Echy:%7.2e",echx,echy);
	TextOut((float)(xd+1.50),(float)(yma-5.00),s);  
	//Ecriture facteurs axes x et noms axes abscisses
	//Toujours fonteD
	m_pDC->SetTextAlign(TA_RIGHT | TA_BOTTOM);							
	r=1.0;          
	for (k=0;k<NbCol;k++)
	{
		if (iD_Axes[0][k]!=-1)
		{
			m_pDC->SetTextColor(cc[k]);
			s.Format("%s*%5.0e",iN_Axes[0][k],1/factx);
			TextOut(xa-1.0,r,s);
			r=r+5.0;
		}
	}
	//Ecriture du titre
	r=ya-5.0;
	m_pDC->SelectObject(&fntD);	  
	//m_pDC->SetTextAlign(TA_CENTER);							
	//TextOut((float)((xmi+xma)/2),(float)(yma-30.0),Titre);  
	m_pDC->SetTextColor(RGB(0,0,0));
	m_pDC->SetTextAlign(TA_BASELINE);							
	TextOut(3.0,r,Titre);  
	//Ecriture facteurs axes y et noms axes ordonnes
	r=r-5.0;
	m_pDC->SelectObject(&fntD);	  
	m_pDC->SetTextAlign(TA_BASELINE);							
	for (k=0;k<NbCol;k++)
	{
		if (iD_Axes[1][k]!=-1)
		{
			m_pDC->SetTextColor(cc[k]);
			s.Format("%s*%5.0e",iN_Axes[1][k],1/facty);
			TextOut(3.0,r,s);
			r=r-5.0;
		}
	}
	//Trac graphe                    
 	for (i=0;i<NbCol;i++)	plume[i].CreatePen(PS_SOLID,(int)(0.48*m_ech),cc[i]);

	for (k=0;k<NbCol;k++)
	{
		if (iD_Axes[0][k]!=-1 && iD_Axes[1][k]!=-1)
		{
			for (i=1;i<Nb;i++)
			{
				xd=m_pDoc->m_fT[i-1][iD_Axes[0][k]];
				yd=m_pDoc->m_fT[i-1][iD_Axes[1][k]];
				xa=m_pDoc->m_fT[i][iD_Axes[0][k]];
				ya=m_pDoc->m_fT[i][iD_Axes[1][k]];
				if (xd>m_fZoomXmi && yd>m_fZoomYmi && xa<m_fZoomXma && ya<m_fZoomYma)
				{
					if ((type&2)!=0)
					{
						
						//Slection de plumes de couleur lambda
						//short lambda=(short)(xa);
						//if (lambda<400) lambda=999;
						//if (lambda>999) lambda=999;
						m_pDC->SelectObject(&(m_pApp->pl[lambda-400]));
						
					}
					else
					{
						//Slection des plumes couleur standard
						m_pDC->SelectObject(&plume[k]);        
					}
					xd=(xd-xori)*echx;
					yd=(yd-yori)*echy;
					xa=(xa-xori)*echx;
					ya=(ya-yori)*echy;
					if ((type&1)!=1)
					{
						//Nuage de points
						if ((xd>xmi+5)&&(xd<xma-5)&&(yd>ymi+5)&&(yd<yma-5)&&(xa>xmi+5)&&(xa<xma-5)&&(ya>ymi+5)&&(ya<yma-5))
							Line(xd,yd,xa,ya);
					}
					else
					{
						//Barres
						if ((xd>xmi+5)&&(xd<xma-5)&&(yd>ymi+5)&&(yd<yma-5)&&(xa>xmi+5)&&(xa<xma-5)&&(ya>ymi+5)&&(ya<yma-5))
						{
							Line(xd-1,0,xd+1,0);LineTo(xd+1,yd);LineTo(xd-1,yd);LineTo(xd-1,0);
							Line(xa-1,0,xa+1,0);LineTo(xa+1,ya);LineTo(xa-1,ya);LineTo(xa-1,0);
						}
					}
				}
			}
		}
	}
	m_pDC->SelectObject(m_pOldPen);        
	for (i=0;i<NbCol;i++)	plume[i].DeleteObject();        
	plumeC.DeleteObject();        
	plumeD.DeleteObject();                          
	m_pDC->SelectObject(m_pOldFont);        
	fntC.DeleteObject();
	fntD.DeleteObject();
	m_pDC->SetTextColor(clrOld);
	return 0;
}
*/ 
//________________________________________ 
void CDessin::Arc1(float xc,float yc,float r,float xd,float yd,float xa,float ya)
{    
 	//Arc dans un rectangle
	float
		xdep,ydep,
		x,y,a,PI=4*atan(1);
	if (xc-r>xd && xc+r<xa && yc-r>yd && yc+r<ya) Circle(xc,yc,r);
	else
	{
		xdep=1e10;ydep=1e10;
		for (a=0;a<=2.1*PI;a=a+2*PI/300)
		{
			x=xc+r*cos(a);
			y=yc+r*sin(a);
			if (x>xd && x<xa && y>yd && y<ya)
			{
				if (xdep!=1e10 && ydep!=1e10)
				{
					Line(xdep,ydep,x,y);
					xdep=x;ydep=y;
				}
				else
				{
					xdep=x;ydep=y;
				}
			}
			else
			{
				xdep=1e10;ydep=1e10;
			}
		}
	}
}
//__________________________________________________
void CDessin::Absisse(short NoGraphe,short Col,CString s)
{
	if (NoGraphe<0 || NoGraphe>10) NoGraphe=0;
	if (Col<0 || Col>=10) Col=0;
	iD_Axes[0][NoGraphe]=Col;
	iN_Axes[0][NoGraphe]=s;
}
//__________________________________________________
void CDessin::Ordonnee(short NoGraphe,short Col,CString s)
{
	if (NoGraphe<0 || NoGraphe>10) NoGraphe=0;
	if (Col<0 || Col>=10) Col=0;
	iD_Axes[1][NoGraphe]=Col;
	iN_Axes[1][NoGraphe]=s;
}
//__________________________________________________
void CDessin::InitZoom(void)
{                       
	m_fZoomXmi=-1e10;
	m_fZoomXma=1e10;
	m_fZoomYmi=-1e10;
	m_fZoomYma=1e10;
}
//__________________________________________________
void CDessin::Zoom(float xmi,float ymi,float xma,float yma)
{                       
	float r;
	if (xmi>xma)
	{
		r=xmi;
		xmi=xma;
		xma=r;
	}
	if (ymi>yma)
	{
		r=ymi;
		ymi=yma;
		yma=r;
	}
	m_fZoomXmi=xmi;
	m_fZoomXma=xma;
	m_fZoomYmi=ymi;
	m_fZoomYma=yma;
}
//__________________________________________________
void CDessin::MarqueDePointageVal(unsigned long coul,float x,float y)
{
	CString s;
	CFont 
		fntD,
		*m_pOldFont;  
	CBrush 
		*m_pOldBrush,
		brosseA,
		brosseB;
	COLORREF clrOld;	

	fntD.CreateFont((int)(m_ech*m_fHautTexte*0.85),0,0,0,FW_MEDIUM,FALSE,FALSE,FALSE,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,"Arial");
	m_pOldFont=m_pDC->SelectObject(&fntD);	  
	m_pDC->SetTextAlign(TA_CENTER|TA_BOTTOM);							
	clrOld=m_pDC->SetTextColor(coul);
 	s.Format("%1.3f, %1.3f",x,y);

	x=x/factx;
	y=y/facty;
	x=(x-xori)*echx;
	y=(y-yori)*echy;
 	TextOut(x,y+1.5,s);

	brosseA.CreateSolidBrush(RGB(255,255,255));
	brosseB.CreateSolidBrush(coul);
	m_pOldBrush=m_pDC->SelectObject(&brosseA);
	Rectangle(x-0.8,y-0.8,x+0.8,y+0.8);
	m_pDC->SelectObject(&brosseB);
	Rectangle(x-0.6,y-0.6,x+0.6,y+0.6);

	m_pDC->SelectObject(m_pOldBrush);
	brosseA.DeleteObject();
	brosseB.DeleteObject();
	m_pDC->SelectObject(m_pOldFont);
	fntD.DeleteObject();                   
	m_pDC->SetTextColor(clrOld);
}
//__________________________________________________
void CDessin::MarqueDePointageValPol(unsigned long coul,float x,float y)
{
	CString s;
	CFont 
		fntD,
		*m_pOldFont;  
	CBrush 
		*m_pOldBrush,
		brosseA,
		brosseB;
	COLORREF clrOld;
	float r,a;
	class CGeoAna geo;

	r=pow(x*x+y*y,0.5);
	
	a=180*geo.atan3(y,x)/3.1415;
	if (a>180) a=a-360;
	else
	if (a<-180) a=a+360;

	fntD.CreateFont((int)(m_ech*m_fHautTexte*0.85),0,0,0,FW_MEDIUM,FALSE,FALSE,FALSE,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,"Arial");
	m_pOldFont=m_pDC->SelectObject(&fntD);	  
	m_pDC->SetTextAlign(TA_CENTER|TA_BOTTOM);							
	clrOld=m_pDC->SetTextColor(coul);
 	s.Format("%1.3f < %1.3f",r,a);

	x=x/factx;
	y=y/facty;
	x=(x-xori)*echx;
	y=(y-yori)*echy;
 	TextOut(x,y+1.5,s);

	brosseA.CreateSolidBrush(RGB(255,255,255));
	brosseB.CreateSolidBrush(coul);
	m_pOldBrush=m_pDC->SelectObject(&brosseA);
	Rectangle(x-0.8,y-0.8,x+0.8,y+0.8);
	m_pDC->SelectObject(&brosseB);
	Rectangle(x-0.6,y-0.6,x+0.6,y+0.6);

	m_pDC->SelectObject(m_pOldBrush);
	brosseA.DeleteObject();
	brosseB.DeleteObject();
	m_pDC->SelectObject(m_pOldFont);
	fntD.DeleteObject();                   
	m_pDC->SetTextColor(clrOld);
}
//__________________________________________________
void CDessin::EcritInfo(float f_x,float f_y,CStringArray *p_sTab,long coul)
{
	CFont 
		fntI,
		*m_pOldFont;
	COLORREF clrOld;
			
	fntI.CreateFont((int)(m_ech*m_fHautTexte),0,0,0,FW_MEDIUM,FALSE,FALSE,FALSE,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,"Arial");
	m_pOldFont=m_pDC->SelectObject(&fntI);	  
	m_pDC->SetTextAlign(TA_BASELINE);							
	clrOld=m_pDC->SetTextColor(coul);
	//Dtermination de l'interLine
	TEXTMETRIC tm;
	m_pDC->GetTextMetrics(&tm);
	int nCyInterval=tm.tmHeight+tm.tmExternalLeading;    

  char s[80];	
  int y=(int)(f_y*m_ech);
  for (int i=0;i<p_sTab->GetSize();i++)
  {
   	sprintf(s,"%s",p_sTab->GetAt(i));
		m_pDC->TextOut((int)(f_x*m_ech),y,s);     
   	y=y-nCyInterval;   
  }
	m_pDC->SelectObject(m_pOldFont);	  
  fntI.DeleteObject();            
  m_pDC->SetTextColor(clrOld);
}
//__________________________________________________
void CDessin::TraceDMC(int no,float a,float b)
{
	CFont 
		fntD,
		*m_pOldFont;  
	COLORREF clrOld;
	class CGeoAna geo;	
	float 
		xd,yd,xa,ya,a1,b1,
		M_PI=3.14159;
	char s[60];	
  
  if (a!=1e10 && b!=1e10)
  {
  	b1=(b-yori)*echy;
		a1=a*echy/echx;
		geo.p2d(-xori*echx,b1,atan(a1),xmi+5,0,M_PI/2,&xd,&yd);
		if (yd>yma-5)	
			geo.p2d(-xori*echx,b1,atan(a1),0,yma-5,0,&xd,&yd);
		else
		if (yd<ymi+5)	
			geo.p2d(-xori*echx,b1,atan(a1),0,ymi+5,0,&xd,&yd);
  
  	geo.p2d(-xori*echx,b1,atan(a1),xma-5,0,M_PI/2,&xa,&ya);
		if (ya>yma-5) 	
			geo.p2d(-xori*echx,b1,atan(a1),0,yma-5,0,&xa,&ya);
		else
		if (ya<ymi+5) 
			geo.p2d(-xori*echx,b1,atan(a1),0,ymi+5,0,&xa,&ya);

  	Line((float)(xd),(float)(yd),(float)(xa),(float)(ya));
  	//Ecriture n DMC
		fntD.CreateFont((int)(m_ech*m_fHautTexte),0,0,0,FW_MEDIUM,FALSE,FALSE,FALSE,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,"Arial");
		m_pOldFont=m_pDC->SelectObject(&fntD);	  
		m_pDC->SetTextAlign(TA_RIGHT | TA_BOTTOM);							
		//m_pDC->SetTextAlign(TA_BASELINE);							
		clrOld=m_pDC->SetTextColor(RGB(0,0,0));

  	sprintf(s,"(%d)",no);
  	TextOut((float)(xd),(float)(yd),s);
  	TextOut((float)(xa),(float)(ya),s);
  	//Ecriture quation
  	sprintf(s,"DMC %d: y=%1.3ex%-+1.3e",no,a,b);
  	TextOut(xma-1,(float)(yma-6-(m_fHautTexte+0.5)*no),s);

		m_pDC->SelectObject(m_pOldFont);
		fntD.DeleteObject();                   
		m_pDC->SetTextColor(clrOld);
	}					
}
//__________________________________________________
void CDessin::TraceReg(int no,class CRegres *pr)
{
	CFont 
		fntD,
		*m_pOldFont;  
	COLORREF clrOld;	
	double 
		x,y,
		xd,yd,xa,ya,
		M_PI=3.14159;
	short i;
	CString s;	
	CPen
  	plumeR,
  	*m_pOldPen;
  
	fntD.CreateFont((int)(m_ech*m_fHautTexte),0,0,0,FW_MEDIUM,FALSE,FALSE,FALSE,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,"Arial");
	m_pOldFont=m_pDC->SelectObject(&fntD);	  
	m_pDC->SetTextAlign(TA_BASELINE);							
	clrOld=m_pDC->SetTextColor(RGB(0,0,255));
  plumeR.CreatePen(PS_SOLID,(int)(0.40*m_ech),RGB(0,0,0));
	m_pOldPen=m_pDC->SelectObject(&plumeR);        

	//Trac de la rgression polynomiale	
	if (pr->m_fP1[no][0]>pr->m_fP2[no][0])
	{
		//Inversion
		x=pr->m_fP1[no][0];pr->m_fP1[no][0]=pr->m_fP2[no][0];pr->m_fP2[no][0]=x;
		y=pr->m_fP1[no][1];pr->m_fP1[no][1]=pr->m_fP2[no][1];pr->m_fP2[no][1]=y;
	}
	for (x=pr->m_fP1[no][0];x<=pr->m_fP2[no][0];x=x+0.002*(pr->m_fP2[no][0]-pr->m_fP1[no][0]))
	{
		y=pr->m_fa[no][7]*pow(x,7)+pr->m_fa[no][6]*pow(x,6)+pr->m_fa[no][5]*pow(x,5)+pr->m_fa[no][4]*pow(x,4)+pr->m_fa[no][3]*pow(x,3)+pr->m_fa[no][2]*pow(x,2)+pr->m_fa[no][1]*x+pr->m_fa[no][0];
		xa=(x-xori)*echx;
		ya=(y-yori)*echy;
		if ((x!=pr->m_fP1[no][0]) && (xd>xmi+5) && (xd<xma-5) && (yd>ymi+5) && (yd<yma-5) && (xa>xmi+5) && (xa<xma-5) && (ya>ymi+5) && (ya<yma-5))
		{
			Line((float)(xd),(float)(yd),(float)(xa),(float)(ya));
		}
		
		xd=xa;yd=ya;
	}
	//Ecriture des coefficients
	for (i=0;i<8;i++)
	{
 		if (pr->m_fa[no][i]!=1e10 && pr->m_fa[no][i]!=0)
		{
			s.Format("a%d[%d]=%12.3e",i,no,pr->m_fa[no][i]);
 			TextOut(xma-50*(no+1),(float)(yma-6-(m_fHautTexte+0.5)*i),s);
		}
	}
	m_pDC->SelectObject(m_pOldPen);        
	plumeR.DeleteObject();        
	m_pDC->SelectObject(m_pOldFont);
	fntD.DeleteObject();                   
	m_pDC->SetTextColor(clrOld);
}
//__________________________________________________
void CDessin::MarqueDePointage(unsigned long coul,float x,float y)
{
	CBrush 
		*m_pOldBrush,
		brosseA,
		brosseB;

	//x=x/factx;
	//y=y/facty;
	x=(x-xori)*echx;
	y=(y-yori)*echy;
	brosseA.CreateSolidBrush(RGB(255,255,255));
	brosseB.CreateSolidBrush(coul);
	m_pOldBrush=m_pDC->SelectObject(&brosseA);
	Rectangle(x-0.8,y-0.8,x+0.8,y+0.8);
	m_pDC->SelectObject(&brosseB);
	Rectangle(x-0.6,y-0.6,x+0.6,y+0.6);
	m_pDC->SelectObject(m_pOldBrush);
	brosseA.DeleteObject();
	brosseB.DeleteObject();
}
