// EuroParaDlg.cpp : implementation file
#include "stdafx.h"
#include "Bk.h"
#include "EuroParaDlg.h"
//#include "EurosmartDX.h"
#include "Eurosmart.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CEuroParaDlg dialog
CEuroParaDlg::CEuroParaDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEuroParaDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEuroParaDlg)
	m_s1 = _T("");
	m_radioTypeAcq = -1;
	//}}AFX_DATA_INIT
}
//________________________________________
void CEuroParaDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEuroParaDlg)
	DDX_Control(pDX, IDTEST, m_btnTest);
	DDX_Control(pDX, IDCANCEL, m_btnCancel);
	DDX_Control(pDX, IDC_VOIE, m_comboVoie);
	DDX_Control(pDX, IDC_MOY, m_comboMoy);
	DDX_Text(pDX, IDC_STATIC1, m_s1);
	DDX_Radio(pDX, IDC_TYPE_ACQ, m_radioTypeAcq);
	//}}AFX_DATA_MAP
}
//________________________________________
BEGIN_MESSAGE_MAP(CEuroParaDlg, CDialog)
	//{{AFX_MSG_MAP(CEuroParaDlg)
	ON_BN_CLICKED(IDTEST, OnTest)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CEuroParaDlg message handlers
BOOL CEuroParaDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	CString s;
	short i;
	m_pApp=((CBkApp*)AfxGetApp());
	for (i=0;i<8;i++)
	{
		s.Format("Voie %d",i);
		m_comboVoie.AddString(s);
	}
	m_comboVoie.GetLBText(m_pApp->m_iVoie,s);
	m_comboVoie.SetWindowText(s);	

	for (i=0;i<11;i++)
	{
		s.Format("%d",(short)pow(2,i));
		m_comboMoy.AddString(s);
	}
	m_comboMoy.GetLBText(m_pApp->m_iMoy,s);
	m_comboMoy.SetWindowText(s);
	m_radioTypeAcq=m_pApp->m_radioTypeAcq;
	//m_pEuro=new CEurosmartDX(); //DriverX
	m_pEuro=new CEurosmart();			//PortIO
	if (!m_pEuro->Connect())
	{
		//Erreur de connexion  DriverX
		//m_s1.Format("Erreur de connexion  DriverX !");
		//Erreur de connexion  PortIO
		m_s1.Format("Carte Eurosmart PC-MES3 non trouve !");
		m_btnTest.EnableWindow(FALSE);
		m_pApp->m_iCarte=0;
	}
	else
	if (!m_pEuro->OKCarte())
	{
		//Carte non prsente
		m_s1.Format("Carte Eurosmart PC-MES3 non trouve !");
		m_btnTest.EnableWindow(FALSE);
		m_pApp->m_iCarte=0;
	}
	else
	{
		m_s1.Format("Carte Eurosmart PC-MES3 OK...");
	}
	m_OK=FALSE;
	UpdateData(FALSE);
	return TRUE;
}
//________________________________________
void CEuroParaDlg::OnOK() 
{
	//CDialog::OnOK();
}
//________________________________________
void CEuroParaDlg::OnCancel() 
{
	MAJ();
	delete m_pEuro;
	CDialog::OnCancel();
}
//________________________________________
void CEuroParaDlg::OnTest() 
{
	if (!m_OK)
	{
		//Test
		MAJ();
		m_btnTest.SetWindowText("&Arrter");
		m_OKBusy=FALSE;SetTimer(1,50,NULL);
	}
	else
	{
		//Arrter
		KillTimer(1);
		m_btnTest.SetWindowText("&Tester");
	}

	m_btnCancel.EnableWindow(m_OK);
	GetDlgItem(IDC_TYPE_ACQ)->EnableWindow(m_OK);
	GetDlgItem(IDC_TYPE_ACQ2)->EnableWindow(m_OK);
	GetDlgItem(IDC_VOIE)->EnableWindow(m_OK);
	GetDlgItem(IDC_MOY)->EnableWindow(m_OK);

	m_OK=!m_OK;
}
//________________________________________
void CEuroParaDlg::OnTimer(UINT nIDEvent) 
{
	short moy;
	char c;
	float u;
	if (!m_OKBusy)
	{
		m_OKBusy=TRUE;
		moy=(short)pow(2,m_pApp->m_iMoy);
		if (m_radioTypeAcq==0) c='U'; else c='B';
		u=m_pEuro->LitTension(m_pApp->m_iVoie,m_radioTypeAcq,moy);
		if (u!=1e10)
			m_s1.Format("Acq. en cours:\nU[%d][%d][%c] (V) : %8.3f",m_pApp->m_iVoie,moy,c,u);
		else
			m_s1.Format("Acq. en cours:\nU[%d][%d][%c] (V) : ?",m_pApp->m_iVoie,moy,c);
		UpdateData(FALSE);
		m_OKBusy=FALSE;
	}	
	CDialog::OnTimer(nIDEvent);
}
//________________________________________
void CEuroParaDlg::MAJ() 
{
	UpdateData(TRUE);
	m_pApp->m_radioTypeAcq=m_radioTypeAcq;
	if (m_comboVoie.GetCurSel()<0)
	{
		//Pas touch au combo
	}
	else
		m_pApp->m_iVoie=m_comboVoie.GetCurSel();

	if (m_comboMoy.GetCurSel()<0)
	{
		//Pas touch au combo
	}
	else
		m_pApp->m_iMoy=m_comboMoy.GetCurSel();
}
