// MainFrm.cpp : implementation of the CMainFrame class
#include "stdafx.h"
#include "Bk.h"
#include "MainFrm.h"
#include "BkDoc.h"
#include "BkView.h"
#include "Regres.h"
#include "RegDlg.h"
#include "EuroParaDlg.h"
#include "CandParaDlg.h"
#include "SysamDlg.h"
#include "MesDlg.h"
#include "DepDlg.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
// CMainFrame
IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_GRAPHE_FONCTION1, OnGrapheFonction1)
	ON_UPDATE_COMMAND_UI(ID_REGRESSION, OnUpdateRegression)
	ON_COMMAND(ID_REGRESSION, OnRegression)
	ON_UPDATE_COMMAND_UI(ID_FICHIER_EXCEL, OnUpdateFichierExcel)
	ON_COMMAND(ID_FICHIER_EXCEL, OnFichierExcel)
	ON_UPDATE_COMMAND_UI(ID_CANDIBUS, OnUpdateCandibus)
	ON_COMMAND(ID_CANDIBUS, OnCandibus)
	ON_UPDATE_COMMAND_UI(ID_EUROSMART, OnUpdateEurosmart)
	ON_COMMAND(ID_EUROSMART, OnEurosmart)
	ON_UPDATE_COMMAND_UI(ID_PARA_TEST, OnUpdateParaTest)
	ON_COMMAND(ID_PARA_TEST, OnParaTest)
	ON_UPDATE_COMMAND_UI(ID_ACQ_AUCUNE, OnUpdateAcqAucune)
	ON_COMMAND(ID_ACQ_AUCUNE, OnAcqAucune)
	ON_COMMAND(ID_MES_ACQ, OnMesAcq)
	ON_UPDATE_COMMAND_UI(ID_SYSAMPCI, OnUpdateSysampci)
	ON_COMMAND(ID_SYSAMPCI, OnSysampci)
	ON_COMMAND(ID_DEP_MANU, OnDepManu)
	ON_COMMAND(ID_GRAPHE_FONCTION4, OnGrapheFonction4)
	ON_COMMAND(ID_GRAPHE_FONCTION5, OnGrapheFonction5)
	ON_UPDATE_COMMAND_UI(ID_GRAPHE_FONCTION1, OnUpdateGrapheFonction1)
	ON_UPDATE_COMMAND_UI(ID_GRAPHE_FONCTION4, OnUpdateGrapheFonction4)
	ON_UPDATE_COMMAND_UI(ID_GRAPHE_FONCTION5, OnUpdateGrapheFonction5)
	//}}AFX_MSG_MAP
	// Global help commands
	ON_COMMAND(ID_HELP_FINDER, CFrameWnd::OnHelpFinder)
	ON_COMMAND(ID_HELP, CFrameWnd::OnHelp)
	ON_COMMAND(ID_CONTEXT_HELP, CFrameWnd::OnContextHelp)
	ON_COMMAND(ID_DEFAULT_HELP, CFrameWnd::OnHelpFinder)
	ON_UPDATE_COMMAND_UI(ID_BK, OnUpdatePage)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,
	ID_BK,
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	//ID_INDICATOR_SCRL,
};
//////////////////////////////////////////
// CMainFrame construction/destruction
CMainFrame::CMainFrame()
{
}

CMainFrame::~CMainFrame()
{
}
int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	ShowWindow(SW_SHOWMAXIMIZED);
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	return CFrameWnd::PreCreateWindow(cs);
}
//////////////////////////////////////////
// CMainFrame diagnostics
#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG
//////////////////////////////////////////
// CMainFrame message handlers
void CMainFrame::OnUpdatePage(CCmdUI *pCmdUI)
{
	CString 
		str,s,s1;
	class CBkDoc* pDoc=NULL;
	float a,x,y,x1,y1;
	m_pApp=((CBkApp*)AfxGetApp());
	CBkView *pView;

	if (AfxGetApp()->m_pMainWnd)
	{
		CFrameWnd *pFrame=(CFrameWnd *)(AfxGetApp()->m_pMainWnd);
		pDoc=(CBkDoc*)pFrame->GetActiveDocument();
		pView=(CBkView*)pFrame->GetActiveView();
	}
	m_wndStatusBar.SetPaneInfo(1,ID_BK,/*SBPS_STRETCH*//*SBPS_POPOUT*/SBPS_NORMAL,250);		
	if (pDoc!=NULL)
	{
		pView->PIX_FEN(pDoc->m_iX,pDoc->m_iY,&x,&y);
		pView->FEN_GR(x,y,&x,&y);
		pView->PIX_FEN(pDoc->m_iDx,pDoc->m_iDy,&x1,&y1);
		pView->FEN_GR(x1,y1,&x1,&y1);

		//Coordonnes absolues
		if (pDoc->m_iDx==0)
		{
			if (pDoc->m_iTypeGr>=0)
			{
				//Coordonnes cartsiennes
				s.Format("X:%1.3f",x);
				s1.Format("Y:%1.3f",y);
			}
			else
			{
				//Coordonnes polaires
				a=180*atan3(y,x)/3.1415;
				if (a>180) a=a-360;
				else
				if (a<-180) a=a+360;
				s.Format("R:%1.3f",pow(x*x+y*y,0.5));
				s1.Format("a():%1.3f",a);
			}
		}
		else
		{
			//Coordonnes relatives
			if (pDoc->m_iTypeGr>=0)
			{
				//Cartsien
				s.Format("dX:%1.3f",x-x1);
				s1.Format("dY:%1.3f",y-y1);
			}
			else
			{
				//Polaire
				s.Format("dR:%1.3f",pow(x*x+y*y,0.5)-pow(x1*x1+y1*y1,0.5));
				a=180*(atan3(y,x)-atan3(y1,x1))/3.1415;
				if (a>180) a=a-360;
				else
				if (a<-180) a=a+360;

				s1.Format("da():%1.3f",a);
			}
		}
		str.Format("%s, %s",s,s1); 
		pCmdUI->SetText(str);
	}
}
//________________________________________
float CMainFrame::atan3(float n,float d)
{
	float r;
	if (fabs(d)<1e-8)
		r=0;
	else
	{
		r=atan(n/d);
		if (n>0)
		{
			//Numrateur positif
			if (r>0)
			{
				//Tangente positive et numrateur positif: 1er quadrant
			}
			else
			{
				//Tangente ngative et numrateur positif: 2me quadrant
				r=r+3.1415;
			}
		}
		else
		{
			//Numrateur ngatif
			if (r>0)
			{
				//Tangente positive et numrateur ngatif: 3me quadrant
				r=r+3.1445;
			}
			else
			{
				//Tangente ngative et numrateur ngatif: 4me quadrant
				r=r+6.28;
			}

		}
	}
	return r;
}
//________________________________________
void CMainFrame::OnUpdateGrapheFonction1(CCmdUI* pCmdUI) 
{
	class CBkDoc* pDoc=NULL;
	if (AfxGetApp()->m_pMainWnd)
	{
		CFrameWnd *pFrame=(CFrameWnd *)(AfxGetApp()->m_pMainWnd);
		pDoc=(CBkDoc*)pFrame->GetActiveDocument();
		if (pDoc->m_iTypeGr==0) pCmdUI->SetCheck(TRUE); else pCmdUI->SetCheck(FALSE);
	}	
}
//________________________________________
void CMainFrame::OnUpdateGrapheFonction4(CCmdUI* pCmdUI) 
{
	class CBkDoc* pDoc=NULL;
	if (AfxGetApp()->m_pMainWnd)
	{
		CFrameWnd *pFrame=(CFrameWnd *)(AfxGetApp()->m_pMainWnd);
		pDoc=(CBkDoc*)pFrame->GetActiveDocument();
		if (pDoc->m_iTypeGr==1) pCmdUI->SetCheck(TRUE); else pCmdUI->SetCheck(FALSE);
	}	
	
}
//________________________________________
void CMainFrame::OnUpdateGrapheFonction5(CCmdUI* pCmdUI) 
{
	class CBkDoc* pDoc=NULL;
	if (AfxGetApp()->m_pMainWnd)
	{
		CFrameWnd *pFrame=(CFrameWnd *)(AfxGetApp()->m_pMainWnd);
		pDoc=(CBkDoc*)pFrame->GetActiveDocument();
		if (pDoc->m_iTypeGr==2) pCmdUI->SetCheck(TRUE); else pCmdUI->SetCheck(FALSE);
	}	
}
//________________________________________
void CMainFrame::OnGrapheFonction1() 
{
	//Linarit suivant x	
	class CBkDoc* pDoc=NULL;
	if (AfxGetApp()->m_pMainWnd)
	{
		CFrameWnd *pFrame=(CFrameWnd *)(AfxGetApp()->m_pMainWnd);
		pDoc=(CBkDoc*)pFrame->GetActiveDocument();
		pDoc->m_iTypeGr=0;
		pDoc->UpdateAllViews(NULL);
	}
	/*
	if (pDoc!=NULL)
	{
		float x,y,t,PI=4*atan(1);
		short n;
		pDoc->m_iTypeGr=0;
		n=0;
		pDoc->Init_m_fT();
		for (t=0;t<=2*PI;t=t+2*PI/500)
		{
			x=3*pow(cos(t),3);
			y=3*pow(sin(t),3);
			pDoc->m_fT[n][0]=x;
			pDoc->m_fT[n][1]=y;
			n++;
		}
		pDoc->m_iNb=n;
		//Annulation rgressions
		for (n=0;n<3;n++) pDoc->m_pReg->m_OKTrace[n]=FALSE;
		//Annulation coordonnes relatives
		pDoc->m_iDx=pDoc->m_iDy=0;
		//Annulation zoom
		//InitZoom();
		pDoc->UpdateAllViews(NULL);
	}
	*/
}
//________________________________________
void CMainFrame::OnGrapheFonction4() 
{
	//Suivant y	
	class CBkDoc* pDoc=NULL;
	if (AfxGetApp()->m_pMainWnd)
	{
		CFrameWnd *pFrame=(CFrameWnd *)(AfxGetApp()->m_pMainWnd);
		pDoc=(CBkDoc*)pFrame->GetActiveDocument();
		pDoc->m_iTypeGr=1;
		pDoc->UpdateAllViews(NULL);
	}
}
//________________________________________
void CMainFrame::OnGrapheFonction5() 
{
	//Suivant x et y	
	class CBkDoc* pDoc=NULL;
	if (AfxGetApp()->m_pMainWnd)
	{
		CFrameWnd *pFrame=(CFrameWnd *)(AfxGetApp()->m_pMainWnd);
		pDoc=(CBkDoc*)pFrame->GetActiveDocument();
		pDoc->m_iTypeGr=2;
		pDoc->UpdateAllViews(NULL);
	}
}
//________________________________________
void CMainFrame::OnUpdateRegression(CCmdUI* pCmdUI) 
{
	if (m_pApp->m_pRegDlg!=NULL) pCmdUI->Enable(FALSE);
}
//________________________________________
void CMainFrame::OnRegression() 
{
	if (m_pApp->m_pRegDlg==NULL)	
	{
		m_pApp->m_pRegDlg=new CRegDlg(this);
	}
}
//________________________________________
void CMainFrame::OnUpdateFichierExcel(CCmdUI* pCmdUI) 
{
	class CBkDoc* pDoc=NULL;
	CFrameWnd *pFrame=(CFrameWnd *)(AfxGetApp()->m_pMainWnd);
	pDoc=(CBkDoc*)pFrame->GetActiveDocument();
	if (pDoc->m_iNb==0) pCmdUI->Enable(FALSE);
}
//________________________________________
void CMainFrame::OnFichierExcel() 
{
	//IMPORTANT: Voir CBkApp::InitInstance() et stdafx.h
	//Voir AfxOleInit()	dans Bk.cpp
	m_pApp=((CBkApp*)AfxGetApp());
	m_pAppli=new _Application();
	EcritureExcel();
	delete m_pAppli;
}
//________________________________________
void CMainFrame::EcritureExcel(void) 
{	
	class CBkDoc* pDoc;
	CFrameWnd *pFrame=(CFrameWnd *)(AfxGetApp()->m_pMainWnd);
	pDoc=(CBkDoc*)pFrame->GetActiveDocument();
	
	if (pDoc!=NULL)
	{
		CString s1,s2,s3,s4,s5;
		Range range,range1,range2,range3,range4,range5;
		Workbooks books;
		_Workbook book;
		Worksheets sheets;
		_Worksheet sheet;

		COleVariant 
			covTrue((short)TRUE),
			covFalse((short)FALSE),
			covOptional((long)DISP_E_PARAMNOTFOUND,VT_ERROR);
		if (!m_pAppli->CreateDispatch("Excel.Application"))
		{
			AfxMessageBox("Erreur de dmarrage Excel");
		}
		else
		{
			m_pAppli->SetVisible(TRUE);
			books=m_pAppli->GetWorkbooks();
			book=books.Add(covOptional); 
			sheets=m_pAppli->GetSheets();
			sheet=sheets.GetItem(COleVariant((short)1));
			sheet.SetName("Valeurs");

			range=sheet.GetRange(COleVariant("A1"),COleVariant("A1"));
			range.SetValue(COleVariant("LOGICIEL ?"));

			range1=sheet.GetRange(COleVariant("A2"),COleVariant("A2"));
			range2=sheet.GetRange(COleVariant("B2"),COleVariant("B2"));
			range3=sheet.GetRange(COleVariant("C2"),COleVariant("C2"));
			range4=sheet.GetRange(COleVariant("D2"),COleVariant("D2"));
			range5=sheet.GetRange(COleVariant("E2"),COleVariant("E2"));

			s1=s2=s3=s4=s5="";

			s1="X";
			s2="Y";
			s3="Z";
			s4="U";
			s5="V";
			range1.SetValue(COleVariant(s1));
			range2.SetValue(COleVariant(s2));
			range3.SetValue(COleVariant(s3));
			range4.SetValue(COleVariant(s4));
			range5.SetValue(COleVariant(s5));
			short i,nb;
			i=3;
			for (nb=0;nb<=pDoc->m_iNb;nb++)
			{
				s1.Format("A%u",i);
				range1=sheet.GetRange(COleVariant(s1),COleVariant(s1));
				s2.Format("B%u",i);
				range2=sheet.GetRange(COleVariant(s2),COleVariant(s2));
				s3.Format("C%u",i);
				range3=sheet.GetRange(COleVariant(s3),COleVariant(s3));
				s4.Format("D%u",i);
				range4=sheet.GetRange(COleVariant(s4),COleVariant(s4));
				s5.Format("E%u",i);
				range5=sheet.GetRange(COleVariant(s5),COleVariant(s5));

				s1=s2=s3=s4=s5="";
				if (pDoc->m_fT[nb][0]!=1e10) s1.Format("%1.4f",pDoc->m_fT[nb][0]);
				if (pDoc->m_fT[nb][1]!=1e10) s2.Format("%1.4f",pDoc->m_fT[nb][1]);
				if (pDoc->m_fT[nb][2]!=1e10) s3.Format("%1.4f",pDoc->m_fT[nb][2]);
				if (pDoc->m_fT[nb][3]!=1e10) s4.Format("%1.4f",pDoc->m_fT[nb][3]);
				if (pDoc->m_fT[nb][4]!=1e10) s5.Format("%1.4f",pDoc->m_fT[nb][4]);

				range1.SetValue(COleVariant(s1));
				range2.SetValue(COleVariant(s2));
				range3.SetValue(COleVariant(s3));
				range4.SetValue(COleVariant(s4));
				range5.SetValue(COleVariant(s5));
				i++;
			}
			//Trac des graphes
			/**/
			Charts charts;
			VARIANT v;
			_Chart chart1;
			charts=m_pAppli->GetCharts();
			//Units absisses
			s3="X";
			s4="0.0E+0";
			s5="0.0E+0";
			v=COleVariant((short)(1));//1: Nb. de sheets  ajouter
			chart1=charts.Add(covOptional,covOptional,v);
			chart1.SetVisible(FALSE);
			s1.Format("A2:A%u",pDoc->m_iNb+2);
			s2.Format("B2:B%u",pDoc->m_iNb+2);
			//											Plage de donnes: s1, s2
			//															Titre du graphe: Y=f(X)
			//																								Titre du sheet: Graphe
			//																											Titre axe des absisses: s3
			GrapheExcel(sheet,chart1,s1,s2,"Y=f(X)","Graphe",s3,s4,s5);
			/**/
			//Pour ne pas avoir une demande automatique de sauvegarde...
			book.SetSaved(TRUE);
			
		}
	}
}
//________________________________________
void CMainFrame::GrapheExcel(_Worksheet sheet,_Chart chart,CString plage1,CString plage2,CString titre,CString nom,CString abs,CString FormatX,CString FormatY) 
{
	COleVariant 
		covTrue((short)TRUE),
		covFalse((short)FALSE),
		covOptional((long)DISP_E_PARAMNOTFOUND,VT_ERROR);
	LPDISPATCH pdisp;
	Axis axis;
	TickLabels tick;
	VARIANT v,v1,v2,v3,v4,v5,v6,v7,v8,v9,v10,v11;
	Font fonte;
	PlotArea aire;
	Interior interieur;
	
	pdisp=sheet.GetRange(COleVariant(plage1),COleVariant(plage2));
	v1=COleVariant((short)(2));//Donnes en colonnes
	chart.ApplyCustomType(-4169,covOptional);
	chart.SetSourceData(pdisp,v1);
	v2=COleVariant((long)(-4169));//Nuage de points
	v3=COleVariant((short)(6));//Format: 1: points uniquement, 2:points relis, 4 & 5: chelles log, 6: courbe uniquement,7,8,9: !!
	v4=COleVariant((short)(2));//Donnes en colonnes
	v5=COleVariant((short)(1));//Donnes en colonnes
	v6=COleVariant((short)(1));//Donnes en colonnes
	v7=covTrue;//Avec noms des sries
	v8=COleVariant(titre);
	v9=COleVariant(abs);//Category axis title text.
	v10=covOptional;
	v11=covOptional;
	chart.ChartWizard(covOptional,v2,v3,v4,v5,v6,v7,v8,v9,v10,v11);
	chart.SetName(nom);
	chart.SetVisible(FALSE);
	//Absisse__________________________________________
	v=COleVariant((short)(1));
	axis=chart.Axes(v,1);//Grille absisses
	axis.SetHasMajorGridlines(TRUE);
	tick=axis.GetTickLabels();
	tick.SetNumberFormat(FormatX);//Format division absisse
	//Ordonne_______________________________________
	v=COleVariant((short)(2));
	axis=chart.Axes(v,1);//Grille ordonne
	axis.SetHasMajorGridlines(TRUE);
	fonte=tick.GetFont();
	v=COleVariant((short)(9));
	fonte.SetSize(v);
	tick=axis.GetTickLabels();
	tick.SetNumberFormat(FormatY);//Format division ordonne 
	fonte=tick.GetFont();
	v=COleVariant((short)(9));
	fonte.SetSize(v);
	aire=chart.GetPlotArea();
	interieur=aire.GetInterior();
	//v=COleVariant((long)RGB(220,220,220));//Gris
	//v=COleVariant((long)RGB(255,255,200));//Jaune clair
	v=COleVariant((long)RGB(228,230,189));//Vert clair
	//v=COleVariant((long)RGB(164,223,255));//Bleu clair
	interieur.SetColor(v);
	chart.SetVisible(TRUE);
	chart.Select(covOptional);
}
//________________________________________
void CMainFrame::OnUpdateAcqAucune(CCmdUI* pCmdUI) 
{
	if (m_pApp->m_iCarte==0) pCmdUI->SetCheck(TRUE); else pCmdUI->SetCheck(FALSE);
}
//________________________________________
void CMainFrame::OnAcqAucune() 
{
	m_pApp->m_iCarte=0;
}
//________________________________________
void CMainFrame::OnUpdateCandibus(CCmdUI* pCmdUI) 
{
	if (m_pApp->m_iCarte==1) pCmdUI->SetCheck(TRUE); else pCmdUI->SetCheck(FALSE);
}
//________________________________________
void CMainFrame::OnCandibus() 
{
	m_pApp->m_iCarte=1;
}
//________________________________________
void CMainFrame::OnUpdateEurosmart(CCmdUI* pCmdUI) 
{
	if (m_pApp->m_iCarte==2) pCmdUI->SetCheck(TRUE); else pCmdUI->SetCheck(FALSE);
}
//________________________________________
void CMainFrame::OnEurosmart() 
{
	m_pApp->m_iCarte=2;
}
//________________________________________
void CMainFrame::OnUpdateSysampci(CCmdUI* pCmdUI) 
{
	if (m_pApp->m_iCarte==3) pCmdUI->SetCheck(TRUE); else pCmdUI->SetCheck(FALSE);
}
//________________________________________
void CMainFrame::OnSysampci() 
{
	m_pApp->m_iCarte=3;
}
//________________________________________
void CMainFrame::OnUpdateParaTest(CCmdUI* pCmdUI) 
{
	if (m_pApp->m_iCarte==0) pCmdUI->Enable(FALSE);
}
//________________________________________
void CMainFrame::OnParaTest() 
{
	if (m_pApp->m_iCarte==1)
	{
		//Candibus
		CCandParaDlg d;
		d.DoModal();
	}
	else
	if (m_pApp->m_iCarte==2)
	{
		//Eurosmart
		CEuroParaDlg d;
		d.DoModal();
	}
	else
	if (m_pApp->m_iCarte==3)
	{
		//Sysam
		CSysamDlg d;
		d.DoModal();
	}
}
//________________________________________
void CMainFrame::OnMesAcq() 
{
	CMesDlg d;
	d.DoModal();	
}
//________________________________________
void CMainFrame::OnDepManu() 
{
	CDepDlg d;
	d.DoModal();	
}
