// MesDlg.cpp : implementation file
#include "stdafx.h"
#include "Bk.h"
#include "MesDlg.h"
#include "BkDoc.h"
//#include "EurosmartDX.h"
//#include "CandibusDX.h"
#include "Eurosmart.h"
#include "Candibus.h"
#include "Sysam.h"
#include "MM2000.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CMesDlg dialog
CMesDlg::CMesDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMesDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMesDlg)
	m_s2 = _T("");
	m_radioAxe = -1;
	m_iNbMes = 0;
	m_fLong = 0.0f;
	//}}AFX_DATA_INIT
}
void CMesDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMesDlg)
	DDX_Control(pDX, IDGH, m_btnGH);
	DDX_Control(pDX, IDDH, m_btnDH);
	DDX_Control(pDX, IDMOINS, m_btnMoins);
	DDX_Control(pDX, IDPLUS, m_btnPlus);
	DDX_Control(pDX, IDCANCEL, m_btnCancel);
	DDX_Control(pDX, IDDEMARRER, m_btnDemarrer);
	DDX_Text(pDX, IDC_STATIC2, m_s2);
	DDX_Radio(pDX, IDC_RADIOX, m_radioAxe);
	DDX_Text(pDX, IDC_NB, m_iNbMes);
	DDX_Text(pDX, IDC_COURSE, m_fLong);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CMesDlg, CDialog)
	//{{AFX_MSG_MAP(CMesDlg)
	ON_BN_CLICKED(IDDEMARRER, OnDemarrer)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDMOINS, OnMoins)
	ON_BN_CLICKED(IDPLUS, OnPlus)
	ON_BN_CLICKED(IDDH, OnDh)
	ON_BN_CLICKED(IDGH, OnGh)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CMesDlg message handlers
BOOL CMesDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_pApp=((CBkApp*)AfxGetApp());
	CFrameWnd *pFrame=(CFrameWnd *)(AfxGetApp()->m_pMainWnd);
	m_pDoc=(CBkDoc*)pFrame->GetActiveDocument();
	switch (m_pApp->m_iCarte)
	{
		case 1://Candibus
			//m_pCand=new CCandibusDX();	//DriverX
			m_pCand=new CCandibus();		//PortIO
			m_s2.Format("Carte Candibus slectionne...");
		break;
		case 2://Eurosmart
			//m_pEuro=new CEurosmartDX();	//DriverX
			m_pEuro=new CEurosmart();		//PortIO
			m_s2.Format("Carte Eurosmart PC-MES3 slectionne...");
		break;
		case 3://Sysam
			m_pSys=new CSysam();
			m_s2.Format("Carte Sysam-PCI slectionne...");
		break;
		default://Aucune
			m_s2.Format("Aucune carte A/N slectionne.\nAcquisitions simules !");
		break;
	}

	m_pMM2000=new CMM2000();
	if (m_pMM2000->TP(1)==1e10) m_OKAxe=FALSE; else m_OKAxe=TRUE;

	if (m_pApp->m_iCarte!=0) m_s2=m_s2+"\nLes acquisitions de tension sont faites sur les VOIES 0 et 1 de la carte.\nVotre origine est-elle bien dfinie au CENTRE du capteur ?";
	m_OK=FALSE;
	m_radioAxe=1;
	m_fLong=14;
	m_iNbMes=30;
	UpdateData(FALSE);
	return TRUE;
}
//________________________________________
void CMesDlg::OnOK() 
{
	//CDialog::OnOK();
}
//________________________________________
void CMesDlg::OnDemarrer() 
{
	if (!m_OK)
	{
		//Test
		UpdateData(TRUE);
		if (m_fLong<1) m_fLong=1;
		if (m_fLong>50) m_fLong=50;
		if (m_iNbMes<2) m_iNbMes=2;
		if (m_iNbMes>m_pDoc->m_iNbMax-1) m_iNbMes=m_pDoc->m_iNbMax-1;
		UpdateData(FALSE);

		m_btnDemarrer.SetWindowText("&Arrter");
		m_iNb=0;
		switch (m_pApp->m_iCarte)
		{
			case 1://Candibus
			break;
			case 2://Eurosmart
			break;
			case 3://Sysam
				m_pSys->GainAN(m_pApp->m_iVoie,(short)pow(2,m_pApp->m_iGain));
			break;
			default:
			break;
		}
		SetTimer(2,50,NULL);
	}
	else
	{
		//Arrter
		KillTimer(2);
		KillTimer(3);
		m_btnDemarrer.SetWindowText("&Dmarrer");
		//Graphe n1, voir BkView.cpp ligne 155
		m_pDoc->m_iTypeGr=2;
		m_pDoc->m_iNb=m_iNb;
		m_pDoc->UpdateAllViews(NULL);
	}
	m_btnCancel.EnableWindow(m_OK);
	m_btnPlus.EnableWindow(m_OK);
	m_btnMoins.EnableWindow(m_OK);
	m_btnDH.EnableWindow(m_OK);
	m_btnGH.EnableWindow(m_OK);
	GetDlgItem(IDC_NB)->EnableWindow(m_OK);
	GetDlgItem(IDC_COURSE)->EnableWindow(m_OK);
	GetDlgItem(IDC_RADIOX)->EnableWindow(m_OK);
	GetDlgItem(IDC_RADIOY)->EnableWindow(m_OK);
	m_OK=!m_OK;
}
//________________________________________
void CMesDlg::OnCancel() 
{
	switch (m_pApp->m_iCarte)
	{
		case 1://Candibus
			delete m_pCand;
		break;
		case 2://Eurosmart
			delete m_pEuro;
		break;
		case 3://Sysam
			delete m_pSys;
		break;
		default://Aucune
		break;
	}
	CDialog::OnCancel();
}
//________________________________________
void CMesDlg::OnMoins() 
{
	UpdateData(TRUE);
	float x;
	if (m_OKAxe)
	{
		if (m_radioAxe==0)
		{
			m_pMM2000->MR(1,-0.5);m_pMM2000->WS(1);
			x=m_pMM2000->TP(1);
		}
		else
		{
			m_pMM2000->MR(2,-0.5);m_pMM2000->WS(2);
			x=m_pMM2000->TP(2);
		}
		if (x==1e10)
		{
			m_s2.Format("Axe(mm): ?");
		}
		else
		{

		  m_s2.Format("Axe(mm):%6.2f",x);
		}
		UpdateData(FALSE);
	}
}
//________________________________________
void CMesDlg::OnPlus() 
{
	UpdateData(TRUE);
	float x;
	if (m_OKAxe)
	{
		if (m_radioAxe==0)
		{
			m_pMM2000->MR(1,0.5);m_pMM2000->WS(1);
			x=m_pMM2000->TP(1);
		}
		else
		{
			m_pMM2000->MR(2,0.5);m_pMM2000->WS(2);
			x=m_pMM2000->TP(2);
		}
		if (x==1e10)
		{
			m_s2.Format("Axe(mm): ?");
		}
		else
		{

		  m_s2.Format("Axe(mm):%6.2f",x);
		}
		UpdateData(FALSE);
	}
}
//________________________________________
void CMesDlg::OnDh() 
{
	if (m_OKAxe)
	{
		//Define Home
		float x;
		m_pMM2000->DH(0);
		//Affichage de la position courante
		x=m_pMM2000->TP(1);
		if (x==1e10)
		{
			m_s2.Format("Axe(mm): ?");
		}
		else
		{

		  m_s2.Format("Axe(mm):%6.2f",x);
		}
	}	
	else
		m_s2.Format("Axe(mm): ?");
	UpdateData(FALSE);
}
//________________________________________
void CMesDlg::OnGh() 
{
	if (m_OKAxe)
	{
		//Go Home                           
		//On invalide les boutons
		m_btnGH.EnableWindow(FALSE);
		m_btnDH.EnableWindow(FALSE);
		m_btnPlus.EnableWindow(FALSE);
		m_btnMoins.EnableWindow(FALSE);
		m_btnCancel.EnableWindow(FALSE);      
		//On se dplace             
		m_pMM2000->GH(0);
		//Affichage de la position courante
		m_s2.Format("Axe (mm):%6.2f",0);
		//On valide les boutons
		m_btnGH.EnableWindow(TRUE);
		m_btnPlus.EnableWindow(TRUE);
		m_btnMoins.EnableWindow(TRUE);
		m_btnDH.EnableWindow(TRUE);      
		m_btnCancel.EnableWindow(TRUE);      
	}
	else
		m_s2.Format("Axe(mm): ?");
	UpdateData(FALSE);
}
//________________________________________
void CMesDlg::OnTimer(UINT nIDEvent) 
{
	short moy;
	float 
/*
		a5=2.006706,
		a4=-1.818989e-12,
		a3=2.339566e-01,
		a2=2.546585e-11,
		a1=2.695387e+00,
		a0=7.628387e-11,
*/
		x,
		PI=4*atan(1),
		ux,uy;

		switch (nIDEvent)
		{
			case 2:
				KillTimer(2);
				moy=(short)pow(2,m_pApp->m_iMoy);
				x=-m_fLong/2+m_fLong*m_iNb/m_iNbMes;
				if (m_OKAxe)
				{
					//Positionner axe motoris
					if (m_radioAxe==0)
					{
						m_pMM2000->MA(1,x);m_pMM2000->WS(1);
					}
					else
					{
						m_pMM2000->MA(2,x);m_pMM2000->WS(2);
					}
				}

				switch (m_pApp->m_iCarte)
				{
					case 1://Candibus
						ux=m_pCand->LitTension(0,moy);
						uy=m_pCand->LitTension(1,moy);
					break;
					case 2://Eurosmart
						ux=m_pEuro->LitTension(0,m_pApp->m_radioTypeAcq,moy);
						uy=m_pEuro->LitTension(1,m_pApp->m_radioTypeAcq,moy);
					break;
					case 3://Sysam
						ux=m_pSys->LitTension(0,moy);
						uy=m_pSys->LitTension(0,moy);
					break;
					default:
						ux=1e10;
						uy=1e10;
					break;
				}
				//Simulation
				if (ux==1e10)
				{
					ux=x/5;
				}
				if (uy==1e10)
				{
					uy=x/5;
				}
				//Ecriture tableau
				if (m_iNb<=m_iNbMes)
				{
					m_pDoc->m_fT[m_iNb][0]=x;
					m_pDoc->m_fT[m_iNb][1]=ux;
					m_pDoc->m_fT[m_iNb][2]=x;
					m_pDoc->m_fT[m_iNb][3]=uy;
					m_s2.Format("Ux(V) : %8.3f\nUy(V) : %8.3f\nAxe(mm): %6.2f\n(%d/%d)",ux,uy,x,m_iNb,m_iNbMes);
					m_iNb++;
					m_iN=0;SetTimer(3,50,NULL);
				}
				else
				{
					//On arrte, tableau plein
					m_btnDemarrer.SetWindowText("&Dmarrer");
					m_btnCancel.EnableWindow(TRUE);
					m_btnPlus.EnableWindow(TRUE);
					m_btnMoins.EnableWindow(TRUE);
					m_btnGH.EnableWindow(TRUE);
					m_btnDH.EnableWindow(TRUE);
					//Graphe n1, voir BkView.cpp ligne 155
					m_pDoc->m_iTypeGr=2;
					m_pDoc->m_iNb=m_iNb;
					m_pDoc->UpdateAllViews(NULL);
					GetDlgItem(IDC_NB)->EnableWindow(m_OK);
					GetDlgItem(IDC_COURSE)->EnableWindow(m_OK);
					GetDlgItem(IDC_RADIOX)->EnableWindow(m_OK);
					GetDlgItem(IDC_RADIOY)->EnableWindow(m_OK);
					m_OK=FALSE;
				}
				UpdateData(FALSE);
			break;
			case 3:
				m_iN++;
				if (m_iN>10)
				{
					KillTimer(3);SetTimer(2,50,NULL);

				}
			break;
	}	
	CDialog::OnTimer(nIDEvent);
}
//________________________________________
float CMesDlg::pos_capteur(float u)
{
	return (float)(2.1485*pow(u,5)+0.0718*pow(u,4)-0.5067*pow(u,3)-0.0721*pow(u,2)+3.266*u-0.002);
}
//________________________________________
float CMesDlg::u_capteur(float x)
{
	return (float)(2.1485*pow(x,5)+0.0718*pow(x,4)-0.5067*pow(x,3)-0.0721*pow(x,2)+3.266*x-0.002);
}
