// SysamDlg.cpp : implementation file
#include "stdafx.h"
#include "Bk.h"
#include "SysamDlg.h"
#include "Sysam.h"
#include "math.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CSysamDlg dialog
CSysamDlg::CSysamDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSysamDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSysamDlg)
	m_s1 = _T("");
	//}}AFX_DATA_INIT
}
void CSysamDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSysamDlg)
	DDX_Control(pDX, IDC_VOIE, m_comboVoie);
	DDX_Control(pDX, IDCANCEL, m_btnCancel);
	DDX_Control(pDX, IDTEST, m_btnTest);
	DDX_Control(pDX, IDC_MOY, m_comboMoy);
	DDX_Control(pDX, IDC_GAIN, m_comboGain);
	DDX_Text(pDX, IDC_STATIC1, m_s1);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CSysamDlg, CDialog)
	//{{AFX_MSG_MAP(CSysamDlg)
	ON_BN_CLICKED(IDTEST, OnTest)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CSysamDlg message handlers
BOOL CSysamDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	CString s;
	short i;
	m_pApp=((CBkApp*)AfxGetApp());
	//Voies A/N
	for (i=0;i<8;i++)
	{
		s.Format("Voie %d",i);
		m_comboVoie.AddString(s);
	}
	m_comboVoie.GetLBText(m_pApp->m_iVoie,s);
	m_comboVoie.SetWindowText(s);	
	//Gain
	for (i=0;i<4;i++)
	{
		s.Format("X %d",(short)pow(2,i));
		m_comboGain.AddString(s);
	}
	m_comboGain.GetLBText(m_pApp->m_iGain,s);
	m_comboGain.SetWindowText(s);	
	//Moyenne
	for (i=0;i<11;i++)
	{
		s.Format("%d",(short)pow(2,i));
		m_comboMoy.AddString(s);
	}
	m_comboMoy.GetLBText(m_pApp->m_iMoy,s);
	m_comboMoy.SetWindowText(s);
	m_pSys=new CSysam();
	if (!m_pSys->OKCarte())
	{
		//Carte non prsente
		m_s1.Format("Carte Sysam-PCI non trouve !");
		m_btnTest.EnableWindow(FALSE);
		m_pApp->m_iCarte=0;
	}
	else
	{
		m_s1.Format("Carte Sysam-PCI OK...");
	}
	m_OK=FALSE;
	UpdateData(FALSE);
	return TRUE;
}
//________________________________________
void CSysamDlg::OnCancel() 
{
	MAJ();
	delete m_pSys;
	CDialog::OnCancel();
}
//________________________________________
void CSysamDlg::OnOK() 
{
	//CDialog::OnOK();
}
//________________________________________
void CSysamDlg::OnTest() 
{
	if (!m_OK)
	{
		//Test
		MAJ();
		m_pSys->GainAN(m_pApp->m_iVoie,(short)pow(2,m_pApp->m_iGain));
		m_btnTest.SetWindowText("&Arrter");
		m_OKBusy=FALSE;SetTimer(1,50,NULL);
	}
	else
	{
		//Arrter
		KillTimer(1);
		m_btnTest.SetWindowText("&Tester");
	}

	m_btnCancel.EnableWindow(m_OK);
	GetDlgItem(IDC_GAIN)->EnableWindow(m_OK);
	GetDlgItem(IDC_VOIE)->EnableWindow(m_OK);
	GetDlgItem(IDC_MOY)->EnableWindow(m_OK);

	m_OK=!m_OK;
}
//________________________________________
void CSysamDlg::OnTimer(UINT nIDEvent) 
{
	short moy;
	float u;
	if (!m_OKBusy)
	{
		m_OKBusy=TRUE;
		moy=(short)pow(2,m_pApp->m_iMoy);
		u=m_pSys->LitTension(m_pApp->m_iVoie,moy);
		if (u!=1e10)
			m_s1.Format("Acq. en cours:\nU[%d][%d] (V) : %8.3f",m_pApp->m_iVoie,moy,u);
		else
			m_s1.Format("Acq. en cours:\nU[%d][%d] (V) : ?",m_pApp->m_iVoie,moy);
		UpdateData(FALSE);
		m_OKBusy=FALSE;
	}	
	CDialog::OnTimer(nIDEvent);
}
//________________________________________
void CSysamDlg::MAJ() 
{
	UpdateData(TRUE);
	if (m_comboVoie.GetCurSel()<0)
	{
		//Pas touch au combo
	}
	else
		m_pApp->m_iVoie=m_comboVoie.GetCurSel();

	if (m_comboMoy.GetCurSel()<0)
	{
		//Pas touch au combo
	}
	else
		m_pApp->m_iMoy=m_comboMoy.GetCurSel();
	if (m_comboGain.GetCurSel()<0)
	{
		//Pas touch au combo
	}
	else
		m_pApp->m_iGain=m_comboGain.GetCurSel();

}
