// 3dDlg.cpp : implementation file
#include "stdafx.h"
#include "Bk.h"
#include "3dDlg.h"
#include "BkDoc.h"
#include "BkView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
// C3dDlg dialog
C3dDlg::C3dDlg(CWnd* pParent /*=NULL*/)
	: CDialog(C3dDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(C3dDlg)
	m_radioPas = -1;
	//}}AFX_DATA_INIT
}
void C3dDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(C3dDlg)
	DDX_Control(pDX, IDC_YPLUS, m_btnYplus);
	DDX_Control(pDX, IDC_YMOINS, m_btnYmoins);
	DDX_Control(pDX, IDC_XPLUS, m_btnXplus);
	DDX_Control(pDX, IDC_XMOINS, m_btnXmoins);
	DDX_Control(pDX, IDCANCEL, m_btnCancel);
	DDX_Control(pDX, IDVISU, m_btnVisu);
	DDX_Radio(pDX, IDC_PAS1, m_radioPas);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(C3dDlg, CDialog)
	//{{AFX_MSG_MAP(C3dDlg)
	ON_BN_CLICKED(IDVISU, OnVisu)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_XMOINS, OnXmoins)
	ON_BN_CLICKED(IDC_XPLUS, OnXplus)
	ON_BN_CLICKED(IDC_YMOINS, OnYmoins)
	ON_BN_CLICKED(IDC_YPLUS, OnYplus)
	ON_BN_CLICKED(IDC_ZMOINS, OnZmoins)
	ON_BN_CLICKED(IDC_ZPLUS, OnZplus)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//////////////////////////////////////////
// C3dDlg message handlers
BOOL C3dDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	short l,h;
	CMDIChildWnd *pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	m_pApp=((CBkApp*)AfxGetApp());
	if (pChild) m_pDoc=(CBkDoc*)pChild->GetActiveDocument(); else m_pDoc=NULL;
	SendMessage(WM_COMMAND,ID_FILE_NEW,0);
	pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) 
	{
		m_pDoc3D=(CBkDoc*)pChild->GetActiveDocument();
		m_pView3D=(CBkView*)pChild->GetActiveView();
	}
	else
	{
		m_pDoc3D=NULL;
		m_pView3D=NULL;
	}
	if (m_pDoc3D)
	{
		m_pDoc3D->m_iType=2;
		//Taille de l'image source 24 bits
		l=m_pDoc->image->endx-m_pDoc->image->stx+1;
		h=m_pDoc->image->endy-m_pDoc->image->sty+1;
		freeimage(m_pDoc3D->image);
		allocimage(m_pDoc3D->image,1.5*l,1.5*h,24);
		resize(m_pDoc->image,m_pDoc3D->image);
		m_pDoc3D->DimensionnerFenetre(1.5*l,1.5*h);
		m_pDoc3D->DimensionnerScroll(1.5*l,1.5*h);
		m_pDoc3D->SetTitle("Visu3D");
	}
	if (m_pView3D!=NULL) 
	{
		m_pView3D->m_iPas=2;
		m_pView3D->Invalidate(FALSE);
	}
	m_radioPas=m_pApp->m_radioPas;
	m_OK=FALSE;
	UpdateData(FALSE);
	return TRUE;
}
//________________________________________
void C3dDlg::OnOK() 
{
	//CDialog::OnOK();
}
//________________________________________
void C3dDlg::OnCancel() 
{
	if (m_pDoc3D!=NULL)
	{
		//On passe par le presse papier pour pouvoir l'imprimer
		if (OpenClipboard())
		{
			EmptyClipboard();
			windowtoimage(m_pView3D->m_hWnd,m_pDoc3D->image);
			m_pDoc3D->m_iType=3;
			short l,h;
			l=m_pDoc3D->image->endx-m_pDoc3D->image->stx+1;
			h=m_pDoc3D->image->endy-m_pDoc3D->image->sty+1;
			m_pDoc3D->DimensionnerFenetre(l,h);
			//m_pd->UpdateAllViews(NULL);
		}
		m_pApp->m_radioPas=m_radioPas;
	}
	CDialog::OnCancel();
}
//________________________________________
void C3dDlg::OnVisu() 
{
	if (!m_OK)
	{
		m_btnVisu.SetWindowText("Arrter");
		m_btnCancel.EnableWindow(FALSE);
		UpdateData(TRUE);
		if (m_radioPas==0) m_pView3D->m_iPas=1; else m_pView3D->m_iPas=2;
		GetDlgItem(IDC_PAS1)->EnableWindow(FALSE);
		GetDlgItem(IDC_PAS2)->EnableWindow(FALSE);
		SetTimer(1,150,NULL);
	}
	else
	{
		KillTimer(1);
		GetDlgItem(IDC_PAS1)->EnableWindow(TRUE);
		GetDlgItem(IDC_PAS2)->EnableWindow(TRUE);
		m_btnVisu.SetWindowText("Visualiser auto.");
		m_btnCancel.EnableWindow(TRUE);
	}
	m_OK=!m_OK;	
}
//________________________________________
void C3dDlg::OnTimer(UINT nIDEvent) 
{
  m_pApp->m_fAngleX -=2.0f;
  m_pApp->m_fAngleY -=20.0f;
  m_pApp->m_fAngleZ -=10.0f;
  //CMDIChildWnd * pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	//if (pChild) m_pView=(CBkView*)pChild->GetActiveView(); else m_pView=NULL;
	if (m_pView3D!=NULL) m_pView3D->Invalidate(FALSE);

	CDialog::OnTimer(nIDEvent);
}
//________________________________________
void C3dDlg::OnXmoins() 
{
	UpdateData(TRUE);
	if (m_radioPas==0) m_pView3D->m_iPas=1; else m_pView3D->m_iPas=2;
	m_pApp->m_fAngleY=m_pApp->m_fAngleY-10;
  //CMDIChildWnd * pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	//if (pChild) m_pView=(CBkView*)pChild->GetActiveView(); else m_pView=NULL;
	if (m_pView3D!=NULL) m_pView3D->Invalidate(FALSE);
}
//________________________________________
void C3dDlg::OnXplus() 
{
	UpdateData(TRUE);
	if (m_radioPas==0) m_pView3D->m_iPas=1; else m_pView3D->m_iPas=2;
	m_pApp->m_fAngleY=m_pApp->m_fAngleY+10;
  //CMDIChildWnd * pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	//if (pChild) m_pView=(CBkView*)pChild->GetActiveView(); else m_pView=NULL;
	if (m_pView3D!=NULL) m_pView3D->Invalidate(FALSE);;
}
//________________________________________
void C3dDlg::OnYmoins() 
{
	UpdateData(TRUE);
	if (m_radioPas==0) m_pView3D->m_iPas=1; else m_pView3D->m_iPas=2;
	m_pApp->m_fAngleX=m_pApp->m_fAngleX-10;
  //CMDIChildWnd * pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	//if (pChild) m_pView=(CBkView*)pChild->GetActiveView(); else m_pView=NULL;
	if (m_pView3D!=NULL) m_pView3D->Invalidate(FALSE);
}
//________________________________________
void C3dDlg::OnYplus() 
{
	UpdateData(TRUE);
	if (m_radioPas==0) m_pView3D->m_iPas=1; else m_pView3D->m_iPas=2;
	m_pApp->m_fAngleX=m_pApp->m_fAngleX+10;
  //CMDIChildWnd * pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	//if (pChild) m_pView=(CBkView*)pChild->GetActiveView(); else m_pView=NULL;
	if (m_pView3D!=NULL) m_pView3D->Invalidate(FALSE);
}
//________________________________________
void C3dDlg::OnZmoins() 
{
	UpdateData(TRUE);
	if (m_radioPas==0) m_pView3D->m_iPas=1; else m_pView3D->m_iPas=2;
	m_pApp->m_fAngleZ=m_pApp->m_fAngleZ-10;
  //CMDIChildWnd * pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	//if (pChild) m_pView=(CBkView*)pChild->GetActiveView(); else m_pView=NULL;
	if (m_pView3D!=NULL) m_pView3D->Invalidate(FALSE);
}
//________________________________________
void C3dDlg::OnZplus() 
{
	UpdateData(TRUE);
	if (m_radioPas==0) m_pView3D->m_iPas=1; else m_pView3D->m_iPas=2;
	m_pApp->m_fAngleZ=m_pApp->m_fAngleZ+10;
  //CMDIChildWnd * pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	//if (pChild) m_pView=(CBkView*)pChild->GetActiveView(); else m_pView=NULL;
	if (m_pView3D!=NULL) m_pView3D->Invalidate(FALSE);
}
