// acqdlg.cpp : implementation file
#include "stdafx.h"
#include "bk.h"
#include "acqdlg.h" 
#include "bkdoc.h"
#include "eurosmart.h"
#include "mm2000.h"
#include "vicdefs.h"
#include <math.h>

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CAcqDlg dialog
CAcqDlg::CAcqDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAcqDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAcqDlg)
	m_fDx = 0;
	m_fDy = 0;
	m_fPas = 0;
	m_iTempo = 0;
	m_sTexte = _T("");
	//}}AFX_DATA_INIT
}
void CAcqDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAcqDlg)
	DDX_Control(pDX, IDCANCEL, m_btnCancel);
	DDX_Control(pDX, IDDEMARRER, m_btnDemarrer);
	DDX_Control(pDX, IDARRETER, m_btnArreter);
	DDX_Text(pDX, IDC_DX, m_fDx);
	DDX_Text(pDX, IDC_DY, m_fDy);
	DDX_Text(pDX, IDC_PAS, m_fPas);
	DDX_Text(pDX, IDC_TEMPO, m_iTempo);
	DDX_Text(pDX, IDC_STATIC_TEXTE, m_sTexte);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CAcqDlg, CDialog)
	//{{AFX_MSG_MAP(CAcqDlg)
	ON_WM_TIMER()
	ON_EN_KILLFOCUS(IDC_DX, OnKillfocusDx)
	ON_BN_CLICKED(IDARRETER, OnArreter)
	ON_BN_CLICKED(IDDEMARRER, OnDemarrer)
	ON_EN_KILLFOCUS(IDC_DY, OnKillfocusDy)
	ON_EN_KILLFOCUS(IDC_PAS, OnKillfocusPas)
	ON_EN_KILLFOCUS(IDC_TEMPO, OnKillfocusTempo)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CAcqDlg message handlers
BOOL CAcqDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	short i,j;
	//Attention: on peut remplacer Mm2000.cpp par SansMm2000.cpp
	//pour ne pas prendre la carte Mm2000 en compte...
	m_pMM2000=new CMM2000();
	m_pEuro=new CEurosmart();

	m_pApp=((CBkApp*)AfxGetApp());
	CMDIChildWnd *pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) m_pDoc=(CBkDoc*)pChild->GetActiveDocument(); else m_pDoc=NULL;

	if (m_pDoc==NULL || m_pDoc->m_iType==3)
	{
		SendMessage(WM_COMMAND,ID_FILE_NEW,0);
		pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
		if (pChild) 
		{
			m_pDoc=(CBkDoc*)pChild->GetActiveDocument();
		}
	}

	j=1;
	for (i=0;i<m_pApp->m_radioMoy;i++)
	{   
		j=j*2*2;
	}

	m_iNb=0;
	m_fDx=m_pApp->m_fDx;
	m_fDy=m_pApp->m_fDy;
	m_fPas=m_pApp->m_fPas;
	m_iTempo=m_pDoc->m_iTempo;
	VerifPara(&m_fDx,&m_fDy,&m_fPas,&m_iNbX,&m_iNbY);
	m_sTexte.Format("Nb. d'acquisitions: %u x %u = %u\nLa temporisation donne le delai avant la prise de mesure.\nLecture tension sur %d chantillons.",m_iNbX,m_iNbY,m_iNbX*m_iNbY,j);

	m_btnArreter.EnableWindow(FALSE);
	m_OK=TRUE;
	if (m_pMM2000->TP(2)==1e10) m_OK=FALSE;
	float u;
	u=m_pEuro->LitTension(1,1,2);
  if (fabs(u)>11) m_OK=FALSE;

	UpdateData(FALSE);
	return TRUE;
}
//________________________________________
void CAcqDlg::OnArreter()
{
	m_pMM2000->ST(0);
	KillTimer(6);
	m_btnArreter.EnableWindow(FALSE);
	m_btnDemarrer.EnableWindow(TRUE);
	m_btnCancel.EnableWindow(TRUE);
}
//________________________________________
void CAcqDlg::OnDemarrer()
{
	UpdateData(TRUE);
	m_btnArreter.EnableWindow(TRUE);
	m_btnDemarrer.EnableWindow(FALSE);
	m_btnCancel.EnableWindow(FALSE);
	//Vitesse de scan
	if (m_OK) m_pMM2000->SV(0,m_pMM2000->m_fVit);
	x_axe=0;y_axe=0;
	m_ik=1;
	m_iNb=0;
	//Initialisation tableau de mesures
	short i;
	for (i=0;i<m_pDoc->m_iNbMax1;i++)
	{
		m_pDoc->m_fM[i][0]=1e10;//x
		m_pDoc->m_fM[i][1]=1e10;//y
		m_pDoc->m_fM[i][2]=1e10;//ux
		m_pDoc->m_fM[i][3]=1e10;//uy
	}
	m_pDoc->SetModifiedFlag(TRUE);

	m_pApp->m_fDx=m_fDx;
	m_pApp->m_fDy=m_fDy;

	x_axeM=0;y_axeM=0;

	m_pDoc->m_Rect3=m_pDoc->DimensionnerImage(m_fDx,m_fDy);
	m_OKBusy=FALSE;SetTimer(6,50,NULL);
}
//________________________________________
void CAcqDlg::OnKillfocusDx()
{
	UpdateData(TRUE);
	VerifPara(&m_fDx,&m_fDy,&m_fPas,&m_iNbX,&m_iNbY);
	UpdateData(FALSE);
	m_sTexte.Format("Nb. d'acquisitions: %u x %u = %u",m_iNbX,m_iNbY,m_iNbX*m_iNbY);
	UpdateData(FALSE);
}
//________________________________________
void CAcqDlg::OnKillfocusDy()
{
	UpdateData(TRUE);
	VerifPara(&m_fDx,&m_fDy,&m_fPas,&m_iNbX,&m_iNbY);
	UpdateData(FALSE);
	m_sTexte.Format("Nb. d'acquisitions: %u x %u = %u",m_iNbX,m_iNbY,m_iNbX*m_iNbY);
	UpdateData(FALSE);
}
//________________________________________
void CAcqDlg::OnKillfocusPas()
{
	UpdateData(TRUE);
	VerifPara(&m_fDx,&m_fDy,&m_fPas,&m_iNbX,&m_iNbY);
	UpdateData(FALSE);
	m_sTexte.Format("Nb. d'acquisitions: %u x %u = %u",m_iNbX,m_iNbY,m_iNbX*m_iNbY);
	UpdateData(FALSE);
}
//________________________________________
void CAcqDlg::OnKillfocusTempo()
{
	UpdateData(TRUE);
	if (m_iTempo<0 || m_iTempo>2500) m_iTempo=2500;	
	UpdateData(FALSE);
}
//________________________________________
void CAcqDlg::OnTimer(UINT nIDEvent)
{
	short i,j;
	float r,h,ux,uy;
	j=1;
	for (i=0;i<m_pApp->m_radioMoy;i++)
	{   
		j=j*2*2;
	}
	//Dplacement au dessus du point de mesure
	if(!m_OKBusy)
	{
		m_OKBusy=TRUE;
		if (m_OK)
		{
			m_pMM2000->MA(1,x_axe);m_pMM2000->WS(1);
			m_pMM2000->MA(2,y_axe);m_pMM2000->WS(2);
		}
		if (m_iTempo!=0 && m_OK) Sleep(m_iTempo);
		if (m_OK)
		{
			//On triche avec la valeur de moyenne 2*j !
			ux=m_pEuro->LitTension(0,1,2*j);
			uy=m_pEuro->LitTension(1,1,2*j);
			//Tenir compte du convertisseur
			//u=u*m_pApp->m_fCanA+m_pApp->m_fCanB;
		}
		else
		{
			//Simulation: dfaut de planit & paralllisme
			ux=0.5;
			h=-3+5.7*x_axe/m_fDx+0.2*sin(6.0*3.1416*x_axe/m_fDx);
			//h=-3+5.7*x_axe/m_fDx;
			//h=0.2*sin(3.0*3.1416*x_axe/m_fDx);
			uy=m_pDoc->pos_capteur_1(h);
		}
		if (m_iNb<m_pDoc->m_iNbMax1)
		{
			m_pDoc->m_fM[m_iNb][0]=x_axe;
			m_pDoc->m_fM[m_iNb][1]=y_axe;
			m_pDoc->m_fM[m_iNb][2]=ux;
			m_pDoc->m_fM[m_iNb][3]=uy;
			h=m_pDoc->PointImage(ux,uy,m_pDoc->m_fGamma);
			m_iNb++;
			if (x_axeM<x_axe) x_axeM=x_axe;
			if (y_axeM<y_axe) y_axeM=y_axe;
		}
		m_sTexte.Format("%u/%u\nX(mm):%7.2f - Y(mm):%7.2f\nUx(V):%1.3f, Uy(V):%1.3f\nh(mm):%1.3f",m_iNb,m_iNbX*m_iNbY,x_axe,y_axe,ux,uy,h);
		x_axe=x_axe+m_ik*m_fPas;
		if (x_axe>m_fDx || x_axe<0)    
		{
			x_axe=x_axe-m_ik*m_fPas;
			m_ik=-m_ik;
			y_axe=y_axe+m_fPas;
			if (y_axe>m_fDy) 
			{
				KillTimer(6);	
				//m_btnCancel.EnableWindow(TRUE);
				//m_btnArreter.EnableWindow(FALSE);
				//m_btnDemarrer.EnableWindow(TRUE);

				//Fermeture automatique de la bote de dialogue en fin d'acquisition

				OnCancel();
			}
		}
		UpdateData(FALSE);
		m_OKBusy=FALSE;

	}
	CDialog::OnTimer(nIDEvent);
}
//__________________________________________________
void CAcqDlg::OnCancel()
{
	float hmax,hmin;
	UpdateData(TRUE);
	m_pApp->m_fPas=m_fPas;

	if (x_axeM<m_fDx || y_axeM<m_fDy)
	{
		//On redimensionne  l'acquisition effective
		m_fDx=x_axeM;
		m_fDy=m_fDy=y_axeM;
	}

	m_pApp->m_fDx=m_fDx;
	m_pApp->m_fDy=m_fDy;
	m_pDoc->m_iTempo=m_iTempo;
	m_pDoc->m_iNb1=m_iNb;
	//Calcul de tous les paramtres
	if (m_iNb!=0) CalculParametres();
	m_pDoc->UpdateAllViews(NULL); 
	delete m_pMM2000;
	delete m_pEuro;
	CDialog::OnCancel();
}
//__________________________________________________
void CAcqDlg::VerifPara(float *m_fDx,float *m_fDy,float *m_fPas,unsigned int *m_iNbX,unsigned int *m_iNbY)
{             
	//Vrification et mise  jour des paramtres de l'acquisition
	if (*m_fDx<3) *m_fDx=3;	
	if (*m_fDx>100) *m_fDx=100;
	if (*m_fDy<3) *m_fDy=3;	
	if (*m_fDy>100) *m_fDy=100;
	if (*m_fPas<1) *m_fPas=1;

	short nbx,nby;
	//Optimisation pas en fonction taille tableau
	do
	{
		nbx=(unsigned int)((*m_fDx)/(*m_fPas)+1);
		nby=(unsigned int)((*m_fDy)/(*m_fPas)+1);
		if (nbx*nby>m_pDoc->m_iNbMax1) *m_fPas=*m_fPas+0.5;
	}
	while (nbx*nby>m_pDoc->m_iNbMax1);


	//Optimisation taille scanning en fonction pas
	*m_fDx=*m_fPas*(nbx-1);
	*m_fDy=*m_fPas*(nby-1);



	*m_iNbX=nbx;
	*m_iNbY=nby;  
}
//__________________________________________________
void CAcqDlg::OnOK()
{
	//CDialog::OnOK();
}
//__________________________________________________
void CAcqDlg::CalculParametres()
{
	m_pApp->m_fDx=m_fDx;m_pApp->m_fDy=m_fDy;
	m_pDoc->m_Rect3=m_pDoc->DimensionnerImage(m_pApp->m_fDx,m_pApp->m_fDy);
	m_pDoc->Def_Plan(&(m_pDoc->m_fAlpha),&(m_pDoc->m_fBeta),&(m_pDoc->m_fOmega),&(m_pDoc->m_fEcmin),&(m_pDoc->m_fEcmax),&(m_pDoc->m_fPara));
	if (m_pApp->m_OKTilt)	m_pDoc->ConstructionImage(); else m_pDoc->ConstructionImageSansTilt(m_pDoc->m_fAlpha,m_pDoc->m_fBeta,m_pDoc->m_fOmega);
	//Position point profil dans l'image
	m_pDoc->m_ptPF.x=m_pDoc->image->endx/2;m_pDoc->m_ptPF.y=m_pDoc->image->endy/2;
	m_pDoc->CalculProfils(m_pDoc->m_ptPF);
}
