// BkDoc.cpp : implementation of the CBkDoc class
#include "stdafx.h"
#include "Bk.h"
#include "BkDoc.h"
#include "BkView.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CBkDoc
IMPLEMENT_DYNCREATE(CBkDoc, CDocument)

BEGIN_MESSAGE_MAP(CBkDoc, CDocument)
	//{{AFX_MSG_MAP(CBkDoc)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CBkDoc construction/destruction
CBkDoc::CBkDoc()
{
	m_pWnd=NULL;	//Pointeur sur la fentre affect dans CBkView::OnInitialUpdate
	m_pApp=((CBkApp*)AfxGetApp());
	m_pApp->m_iNb++;

	//Tableau profils_______________________
  m_iNbMax=400;	//Nb. de lignes du tableau, la taille maxi de l'image est de 400 x 400 pixels
	m_iNbCol=4;	//Nb. de colonnes du tableau		
  m_iNb=0;//Aucune acquisition de faite pour l'instant
  m_fT=new float[m_iNbMax][4];//4: m_iNbCol
	Init_m_fT();
	//Paramtres graphes profils____________
	m_Rect1.SetRect(552,40,552+420,40+262);	//Taille et position des rectangles contenant les graphes
	m_Rect2.SetRect(552,368,552+420,368+262);
	//Paramtres de l'image_________________
	image=new imgdes;
	allocimage(image,400,400,24);
	//On dclare d'abord une image, puis on optimise sa taille en fonction des paramtres de scanning
	m_Rect3=DimensionnerImage(m_pApp->m_fDx,m_pApp->m_fDy);
	m_iType=0;
	//Pas de point d'talonnage mesur
	m_iEtal=0;
	//Tableau mesures_______________________
  m_iNbMax1=500;
  m_iNb1=0;
	m_iNbCol1=4;
  m_fM=new float[m_iNbMax1][4];//4: m_iNbCol
	Init_m_fM();
	m_iTempo=1500;

	//Rectangle informations
	m_Rect4.SetRect(18,435,18+450,435+218);

	//Rectangle chelle des niveaux
	m_Rect5.SetRect(432,17,432+80,17+250);

	//Echelle pour visualisation en pseudo-couleur et calcul Tension (par dfaut)
	//Ces valeurs sont calcules par les fonctions ConstructionImage et ConstructionImageSansTilt
	m_fHmin=-100;m_fHmax=100;

	//Etalonnage (structure dfinie dans stdafx.h)
	//Point 1
	m_Ep1.x=m_pApp->m_Ep1.x;
	m_Ep1.y=m_pApp->m_Ep1.y;
	m_Ep1.h=m_pApp->m_Ep1.h;
	m_Ep1.ux=m_pApp->m_Ep1.ux;
	m_Ep1.uy=m_pApp->m_Ep1.uy;
	//Point 2
	m_Ep2.x=m_pApp->m_Ep2.x;
	m_Ep2.y=m_pApp->m_Ep2.y;
	m_Ep2.h=m_pApp->m_Ep2.h;
	m_Ep2.ux=m_pApp->m_Ep2.ux;
	m_Ep2.uy=m_pApp->m_Ep2.uy;

	//float u;
	//u=pos_capteur_1(4);
	//CString z;z.Format("%f",u);AfxMessageBox(z);

	
	//Calcul de gamma
	m_fGamma=CalculGamma();

	//Mtrologie du plan : calcul des dfauts de forme et position
	Def_Plan(&m_fAlpha,&m_fBeta,&m_fOmega,&m_fEcmin,&m_fEcmax,&m_fPara);

	if (m_pApp->m_OKTilt)
		//Calcul de l'image pseudo-couleur et des valeurs m_fHmin et m_fHmax
		ConstructionImage();
	else
		//Idem, mais en supprimant le TILT
		ConstructionImageSansTilt(m_fAlpha,m_fBeta,m_fOmega);

	//Curseurs horizontaux et verticaux sur graphe 1 et 2 non dfinis
	InitCurseursGraphes();
	//Position de la barre de dfilement
	m_iXpos=m_iYpos=0;
	//Position point profil dans l'image
	m_ptPF.x=image->endx/2;m_ptPF.y=image->endy/2;
	//Calcul des profils H et V
	CalculProfils(m_ptPF);
	//Marque de pointage____________________
	m_ptMarque[0].x=-1;m_ptMarque[0].y=-1;
	m_ptMarque[1].x=-1;m_ptMarque[1].y=-1;
}
//________________________________________
CBkDoc::~CBkDoc()
{
	m_pApp->m_iNb--;
	delete image;
	delete m_fT;
	delete m_fM;

	if (m_iType==1) 
	{	
		//Visualisation spot
		//m_iType=0;
		m_pApp->m_OKPSD=FALSE;
		m_pApp->m_pDocPSD=NULL;
	}

}
//________________________________________
BOOL CBkDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	return TRUE;
}
//________________________________________
// CBkDoc serialization
void CBkDoc::Serialize(CArchive& ar)
{
	short i,j;
	float r;
	if (ar.IsStoring())
	{
 		//Etalonnage
		ar << m_Ep1.x;
 		ar << m_Ep1.y;
 		ar << m_Ep1.h;
 		ar << m_Ep1.ux;
 		ar << m_Ep1.uy;
 		ar << m_Ep2.x;
 		ar << m_Ep2.y;
 		ar << m_Ep2.h;
 		ar << m_Ep2.ux;
 		ar << m_Ep2.uy;
		//Paramtres acquisition
		ar << m_pApp->m_fAlpha;
		ar << m_pApp->m_fDx;
		ar << m_pApp->m_fDy;
		ar << m_pApp->m_fPas;
		ar << (short)m_pApp->m_OKCor;
		ar << (short)m_pApp->m_OKTilt;
		//Acquisitions
		ar << (short)m_iNb1;
		for (i=0;i<m_iNb1;i++)
		{
			for (j=0;j<4;j++)
			{
				ar << m_fM[i][j];
			}
		}
		//Curseurs
		ar << (short)m_iXpos;
		ar << (short)m_iYpos;
		ar << m_ptPF.x;
		ar << m_ptPF.y;
		for (i=0;i<2;i++)
		{
			for (j=0;j<2;j++)
			{
				ar << m_iCurH[i][j];
				ar << m_iCurV[i][j];		
			}
		}
		//Carte Eurosmart
	}
	else
	{
 		//Etalonnage
		ar >> m_Ep1.x;
 		ar >> m_Ep1.y;
 		ar >> m_Ep1.h;
 		ar >> m_Ep1.ux;
 		ar >> m_Ep1.uy;
 		ar >> m_Ep2.x;
 		ar >> m_Ep2.y;
 		ar >> m_Ep2.h;
 		ar >> m_Ep2.ux;
 		ar >> m_Ep2.uy;
		//Paramtres acquisition
		ar >> m_pApp->m_fAlpha;
		ar >> m_pApp->m_fDx;
		ar >> m_pApp->m_fDy;
		ar >> m_pApp->m_fPas;
		ar >> (short&)m_pApp->m_OKCor;
		ar >> (short&)m_pApp->m_OKTilt;
		//Acquisitions
		ar >> (short&)m_iNb1;
		for (i=0;i<m_iNb1;i++)
		{
			for (j=0;j<4;j++)
			{
				ar >> m_fM[i][j];
			}
		}
		//Curseurs
		ar >> (short&)m_iXpos;
		ar >> (short&)m_iYpos;
		ar >> m_ptPF.x;
		ar >> m_ptPF.y;
		for (i=0;i<2;i++)
		{
			for (j=0;j<2;j++)
			{
				ar >> m_iCurH[i][j];
				ar >> m_iCurV[i][j];		
			}
		}
		//Carte Eurosmart

		//Calcul de tous les paramtres
		m_Rect3=DimensionnerImage(m_pApp->m_fDx,m_pApp->m_fDy);
		m_fGamma=CalculGamma();
		Def_Plan(&m_fAlpha,&m_fBeta,&m_fOmega,&m_fEcmin,&m_fEcmax,&m_fPara);
		if (m_pApp->m_OKTilt)	ConstructionImage(); else ConstructionImageSansTilt(m_fAlpha,m_fBeta,m_fOmega);
		CalculProfils(m_ptPF);
	}
	UpdateAllViews(NULL);
}
//________________________________________
// CBkDoc diagnostics
#ifdef _DEBUG
void CBkDoc::AssertValid() const
{
	CDocument::AssertValid();
}
void CBkDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG
//________________________________________
// CBkDoc commands
void CBkDoc::DimensionnerFenetre(short l,short h)
{
	//Pointeur sur l'application
	/*
	class CBkApp *pApp=((CBkApp*)AfxGetApp());
  CMDIChildWnd * pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	//Pointeur sur la vue
	class CBkView *pView;
	if (pChild) pView=(CBkView*)pChild->GetActiveView(); else pView=NULL;
	*/
	CRect	 MMRect,MMRect1,MMRect2;
	long l1,h1,l2,h2;
	m_pWnd->GetWindowRect(MMRect1);
	m_pWnd->GetClientRect(MMRect2);
	l1=MMRect1.right-MMRect1.left;
	h1=MMRect1.bottom-MMRect1.top;
	l2=MMRect2.right-MMRect2.left;
	h2=MMRect2.bottom-MMRect2.top;
	MMRect.SetRect(0,0,l+l1-l2+4,h+h1-h2+4);
	MMRect.OffsetRect(-MMRect.left,-MMRect.top);
	m_pWnd->SetWindowPos(NULL,l1,h1,MMRect.right,MMRect.bottom,SWP_NOACTIVATE|SWP_NOZORDER|SWP_NOMOVE|SWP_DRAWFRAME);
	m_pWnd->InvalidateRect(NULL,FALSE);
}
//________________________________________
void CBkDoc::Init_m_fT(void)
{
	short i,j;
	for (i=0;i<m_iNbMax;i++)
	{
		for (j=0;j<m_iNbCol;j++)
		{
			m_fT[i][j]=1e10f;
		}
	}
	m_iNb=0;
}
//________________________________________
void CBkDoc::Init_m_fM(void)
{
	short i,j;
	for (i=0;i<m_iNbMax1;i++)
	{
		for (j=0;j<m_iNbCol1;j++)
		{
			m_fM[i][j]=1e10f;
		}
	}
	m_iNb1=0;
}
//________________________________________
long CBkDoc::Couleur(float H,float Hmin,float Hmax)
{
	short h,R,V,B;

	if (H<Hmin) H=Hmin;
	if (H>Hmax) H=Hmax;
	//h dans l'intervalle [0, 1023] pour [hmin, hmax]
	h=(short)(1023.0*(H-Hmin)/(Hmax-Hmin));
	if (h>1022) h=1022;
	if (h<256)
	{
		R=0;
		V=h;
		B=255;
	}
	else
	if (h>=256 && h<512)
	{
		B=511-h;
		V=255;
		R=h-256;
	}
	else
	if (h>=512 && h<768)
	{
		R=255;
		V=767-h;
		B=0;
	}
	else
	{
		R=1023-h;
		B=h-768;
		V=0;
	}
	return RGB(R,V,B);
}
//________________________________________
float CBkDoc::Altitude(imgdes *im,short i,short j,float hmin,float hmax)
{
	//Tension en V en fonction luminance
	float r=0,k;
	short l,h,nbB,R,V,B;
	long w;
	l=im->endx-im->stx+1;
	h=im->endy-im->sty+1;
	nbB=im->bmh->biBitCount;

	if (i>=0 && i<l && j>=0 && j<h)
	{
		w=getpixelcolor(im,i,j);

		if (w==0) return 0;

		if (nbB==24)
		{
			R=w&255; 
			V=(w/256)&255; 
			B=(w/65536)&255;
			//Fonction inverse de la fonction Couleur
			if (R==0 && B==255 )
			{
				//k dans l'intervalle [0, 1023]
				k=V;
				//r : altitude en mm, 0 -> hmin , 1023 ->  hmax 
				r=(hmax-hmin)*k/1023+hmin;
			}
			else
			if (V==255)
			{
				k=255.0+R;
				r=(hmax-hmin)*k/1023+hmin;
			}
			else
			if (R==255 && B==0)
			{
				k=511.0+(255-V);
				r=(hmax-hmin)*k/1023+hmin;
			}
			else
			if (V==0)
			{
				k=767.0+B;
				r=(hmax-hmin)*k/1023+hmin;
			}
			else
				r=1e10;
		}
		else
		{
			r=(hmax-hmin)*w/255+hmin;
		}
	}
	else
		r=1e10;

	return r;
}
//________________________________________
void CBkDoc::InitCurseursGraphes(void)
{
	m_iCurH[0][0]=-1;m_iCurH[0][1]=-1;
	m_iCurV[0][0]=-1;m_iCurV[0][1]=-1;
	m_iCurH[1][0]=-1;m_iCurH[1][1]=-1;
	m_iCurV[1][0]=-1;m_iCurV[1][1]=-1;
	//Initialisation marques de pointage
	m_ptMarque[0].x=-1;
	m_ptMarque[0].y=-1;
	m_ptMarque[1].x=-1;
	m_ptMarque[1].y=-1;
}
//________________________________________
void CBkDoc::CalculProfils(CPoint P)
{
	//Affectation du tableau m_fT en fonction point profil digitalis dans l'image 24 bits
	float H,Hder,x,y;
	short 
		l=image->endx-image->stx+1,
		h=image->endy-image->sty+1,
		i,j;
	Init_m_fT();
	Hder=1e10;
	for (i=0;i<l;i++)
	{
		x=1.0*i/m_fEch;	
		H=Altitude(image,i,P.y,m_fHmin,m_fHmax);
		if (fabs(Hder-H)<0.005) H=Hder;
		Hder=H;
		if (i<m_iNbMax)
		{
			m_fT[i][0]=x;
			m_fT[i][1]=H;
		}
	}
	Hder=1e10;
	for (j=0;j<h;j++)
	{
		x=1.0*j/m_fEch;	
		H=Altitude(image,P.x,j,m_fHmin,m_fHmax);
		if (fabs(Hder-H)<0.005) H=Hder;
		Hder=H;
		if (j<m_iNbMax)
		{
			m_fT[j][2]=x;
			m_fT[j][3]=H;
		}
	}
	m_iNb=m_iNbMax;
}
//________________________________________
CRect CBkDoc::DimensionnerImage(float L,float H)
{
	//Dimensionner l'image en fonction des paramtres de scanning
	short 
		px=20,py=15,//Position dans la fentre
		maxi=400;//La taille maxi est de 400 x 400 pixels

	float echx,echy;
	echx=1.0*maxi/L;
	echy=1.0*maxi/H;
	if (echx<echy) m_fEch=echx; else m_fEch=echy;
	CRect r;
	short l,h;
	l=(short)(m_fEch*L);
	h=(short)(m_fEch*H);
	r.SetRect(px,py,px+l,py+h);	//Taille et position de l'image
	freeimage(image);
	allocimage(image,l,h,24);
	zeroimage(0,image);
	return r;
}
//________________________________________
void CBkDoc::ConstructionImage(void)
{
	//Remplissage de l'image 24 bits en fonction des valeurs dans m_fM
	short 
		l=image->endx-image->stx+1,
		h=image->endy-image->sty+1,
		i,j,k;
	float x,y,u1,u2,H;
	long w;
	//Recherche des extremums
	m_fHmin=1e10;
	m_fHmax=-1e10;
	for (k=0;k<m_iNb1;k++)
	{
		u1=m_fM[k][2];
		u2=m_fM[k][3];
		if(u1!=1e10 && u2!=1e10)
		{
			H=PointImage(u1,u2,m_fGamma);
			if (H<m_fHmin) m_fHmin=H;
			if (H>m_fHmax) m_fHmax=H;
		}
	}
	zeroimage(0,image);
	for (k=0;k<m_iNb1;k++)
	{
		x=m_fM[k][0];
		y=m_fM[k][1];
		u1=m_fM[k][2];
		u2=m_fM[k][3];

		if (x!=1e10 && y!=1e10 && u1!=1e10 && u2!=1e10)
		{
			i=(short)(m_fEch*x);
			if (i>l-1) i=l-1;
			j=(short)(m_fEch*y);
			if (j>h-1) j=h-1;
			if(i>=0 && i<l && j>=0 && j<h)
			{
				H=PointImage(u1,u2,m_fGamma);
				w=Couleur(H,m_fHmin,m_fHmax);
				setpixelcolor(image,i,j,w);
			}
		}
	}
	Maillage(image);
}
//________________________________________
void CBkDoc::ConstructionImageSansTilt(float Alpha,float Beta,float Omega)
{
	//Remplissage de l'image 24 bits en fonction des valeurs dans m_fM
	short 
		l=image->endx-image->stx+1,
		h=image->endy-image->sty+1,
		i,j,k;
	float x,y,u1,u2,H;
	long w;
	//Recherche des extremums
	m_fHmin=1e10;
	m_fHmax=-1e10;
	for (k=0;k<m_iNb1;k++)
	{
		x=m_fM[k][0];
		y=m_fM[k][1];
		u1=m_fM[k][2];
		u2=m_fM[k][3];
		if(x!=1e10 && y!=1e10 && u1!=1e10 && u2!=1e10)
		{
			H=PointImage(u1,u2,m_fGamma);
			H=H-(Omega+y*Alpha-x*Beta);
			if (H<m_fHmin) m_fHmin=H;
			if (H>m_fHmax) m_fHmax=H;
		}
	}
	zeroimage(0,image);
	for (k=0;k<m_iNb1;k++)
	{
		x=m_fM[k][0];
		y=m_fM[k][1];
		u1=m_fM[k][2];
		u2=m_fM[k][3];
		if (x!=1e10 && y!=1e10 && u1!=1e10 && u2!=1e10)
		{
			H=PointImage(u1,u2,m_fGamma);
			H=H-(Omega+y*Alpha-x*Beta);
			i=(short)(m_fEch*x);
			if (i>l-1) i=l-1;
			j=(short)(m_fEch*y);
			if (j>h-1) j=h-1;
			if(i>=0 && i<l && j>=0 && j<h)
			{
				w=Couleur(H,m_fHmin,m_fHmax);
				setpixelcolor(image,i,j,w);
			}
		}
	}
	Maillage(image);
}
//________________________________________
void CBkDoc::Maillage(imgdes *im)
{
	float r,delta,u1,u2;
	short
		i,j,ider,jder,
		k;

	short 
		l=im->endx-im->stx+1,
		h=im->endy-im->sty+1;
	long w,wd;

	//Maillage suivant x
	for (j=0;j<h;j++)
	{
		k=-1;
		do
		{
			k++;
			wd=getpixelcolor(im,k,j);
		}
		while (k<l && wd==0);

		ider=k;
		for (i=k;i<l;i++)
		{
			wd=getpixelcolor(im,i,j);
			if (wd!=0)
			{
				//Valeur trouve
				if (i>ider+1)
				{
					u1=Altitude(im,i,j,m_fHmin,m_fHmax);
					u2=Altitude(im,ider,j,m_fHmin,m_fHmax);
					delta=1.0*(u1-u2)/(i-ider);			

					//CString z3;z3.Format("%d-w1:%lu, %d-w2:%lu\nDelta: %1.3f",i,w1,ider,w2,delta);AfxMessageBox(z3);
					r=u2;
					for (k=ider+1;k<=i-1;k++) 
					{
						r=r+delta;
						w=Couleur(r,m_fHmin,m_fHmax);
						//CString z3;z3.Format("%f, %lu",delta,w);AfxMessageBox(z3);
						setpixelcolor(im,k,j,w);
					}
					ider=i;
				}
			}
		}//for
	}
	//Maillage suivant y
	for (i=0;i<l;i++)
	{
		k=-1;
		do
		{
			k++;
			wd=getpixelcolor(im,i,k);
		}
		while (k<h && wd==0);
		jder=k;
		for (j=k;j<h;j++)
		{
			wd=getpixelcolor(im,i,j);
			if (wd!=0)
			{
				if (j>jder+1)
				{
					//Interpolation
					u1=Altitude(im,i,j,m_fHmin,m_fHmax);
					u2=Altitude(im,i,jder,m_fHmin,m_fHmax);
					delta=1.0*(u1-u2)/(j-jder);			
					r=u2;
					for (k=jder+1;k<=j-1;k++)
					{
						r=r+delta;
						w=Couleur(r,m_fHmin,m_fHmax);
						setpixelcolor(im,i,k,w);
					}
					jder=j;
				}
			}
		}//for
	}
}
//________________________________________
void CBkDoc::Def_Plan(float *alpha,float *beta,float *omega,float *ecmin,float *ecmax,float *para)
{
	float
		x,y,U,U1,P,
		d,ec,k,
		sx=0,sy=0,sx2=0,sy2=0,sxy=0,se=0,sex=0,sey=0,
		xma,yma,Pma,Pmi;
	short
		i,
		v,u;
	long w;
	xma=yma=-1e10;
	Pma=-1e10;
	Pmi=1e10;
	k=0;
	if (m_iNb1>m_iNbMax1) m_iNb1=m_iNbMax1;
	for (i=0;i<m_iNb1;i++)
	{
		x=m_fM[i][0];
		y=m_fM[i][1];
		U=m_fM[i][2];
		U1=m_fM[i][3];
		if (x!=1e10 && y!=1e10 && U!=1E10 && U1!=1E10)
		{
			if (xma<x) xma=x;
			if (yma<y) yma=x;

			P=PointImage(U,U1,m_fGamma);
			if (P>Pma) Pma=P;
			if (P<Pmi) Pmi=P;
			sx=sx+x;
			sy=sy+y;
			sx2=sx2+x*x;
			sy2=sy2+y*y;
			sxy=sxy+x*y;
			se=se+P;
			sex=sex+x*P;
			sey=sey+y*P; 
			k=k+1;
		}
	}
	d=det3_3(sy2,-sxy,sy,-sxy,sx2,-sx,sy,-sx,k);
	if (fabs(d)<1e-10)
	{
		*alpha=0;
		*beta=0;
		*omega=0;
		*ecmin=0;
		*ecmax=0;
		*para=0;
	}
	else
	{
		*alpha=det3_3(sey,-sex,se,-sxy,sx2,-sx,sy,-sx,k)/d;
		*beta=det3_3(sy2,-sxy,sy,sey,-sex,se,sy,-sx,k)/d;
		*omega=det3_3(sy2,-sxy,sy,-sxy,sx2,-sx,sey,-sex,se)/d;
		//*para=fabs(*alpha*yma-*beta*xma);
		if (Pma!=-1e10 && Pmi!=1e10) *para=Pma-Pmi; else *para=0;

	}
	//Recherche max/min
	*ecmax=-1e10;
	*ecmin=1e10;
	for (i=0;i<m_iNb1;i++)
	{
		x=m_fM[i][0];
		y=m_fM[i][1];
		U=m_fM[i][2];
		U1=m_fM[i][3];
		if (x!=1e10 && y!=1e10 && U!=1E10 && U1!=1E10)
		{
			P=PointImage(U,U1,m_fGamma);
			//Formules vrifies le 28/09/99, je n'ai rien vu d'anormal...
			ec=P-(*omega+y**alpha-x**beta);
			if (ec<*ecmin) *ecmin=ec;
			if (ec>*ecmax) *ecmax=ec;
		}
	}
}
//________________________________________
//Dterminant 3-3
float CBkDoc::det3_3(float a11,float a21,float a31,float a12,float a22,float a32,float a13,float a23,float a33)
{
	return a11*a22*a33+a12*a23*a31+a13*a21*a32-a13*a22*a31-a11*a23*a32-a12*a21*a33;
}
//________________________________________
float CBkDoc::pos_capteur(float u)
{
	return (float)(m_pApp->m_fa5*pow(u,5)+m_pApp->m_fa4*pow(u,4)+m_pApp->m_fa3*pow(u,3)+m_pApp->m_fa2*pow(u,2)+m_pApp->m_fa1*u+m_pApp->m_fa0);
}
//________________________________________
float CBkDoc::pos_capteur_1(float h)
{
	float 
		h1,u;
	u=-1;
	do
	{
		h1=pos_capteur(u);
		u=u+0.001;
	}
	while (u<=1 && h1<h);
	return u;
}
//________________________________________
//Sans tenir compte du dfaut de linarit
float CBkDoc::pos_capteur1(float u)
{
	return (float)(5.0*u);
}
//________________________________________
float CBkDoc::CalculGamma(void)
{
	//Calcul de gamma
	float
		Gamma,PI=4*atan(1),
		px1,py1,px2,py2,
		ux,uy,
		d,
		signe;

	//Dtermination de l'axe donnant le signe
	ux=m_Ep2.ux-m_Ep1.ux;
	uy=m_Ep2.uy-m_Ep1.uy;
	if (fabs(ux)>fabs(uy)) 
	{
		if (ux>0) signe=1; else signe=-1;
	}
	else
	{
		if (uy>0) signe=1; else signe=-1;
	}
	
	if (m_pApp->m_OKCor)
	{
		px1=pos_capteur(m_Ep1.ux);
		px2=pos_capteur(m_Ep2.ux);
		py1=pos_capteur(m_Ep1.uy);
		py2=pos_capteur(m_Ep2.uy);
	}
	else
	{
		px1=pos_capteur1(m_Ep1.ux);
		px2=pos_capteur1(m_Ep2.ux);
		py1=pos_capteur1(m_Ep1.uy);
		py2=pos_capteur1(m_Ep2.uy);
	}
	
	d=sqrt(pow(px2-px1,2)+pow(py2-py1,2));
	
	if (fabs(d)<0.01)
	{
		Gamma=1;
	}
	else
	{
		Gamma=signe*d/(cos(m_pApp->m_fAlpha*PI/180)*(m_Ep2.h-m_Ep1.h));
	}
	
	/*
	float
		Gamma;
	if (fabs(m_Ep2.h-m_Ep1.h)<0.01)
		Gamma=1;
	else
		Gamma=m_pApp->m_fCte*(pos_capteur(m_Ep2.uy)-pos_capteur(m_Ep1.uy))/(m_Ep2.h-m_Ep1.h);
	*/
	return Gamma;

}
//________________________________________
float CBkDoc::PointImage(float Ux,float Uy,float Gamma)
{
	//Retourne la position p du point image sur le dtecteur dans l'intervalle [-5 ,5 mm] de ct
	float 
		PI=4*atan(1),
		ux,uy,
		px1,px,py1,py,signe,d,
		p;

	/*
	if (m_OKCor)
		p=m_Ep1.h+m_pApp->m_fCte*(pos_capteur(Uy)-pos_capteur(m_Ep1.uy))/Gamma;
	else
		p=m_Ep1.h+m_pApp->m_fCte*(pos_capteur1(Uy)-pos_capteur1(m_Ep1.uy))/Gamma;
	*/

	//Dtermination de l'axe donnant le signe
	ux=m_Ep2.ux-m_Ep1.ux;
	uy=m_Ep2.uy-m_Ep1.uy;
	if (fabs(ux)>fabs(uy)) 
	{
		if (ux>0) signe=1; else signe=-1;
	}
	else
	{
		if (uy>0) signe=1; else signe=-1;
	}
	
	if (m_pApp->m_OKCor)
	{
		px1=pos_capteur(m_Ep1.ux);
		px=pos_capteur(Ux);
		py1=pos_capteur(m_Ep1.uy);
		py=pos_capteur(Uy);
	}
	else
	{
		px1=pos_capteur1(m_Ep1.ux);
		px=pos_capteur1(Ux);
		py1=pos_capteur1(m_Ep1.uy);
		py=pos_capteur1(Uy);
	}

	d=sqrt(pow(px-px1,2)+pow(py-py1,2));
	p=m_Ep1.h+signe*d/(cos(m_pApp->m_fAlpha*PI/180)*Gamma);
	
	
	return p;
}
//_________________________________________________
void CBkDoc::PositionnerFenetre(short l,short h)
{
	CRect	 MMRect,MMRect1,MMRect2;
	long l1,h1;
	m_pWnd->GetWindowRect(MMRect1);
	l1=MMRect1.right-MMRect1.left;
	h1=MMRect1.bottom-MMRect1.top;
	MMRect.SetRect(0,0,l1,h1);
	MMRect.OffsetRect(-MMRect.left,-MMRect.top);
	m_pWnd->SetWindowPos(NULL,l,h,MMRect.right,MMRect.bottom,SWP_NOZORDER|SWP_DRAWFRAME|SWP_SHOWWINDOW);
	m_pWnd->InvalidateRect(NULL,FALSE);
}
//________________________________________
void CBkDoc::DimensionnerScroll(short l,short h)
{
	//Pointeur sur l'application
	class CBkApp *pApp=((CBkApp*)AfxGetApp());
  CMDIChildWnd * pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	//Pointeur sur la vue
	class CBkView *pView;
	if (pChild) pView=(CBkView*)pChild->GetActiveView(); else pView=NULL;
	if (pView) pView->SetScrollSizes(MM_TEXT, CSize(l,h));
}
