// BkView.cpp : implementation of the CBkView class
#include "stdafx.h"
#include "Bk.h"
#include "BkDoc.h"
#include "BkView.h"
#include "Graphe.h"
#include "math.h"
#include "gl\gl.h"
#include "gl\glu.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
unsigned char threeto8[8] =
{
	0, 0111>>1, 0222>>1, 0333>>1, 0444>>1, 0555>>1, 0666>>1, 0377
};
unsigned char twoto8[4] =
{
	0, 0x55, 0xaa, 0xff
};
unsigned char oneto8[2] =
{
	0, 255
};
static int defaultOverride[13] =
{
	0, 3, 24, 27, 64, 67, 88, 173, 181, 236, 247, 164, 91
};
static PALETTEENTRY defaultPalEntry[20] =
{
	{ 0,   0,   0,    0 },
	{ 0x80,0,   0,    0 },
	{ 0,   0x80,0,    0 },
	{ 0x80,0x80,0,    0 },
	{ 0,   0,   0x80, 0 },
	{ 0x80,0,   0x80, 0 },
	{ 0,   0x80,0x80, 0 },
	{ 0xC0,0xC0,0xC0, 0 },

	{ 192, 220, 192,  0 },
	{ 166, 202, 240,  0 },
	{ 255, 251, 240,  0 },
	{ 160, 160, 164,  0 },

	{ 0x80,0x80,0x80, 0 },
	{ 0xFF,0,   0,    0 },
	{ 0,   0xFF,0,    0 },
	{ 0xFF,0xFF,0,    0 },
	{ 0,   0,   0xFF, 0 },
	{ 0xFF,0,   0xFF, 0 },
	{ 0,   0xFF,0xFF, 0 },
	{ 0xFF,0xFF,0xFF, 0 }
};
//________________________________________
// CBkView
IMPLEMENT_DYNCREATE(CBkView, CScrollView)

BEGIN_MESSAGE_MAP(CBkView, CScrollView)
	//{{AFX_MSG_MAP(CBkView)
	ON_WM_MOUSEMOVE()
	ON_WM_HSCROLL()
	ON_WM_VSCROLL()
	ON_WM_LBUTTONDOWN()
	ON_WM_SIZE()
	ON_WM_LBUTTONUP()
	ON_WM_CONTEXTMENU()
	ON_UPDATE_COMMAND_UI(ID_TILT, OnUpdateTilt)
	ON_COMMAND(ID_TILT, OnTilt)
	ON_UPDATE_COMMAND_UI(ID_CAPTEUR, OnUpdateCapteur)
	ON_COMMAND(ID_CAPTEUR, OnCapteur)
	ON_UPDATE_COMMAND_UI(ID_FIC_TXT, OnUpdateFicTxt)
	ON_COMMAND(ID_FIC_TXT, OnFicTxt)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CScrollView::OnFilePrintPreview)
	//Menus contextuels
	ON_COMMAND(ID__TILT,SupprimerTilt)
	ON_COMMAND(ID__TILT_LAISSER,LaisserTilt)
	ON_COMMAND(ID__CAPTEUR,CapteurPSD)
	ON_COMMAND(ID__CAPTEUR_LINEAIRE,CapteurPSDLineaire)
	ON_COMMAND(ID__CURSEURS,InitCurseurs)
END_MESSAGE_MAP()
//________________________________________
// CBkView construction/destruction
CBkView::CBkView()
{
	m_OKCote=TRUE;
	m_iCurseur=-1;
	//Visu 3D
	m_iPas=2;
	m_pOldPalette=NULL;
}
//________________________________________
CBkView::~CBkView()
{
}
//________________________________________
void CBkView::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	//Menu contextuel -> Activ par bouton droit souris
	//CBkDoc* pDoc=GetDocument(); 
	CMenu menu;
	menu.LoadMenu(IDR_POPUP);
	CMenu* pPopup=menu.GetSubMenu(0);
	if (m_pApp->m_OKTilt)
		menu.EnableMenuItem(ID__TILT_LAISSER,MF_GRAYED);
	else
		menu.EnableMenuItem(ID__TILT,MF_GRAYED);
	if (m_pApp->m_OKCor)
		menu.EnableMenuItem(ID__CAPTEUR,MF_GRAYED);
	else
		menu.EnableMenuItem(ID__CAPTEUR_LINEAIRE,MF_GRAYED);
	if (pPopup!=NULL) pPopup->TrackPopupMenu(TPM_LEFTALIGN|TPM_RIGHTBUTTON,point.x,point.y,this,NULL);
}
//Contextuel______________________________
void CBkView::LaisserTilt()
{
	CBkDoc* pDoc=GetDocument(); 
	m_pApp->m_OKTilt=TRUE;
	pDoc->ConstructionImage();
	pDoc->CalculProfils(pDoc->m_ptPF);
	pDoc->UpdateAllViews(NULL);
}
//Contextuel______________________________
void CBkView::SupprimerTilt()
{
	CBkDoc* pDoc=GetDocument(); 
	m_pApp->m_OKTilt=FALSE;
	pDoc->ConstructionImageSansTilt(pDoc->m_fAlpha,pDoc->m_fBeta,pDoc->m_fOmega);
	pDoc->CalculProfils(pDoc->m_ptPF);
	pDoc->UpdateAllViews(NULL);
}
//Contextuel______________________________
void CBkView::CapteurPSD()
{
	CBkDoc* pDoc=GetDocument(); 
	m_pApp->m_OKCor=TRUE;
	pDoc->m_fGamma=pDoc->CalculGamma();
	pDoc->Def_Plan(&(pDoc->m_fAlpha),&(pDoc->m_fBeta),&(pDoc->m_fOmega),&(pDoc->m_fEcmin),&(pDoc->m_fEcmax),&(pDoc->m_fPara));
	if (m_pApp->m_OKTilt)
		pDoc->ConstructionImage();
	else
		pDoc->ConstructionImageSansTilt(pDoc->m_fAlpha,pDoc->m_fBeta,pDoc->m_fOmega);
	pDoc->CalculProfils(pDoc->m_ptPF);
	pDoc->UpdateAllViews(NULL);
}
//Contextuel______________________________
void CBkView::CapteurPSDLineaire()
{
	CBkDoc* pDoc=GetDocument(); 
	m_pApp->m_OKCor=FALSE;
	pDoc->m_fGamma=pDoc->CalculGamma();
	pDoc->Def_Plan(&(pDoc->m_fAlpha),&(pDoc->m_fBeta),&(pDoc->m_fOmega),&(pDoc->m_fEcmin),&(pDoc->m_fEcmax),&(pDoc->m_fPara));
	if (m_pApp->m_OKTilt)
		pDoc->ConstructionImage();
	else
		pDoc->ConstructionImageSansTilt(pDoc->m_fAlpha,pDoc->m_fBeta,pDoc->m_fOmega);
	pDoc->CalculProfils(pDoc->m_ptPF);
	pDoc->UpdateAllViews(NULL);
}
//Contextuel______________________________
void CBkView::InitCurseurs()
{
	CBkDoc* pDoc=GetDocument(); 
	pDoc->InitCurseursGraphes();
	pDoc->UpdateAllViews(NULL);
}
//________________________________________
BOOL CBkView::PreCreateWindow(CREATESTRUCT& cs)
{
	return CScrollView::PreCreateWindow(cs);
}
//________________________________________
// CBkView drawing
void CBkView::OnDraw(CDC* pDC)
{
	CBkDoc* pDoc=GetDocument();
	CPoint HG,BD;
	HDC hDC;
	HPALETTE hpal;
	CRect rcClient;
	short 
		err,
		l=pDoc->image->endx-pDoc->image->stx+1,
		h=pDoc->image->endy-pDoc->image->sty+1;
	float r;

	if (pDC->IsPrinting())
	{
		float ech=m_pApp->m_fEchImp;
		hDC=pDC->m_hDC;
		pDC->SetMapMode(MM_ISOTROPIC);
		pDC->DPtoLP(rcClient);            
		pDC->SetWindowExt(l,h);
		pDC->SetViewportExt(l*ech,h*ech);
		if (pDoc->m_iType==1)
		{
			//1: Visualisation spot non trait  l'imprimante
			//viewimage(m_hWnd,hDC,&hpal,0,0,pDoc->image);
		}
		else
		if (pDoc->m_iType==2)
		{
			//2: Visu 3D non traite  l'imprimante
		}
		else
		if (pDoc->m_iType==3)
		{
			//3: Visu 3D statique
			viewimage(m_hWnd,hDC,&hpal,0,0,pDoc->image);
		}
		else
		{
			//0: Visualisation acquisition
			HG=pDoc->m_Rect3.TopLeft(),BD=pDoc->m_Rect3.BottomRight();
			if (pDoc->m_iNb1!=0) EchelleCouleurs(pDC,m_hWnd);
			viewimage(m_hWnd,hDC,&hpal,-HG.x,-HG.y,pDoc->image);
			if (pDoc->m_iNb1!=0) Marqueprofil(pDC,pDoc->m_ptPF);
			EcritInfos(pDC);
			//Graphe 1 sous forme de pointeur
			CGraphe *pGraphe1;
			pGraphe1=new CGraphe(pDC,pDoc->m_Rect1);
			pGraphe1->LegendeGraphe("Profil horizontal","x(mm)","h(mm)");
			err=pGraphe1->TraceGraphe(0,1,pDoc->m_fT,pDoc->m_iNb,RGB(255,0,0));	//Graphe 1: colonnes 0 et 1
			if (err==0)
			{
				pGraphe1->ParametresGraphe(pDoc->m_fP1);	//xmi, ymi, xma, yma, echx, echy, xori, yori, factx, facty

				pGraphe1->MetCurseurH(0,pDoc->m_iCurH[0][0],RGB(255,0,255));
				pGraphe1->MetCurseurH(1,pDoc->m_iCurH[0][1],RGB(255,0,255));
				pGraphe1->CotationH(RGB(255,0,255));

				pGraphe1->MetCurseurV(0,pDoc->m_iCurV[0][0],RGB(0,128,64));
				pGraphe1->MetCurseurV(1,pDoc->m_iCurV[0][1],RGB(0,128,64));
				pGraphe1->CotationV(RGB(0,128,64));
				if (pDoc->m_ptMarque[0].x!=-1) pGraphe1->MarqueDePointage(pDoc->m_ptMarque[0],RGB(0,0,0));
			}
			delete pGraphe1;

			//Graphe 1 sous forme de variable
			CGraphe Graphe2(pDC,pDoc->m_Rect2);
			Graphe2.LegendeGraphe("Profil vertical","y(mm)","h(mm)");
			err=Graphe2.TraceGraphe(2,3,pDoc->m_fT,pDoc->m_iNb,RGB(0,0,255));
			if (err==0)
			{
				Graphe2.ParametresGraphe(pDoc->m_fP2);

				Graphe2.MetCurseurH(0,pDoc->m_iCurH[1][0],RGB(255,0,255));
				Graphe2.MetCurseurH(1,pDoc->m_iCurH[1][1],RGB(255,0,255));
				Graphe2.CotationH(RGB(255,0,255));

				Graphe2.MetCurseurV(0,pDoc->m_iCurV[1][0],RGB(0,128,64));
				Graphe2.MetCurseurV(1,pDoc->m_iCurV[1][1],RGB(0,128,64));
				Graphe2.CotationV(RGB(0,128,64));
				if (pDoc->m_ptMarque[1].x!=-1) Graphe2.MarqueDePointage(pDoc->m_ptMarque[1],RGB(0,0,0));
			}
		}
	}
	else
	{
		//Affichage cran
		pDC->DPtoLP(rcClient);            
		if (pDoc->m_iType==2)
		{
			//2: Visualisation 3D live
			/*
			CClientDC dc(this);
			hDC=dc.m_hDC;
			viewimage(m_hWnd,hDC,&hpal,GetScrollPos(SB_HORZ),GetScrollPos(SB_VERT),pDoc->image);
			*/
			
			CClientDC dc1(this);
			Init(&dc1);
			DrawScene();
			Libere(&dc1);
			
		}
		else
		{
			CClientDC dc(this);
			hDC=dc.m_hDC;
			//Ne pas utilliser, sinon scroll ne fonctionne pas!
			//hDC=pDC->m_hDC;
			if (pDoc->m_iType==1)
			{
				//1: Visualisation spot
				viewimage(m_hWnd,hDC,&hpal,GetScrollPos(SB_HORZ),GetScrollPos(SB_VERT),pDoc->image);
			}
			else
			if (pDoc->m_iType==3)
			{
				//3: Visualisation 3D statique
				viewimage(m_hWnd,hDC,&hpal,GetScrollPos(SB_HORZ),GetScrollPos(SB_VERT),pDoc->image);
			}
			else
			{
				//0: Visualisation acquisition
				//pDC->SetBkMode(TRANSPARENT);
				HG=pDoc->m_Rect3.TopLeft(),BD=pDoc->m_Rect3.BottomRight();
				if (pDoc->m_iNb1!=0) EchelleCouleurs(pDC,m_hWnd);
				viewimage(m_hWnd,pDC->m_hDC,&hpal,GetScrollPos(SB_HORZ)-HG.x,GetScrollPos(SB_VERT)-HG.y,pDoc->image);
				if (pDoc->m_iNb1!=0) Marqueprofil(pDC,pDoc->m_ptPF);
				EcritInfos(pDC);
				//Graphe 1 sous forme de pointeur
				CGraphe *pGraphe1;
				pGraphe1=new CGraphe(pDC,pDoc->m_Rect1);
				HG=pDoc->m_Rect1.TopLeft(),BD=pDoc->m_Rect1.BottomRight();
				pGraphe1->LegendeGraphe("Profil horizontal","x(mm)","h(mm)");
				err=pGraphe1->TraceGraphe(0,1,pDoc->m_fT,pDoc->m_iNb,RGB(255,0,0));	//Graphe 1: colonnes 0 et 1
				if (err==0)
				{
					pGraphe1->ParametresGraphe(pDoc->m_fP1);					//xmi, ymi, xma, yma, echx, echy, xori, yori, factx, facty
					pGraphe1->MetCurseurH(0,pDoc->m_iCurH[0][0],RGB(255,0,255));
					pGraphe1->MetCurseurH(1,pDoc->m_iCurH[0][1],RGB(255,0,255));
					if (m_OKCote) r=pGraphe1->CotationH(RGB(255,0,255));						//r: valeur de la cote
					pDoc->m_iCurH[0][0]=pGraphe1->RenvoiCurseurH(0);	//position du curseur 0
					pDoc->m_iCurH[0][1]=pGraphe1->RenvoiCurseurH(1);	//position du curseur 1

					pGraphe1->MetCurseurV(0,pDoc->m_iCurV[0][0],RGB(0,128,64));
					pGraphe1->MetCurseurV(1,pDoc->m_iCurV[0][1],RGB(0,128,64));
					if (m_OKCote) r=pGraphe1->CotationV(RGB(0,128,64));						
					pDoc->m_iCurV[0][0]=pGraphe1->RenvoiCurseurV(0);
					pDoc->m_iCurV[0][1]=pGraphe1->RenvoiCurseurV(1);
					if (pDoc->m_ptMarque[0].x!=-1) pGraphe1->MarqueDePointage(pDoc->m_ptMarque[0],RGB(0,0,0));
				}
				delete pGraphe1;

				//Graphe 2 sous forme de variable
				CGraphe Graphe2(pDC,pDoc->m_Rect2);
				HG=pDoc->m_Rect2.TopLeft(),BD=pDoc->m_Rect2.BottomRight();
				Graphe2.LegendeGraphe("Profil vertical","y(mm)","h(mm)");
				err=Graphe2.TraceGraphe(2,3,pDoc->m_fT,pDoc->m_iNb,RGB(0,0,255));	//Graphe 2: colonnes 2 et 3
				if (err==0)
				{
					Graphe2.ParametresGraphe(pDoc->m_fP2);
					Graphe2.MetCurseurH(0,pDoc->m_iCurH[1][0],RGB(255,0,255));
					Graphe2.MetCurseurH(1,pDoc->m_iCurH[1][1],RGB(255,0,255));
					if (m_OKCote) Graphe2.CotationH(RGB(255,0,255));
					pDoc->m_iCurH[1][0]=Graphe2.RenvoiCurseurH(0);		
					pDoc->m_iCurH[1][1]=Graphe2.RenvoiCurseurH(1);		
					Graphe2.MetCurseurV(0,pDoc->m_iCurV[1][0],RGB(0,128,64));
					Graphe2.MetCurseurV(1,pDoc->m_iCurV[1][1],RGB(0,128,64));
					if (m_OKCote) Graphe2.CotationV(RGB(0,128,64));
					pDoc->m_iCurV[1][0]=Graphe2.RenvoiCurseurV(0);		
					pDoc->m_iCurV[1][1]=Graphe2.RenvoiCurseurV(1);		
					if (pDoc->m_ptMarque[1].x!=-1) Graphe2.MarqueDePointage(pDoc->m_ptMarque[1],RGB(0,0,0));
				}
			}
		}
	}
}
//________________________________________
void CBkView::OnInitialUpdate()
{
	CScrollView::OnInitialUpdate();

	m_pApp=((CBkApp*)AfxGetApp());
	class CBkDoc *pDoc=GetDocument();
	//Mmoriser le pointeur sur la fentre et la vue dans le document
	pDoc->m_pWnd=GetParent();
	short 
		l=m_pApp->m_iL,
		h=m_pApp->m_iH;
	pDoc->DimensionnerFenetre(l,h);
	SetScrollSizes(MM_TEXT,CSize(l,h));
}
//________________________________________
// CBkView printing
BOOL CBkView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CBkView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
}

void CBkView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
}
//________________________________________
// CBkView diagnostics
#ifdef _DEBUG
void CBkView::AssertValid() const
{
	CScrollView::AssertValid();
}
void CBkView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}
CBkDoc* CBkView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CBkDoc)));
	return (CBkDoc*)m_pDocument;
}
#endif //_DEBUG
//________________________________________
// CBkView message handlers
void CBkView::OnMouseMove(UINT nFlags, CPoint point) 
{
	short x,y,n;
	CPoint HG,BD;
	CRect r;
	CBkDoc* pDoc=GetDocument();
	//Coordonnes absolues, il faut tenir compte des barres de dfilement
	x=pDoc->m_iX=point.x+pDoc->m_iXpos;
	y=pDoc->m_iY=point.y+pDoc->m_iYpos;

	if (nFlags==MK_LBUTTON)
	{
		n=CurseurGraphe(x,y);
		if (n>=0) 
		{
			m_iCurseur=n;
		}
		switch (m_iCurseur)
		{
			case 0://1er curseur H, graphe 1
				if (m_OKCote)
				{
					//Les cotes ne sont traces que si l'on relche le bouton de la souris
					//S'il y a cotes, elles sont d'abord supprimmes...
					m_OKCote=FALSE;
					InvalidateRect(pDoc->m_Rect1,TRUE);
				}
				HG=pDoc->m_Rect1.TopLeft();BD=pDoc->m_Rect1.BottomRight();
				r.SetRect(HG.x-30,y-30,BD.x+20,y+30);
				pDoc->m_iCurH[0][0]=y;
				InvalidateRect(r,TRUE);
				//pDoc->UpdateAllViews(this,(LPARAM)(LPCRECT)r);
			break;
			case 1://2me curseur H
				if (m_OKCote)
				{
					m_OKCote=FALSE;
					InvalidateRect(pDoc->m_Rect1,TRUE);
				}
				HG=pDoc->m_Rect1.TopLeft();BD=pDoc->m_Rect1.BottomRight();
				r.SetRect(HG.x-20,y-30,BD.x+20,y+30);
				pDoc->m_iCurH[0][1]=y;
				InvalidateRect(r,TRUE);
			break;
			case 2://1er curseur V
				if (m_OKCote)
				{
					m_OKCote=FALSE;
					InvalidateRect(pDoc->m_Rect1,TRUE);
				}
				HG=pDoc->m_Rect1.TopLeft();BD=pDoc->m_Rect1.BottomRight();
				r.SetRect(x-30,HG.y-20,x+30,BD.y+20);
				pDoc->m_iCurV[0][0]=x;
				InvalidateRect(r,TRUE);
			break;
			case 3://2me curseur V
				if (m_OKCote)
				{
					m_OKCote=FALSE;
					InvalidateRect(pDoc->m_Rect1,TRUE);
				}
				HG=pDoc->m_Rect1.TopLeft();BD=pDoc->m_Rect1.BottomRight();
				r.SetRect(x-30,HG.y-20,x+30,BD.y+20);
				pDoc->m_iCurV[0][1]=x;
				InvalidateRect(r,TRUE);
			break;
			case 4://1er curseur H, graphe 2
				if (m_OKCote)
				{
					m_OKCote=FALSE;
					InvalidateRect(pDoc->m_Rect2,TRUE);
				}
				HG=pDoc->m_Rect2.TopLeft();BD=pDoc->m_Rect2.BottomRight();
				r.SetRect(HG.x-20,y-30,BD.x+20,y+30);
				pDoc->m_iCurH[1][0]=y;
				InvalidateRect(r,TRUE);
			break;
			case 5://2me curseur H
				if (m_OKCote)
				{
					m_OKCote=FALSE;
					InvalidateRect(pDoc->m_Rect2,TRUE);
				}
				HG=pDoc->m_Rect2.TopLeft();BD=pDoc->m_Rect2.BottomRight();
				r.SetRect(HG.x-20,y-30,BD.x+20,y+30);
				pDoc->m_iCurH[1][1]=y;
				InvalidateRect(r,TRUE);
			break;
			case 6://1er curseur V
				if (m_OKCote)
				{
					m_OKCote=FALSE;
					InvalidateRect(pDoc->m_Rect2,TRUE);
				}
				HG=pDoc->m_Rect2.TopLeft();BD=pDoc->m_Rect2.BottomRight();
				r.SetRect(x-30,HG.y-20,x+30,BD.y+20);
				pDoc->m_iCurV[1][0]=x;
				InvalidateRect(r,TRUE);
			break;
			case 7://2me curseur V
				if (m_OKCote)
				{
					m_OKCote=FALSE;
					InvalidateRect(pDoc->m_Rect2,TRUE);
				}
				HG=pDoc->m_Rect2.TopLeft();BD=pDoc->m_Rect2.BottomRight();
				r.SetRect(x-30,HG.y-20,x+30,BD.y+20);
				pDoc->m_iCurV[1][1]=x;
				InvalidateRect(r,TRUE);
			break;
		}
		HG=pDoc->m_Rect3.TopLeft();BD=pDoc->m_Rect3.BottomRight();
		if (x>HG.x && x<BD.x && y>HG.y && y<BD.y)
		{
			//Dans l'image, digitalisation d'une position de profil
			pDoc->m_ptPF.x=x-HG.x;
			pDoc->m_ptPF.y=y-HG.y;
			pDoc->CalculProfils(pDoc->m_ptPF);
			m_OKCote=TRUE;
			//On regnre les 3 fentres: image, profilH et profilV
			InvalidateRect(pDoc->m_Rect1,TRUE);
			InvalidateRect(pDoc->m_Rect2,TRUE);
			InvalidateRect(pDoc->m_Rect3,TRUE);
		}
	}
	/*
	//Souris dans zone graphe 1
	CPoint HG=pDoc->m_Rect1.TopLeft(),BD=pDoc->m_Rect1.BottomRight();
	if (pDoc->m_iX>=HG.x && pDoc->m_iX<=BD.x && pDoc->m_iY>=HG.y && pDoc->m_iY<=BD.y)
	{
		//Souris dans zone graphe 1
	}
	HG=pDoc->m_Rect2.TopLeft();BD=pDoc->m_Rect2.BottomRight();
	if (pDoc->m_iX>=HG.x && pDoc->m_iX<=BD.x && pDoc->m_iY>=HG.y && pDoc->m_iY<=BD.y)
	{
		//Souris dans zone graphe 2
	}
	*/
	CScrollView::OnMouseMove(nFlags, point);
}
//________________________________________
void CBkView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	CBkDoc* pDoc=GetDocument();
	short x,y;
	CPoint HG,BD;

	x=pDoc->m_iX=point.x+pDoc->m_iXpos;
	y=pDoc->m_iY=point.y+pDoc->m_iYpos;
	
	//Quand on lche le bouton gauche dans un graphe, on regnre le trac pour cotes
	HG=pDoc->m_Rect1.TopLeft();BD=pDoc->m_Rect1.BottomRight();
	if (x>=HG.x-30 && x<=BD.x+30 && y>=HG.y-30 && y<=BD.y+30)
	{
		m_OKCote=TRUE;
		InvalidateRect(pDoc->m_Rect1,TRUE);
	}
	HG=pDoc->m_Rect2.TopLeft();BD=pDoc->m_Rect2.BottomRight();

	if (x>=HG.x-30 && x<=BD.x+30 && y>=HG.y-30 && y<=BD.y+30)
	{
		m_OKCote=TRUE;
		InvalidateRect(pDoc->m_Rect2,TRUE);
	}
	m_iCurseur=-1;
	CScrollView::OnLButtonUp(nFlags, point);
}
//________________________________________
void CBkView::OnLButtonDown(UINT nFlags,CPoint point) 
{
	short x,y;
	CPoint HG,BD;
	CBkDoc* pDoc=GetDocument();
	//Coordonnes absolues, il faut tenir compte des barres de dfilement
	x=pDoc->m_iX=point.x+pDoc->m_iXpos;
	y=pDoc->m_iY=point.y+pDoc->m_iYpos;
	HG=pDoc->m_Rect3.TopLeft();BD=pDoc->m_Rect3.BottomRight();
	if (x>HG.x && x<BD.x && y>HG.y && y<BD.y)
	{
		//Dans l'image, digitalisation d'une position de profil
		pDoc->m_ptPF.x=x-HG.x;
		pDoc->m_ptPF.y=y-HG.y;
		pDoc->CalculProfils(pDoc->m_ptPF);
		m_OKCote=TRUE;
		//pDoc->UpdateAllViews(NULL);
		InvalidateRect(pDoc->m_Rect1,TRUE);
		InvalidateRect(pDoc->m_Rect2,TRUE);
		InvalidateRect(pDoc->m_Rect3,TRUE);
	}
	HG=pDoc->m_Rect1.TopLeft();BD=pDoc->m_Rect1.BottomRight();
	if (x>HG.x && x<BD.x && y>HG.y && y<BD.y)
	{
		//Marque de pointage dans profil H
		pDoc->m_ptMarque[0].x=x-HG.x;
		pDoc->m_ptMarque[0].y=y-HG.y;
	}
	HG=pDoc->m_Rect2.TopLeft();BD=pDoc->m_Rect2.BottomRight();
	if (x>HG.x && x<BD.x && y>HG.y && y<BD.y)
	{
		//Marque de pointage dans profil V
		pDoc->m_ptMarque[1].x=x-HG.x;
		pDoc->m_ptMarque[1].y=y-HG.y;
	}
	CScrollView::OnLButtonDown(nFlags, point);
}
//________________________________________
void CBkView::OnHScroll(UINT nSBCode, UINT nPos,CScrollBar* pScrollBar) 
{
	CBkDoc* pDoc=GetDocument();
	pDoc->m_iXpos=GetScrollPos(SB_HORZ);
	pDoc->m_iYpos=GetScrollPos(SB_VERT);
	CScrollView::OnHScroll(nSBCode, nPos, pScrollBar);
}
//________________________________________
void CBkView::OnVScroll(UINT nSBCode, UINT nPos,CScrollBar* pScrollBar) 
{
	CBkDoc* pDoc=GetDocument();
	pDoc->m_iXpos=GetScrollPos(SB_HORZ);
	pDoc->m_iYpos=GetScrollPos(SB_VERT);
	CScrollView::OnVScroll(nSBCode, nPos, pScrollBar);
}
//________________________________________
void CBkView::OnSize(UINT nType,int cx,int cy) 
{
	CScrollView::OnSize(nType, cx, cy);
	//Visualisation 3D______________________
	if(cy>0 && GetDocument()->m_iType==2)
  {    
		//Taille fentre OpenGl
		glViewport(0,0,cx,cy);
    if((m_oldRect.right > cx) || (m_oldRect.bottom > cy)) RedrawWindow();
    m_oldRect.right=cx;
    m_oldRect.bottom=cy;
		//Modification de la matrice de projection
    glMatrixMode(GL_PROJECTION);
		//Vider la matrice de projection
    glLoadIdentity();
		//Cration matrice de vision en perspective
    gluPerspective(45.0f, (GLdouble)cx/cy,3.0f,7.0f);
    glMatrixMode(GL_MODELVIEW);
  }
	//______________________________________
	
	CBkDoc* pDoc=GetDocument();
	pDoc->m_iXpos=GetScrollPos(SB_HORZ);
	pDoc->m_iYpos=GetScrollPos(SB_VERT);
}
//________________________________________
short CBkView::CurseurGraphe(short x,short y) 
{
	short
		zone=10,
		ch0,ch1,ch2,ch3,cv0,cv1,cv2,cv3,
		n=-1;
	CString z;

	CBkDoc* pDoc=GetDocument();
	//Recherche si souris accroche  un curseur
	ch0=pDoc->m_iCurH[0][0];ch1=pDoc->m_iCurH[0][1];
	cv0=pDoc->m_iCurV[0][0];cv1=pDoc->m_iCurV[0][1];
	ch2=pDoc->m_iCurH[1][0];ch3=pDoc->m_iCurH[1][1];
	cv2=pDoc->m_iCurV[1][0];cv3=pDoc->m_iCurV[1][1];

	//Souris dans zone graphe 1
	CPoint HG=pDoc->m_Rect1.TopLeft(),BD=pDoc->m_Rect1.BottomRight();
	if (y>=ch0-zone && y<=ch0+zone && x>=BD.x-zone && x<=BD.x+zone) n=0;//Premier curseur H
	if (y>=ch1-zone && y<=ch1+zone && x>=BD.x-zone && x<=BD.x+zone) n=1;//2me curseur H
	if (x>=cv0-zone && x<=cv0+zone && y>=HG.y-zone && y<=HG.y+zone) n=2;//Premier curseur V
	if (x>=cv1-zone && x<=cv1+zone && y>=HG.y-zone && y<=HG.y+zone) n=3;//2me curseur V

	//Souris dans zone graphe 2
	HG=pDoc->m_Rect2.TopLeft();BD=pDoc->m_Rect2.BottomRight();
	if (y>=ch2-zone && y<=ch2+zone && x>=BD.x-zone && x<=BD.x+zone) n=4;//Premier curseur H
	if (y>=ch3-zone && y<=ch3+zone && x>=BD.x-zone && x<=BD.x+zone) n=5;//2me curseur H
	if (x>=cv2-zone && x<=cv2+zone && y>=HG.y-zone && y<=HG.y+zone) n=6;//Premier curseur V
	if (x>=cv3-zone && x<=cv3+zone && y>=HG.y-zone && y<=HG.y+zone) n=7;//2me curseur V

	return n;
}
//________________________________________
void CBkView::EchelleCouleurs(CDC *pDC,HWND hwnd) 
{
	CBkDoc* pDoc=GetDocument();
	CPen plume,*oldPen;
  plume.CreatePen(PS_SOLID,1,RGB(0,0,0));
	oldPen=pDC->SelectObject(&plume);
	CFont fnt,*oldFont;
	COLORREF clrOld;
	CString s;
	short i,j,h,l;
	imgdes im;
	HDC hDC=pDC->m_hDC;
	HPALETTE hpal;
	float H;
	long w;

	fnt.CreateFont(15,0,0,0,FW_MEDIUM,FALSE,FALSE,FALSE,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,"Arial");
	oldFont=pDC->SelectObject(&fnt);	  
	pDC->SetTextAlign(TA_LEFT|TA_BASELINE);
	clrOld=pDC->SetTextColor(RGB(0,0,0));
	CPoint HG=pDoc->m_Rect5.TopLeft(),BD=pDoc->m_Rect5.BottomRight();
	//Rectangle extrieur
	pDC->Rectangle(pDoc->m_Rect5);
	l=20;
	h=BD.y-HG.y;
	allocimage(&im,l,h,24);
	
	for (i=0;i<=h;i++)
	{
		H=pDoc->m_fHmin+i*(pDoc->m_fHmax-pDoc->m_fHmin)/h;
		w=pDoc->Couleur(H,pDoc->m_fHmin,pDoc->m_fHmax);
		for (j=0;j<l;j++) setpixelcolor(&im,j,h-i,w);
	}
	for (i=0;i<=h;i=i+h/10)
	{
		H=pDoc->m_fHmin+i*(pDoc->m_fHmax-pDoc->m_fHmin)/h;
		if (fabs(H)<100)
		{
			H=pDoc->m_fHmin+i*(pDoc->m_fHmax-pDoc->m_fHmin)/h;
			s.Format("%+1.2f",H);
			pDC->TextOut(HG.x+l+15,HG.y+(h-i)+5,s);
		}
		
	}
	
	viewimage(hwnd,hDC,&hpal,-HG.x,-HG.y,&im);

	freeimage(&im);
	pDC->SelectObject(oldPen);        
	plume.DeleteObject();        
	pDC->SelectObject(oldFont);        
	fnt.DeleteObject();
	pDC->SetTextColor(clrOld);

}
//________________________________________
void CBkView::Marqueprofil(CDC *pDC,CPoint p) 
{
	//Trac de la croix digitalise dans l'image pour visualisation de profils
	CBkDoc* pDoc=GetDocument();
	CPen plume,*oldPen;
	CFont fnt,*oldFont;
	COLORREF clrOld;
	float x,y,H;
	CString s;
	CPoint HG=pDoc->m_Rect3.TopLeft(),BD=pDoc->m_Rect3.BottomRight();
  plume.CreatePen(PS_SOLID,1,RGB(0,0,0));
	oldPen=pDC->SelectObject(&plume);        
	fnt.CreateFont(14,0,0,0,FW_MEDIUM,FALSE,FALSE,FALSE,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,"Arial");
	oldFont=pDC->SelectObject(&fnt);	  
	pDC->SetTextAlign(TA_CENTER|TA_BASELINE);
	clrOld=pDC->SetTextColor(RGB(255,255,255));

	pDC->MoveTo(HG.x+p.x,HG.y);
	pDC->LineTo(HG.x+p.x,BD.y);
	pDC->MoveTo(HG.x,HG.y+p.y);
	pDC->LineTo(BD.x,HG.y+p.y);
	pDC->Arc(HG.x+p.x-3,HG.y+p.y-3,HG.x+p.x+3,HG.y+p.y+3,HG.x+p.x-3,0,HG.y+p.x-3,0);
	H=pDoc->Altitude(pDoc->image,p.x,p.y,pDoc->m_fHmin,pDoc->m_fHmax);
	s.Format("h(mm):%1.3f",H);
	long w=pDC->SetBkColor(0);
	pDC->TextOut(HG.x+p.x,HG.y+p.y-10,s);
	pDC->SetBkColor(w);
	pDC->SelectObject(oldPen);        
	plume.DeleteObject();        
	pDC->SelectObject(oldFont);        
	fnt.DeleteObject();
	pDC->SetTextColor(clrOld);
}
//________________________________________
void CBkView::EcritInfos(CDC *pDC)
{
	//Ecriture des informations dans m_Rect4
	CBkDoc* pDoc=GetDocument();
	CPen plume,*oldPen;
  plume.CreatePen(PS_SOLID,1,RGB(0,0,0));
	oldPen=pDC->SelectObject(&plume);
	CFont fnt,fnt1,*oldFont;
	COLORREF clrOld;
	CString s;
	short h,l;
	float r,r1;
	fnt.CreateFont(15,0,0,0,FW_MEDIUM,FALSE,FALSE,FALSE,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,"Arial");
	fnt1.CreateFont(15,0,0,0,FW_BOLD,FALSE,FALSE,FALSE,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,"Arial");
	oldFont=pDC->SelectObject(&fnt1);	  
	pDC->SetTextAlign(TA_LEFT|TA_BASELINE);
	clrOld=pDC->SetTextColor(RGB(0,0,255));
	CPoint HG=pDoc->m_Rect4.TopLeft(),BD=pDoc->m_Rect4.BottomRight();
	//Rectangle extrieur
	pDC->Rectangle(pDoc->m_Rect4);
	h=HG.y+15;
	l=HG.x+10;
	s.Format("Analyse:");
	pDC->TextOut(l,h,s);h=h+15;
	pDC->SelectObject(&fnt);
	pDC->SetTextColor(RGB(0,0,0));
	s.Format("Dimensions du scanning(mm): %1.1f x %1.1f",m_pApp->m_fDx,m_pApp->m_fDy);
	pDC->TextOut(l,h,s);h=h+15;
	s.Format("Pas du scanning(mm): %1.1f",m_pApp->m_fPas);
	pDC->TextOut(l,h,s);h=h+15;
	if (m_pApp->m_OKCor)
		s.Format("Tenir compte du dfaut de linarit capteur: OUI");
	else
		s.Format("Tenir compte du dfaut de linarit capteur: NON");
	pDC->TextOut(l,h,s);h=h+15;

	s.Format("alpha(): %1.0f, gamma: %1.2f",m_pApp->m_fAlpha,pDoc->m_fGamma);
	pDC->TextOut(l,h,s);h=h+15;

	pDC->SelectObject(&fnt1);
	pDC->SetTextColor(RGB(0,0,255));
	s.Format("Etalonnage - Point n1:");
	pDC->TextOut(l,h,s);h=h+15;
	pDC->SelectObject(&fnt);
	pDC->SetTextColor(RGB(0,0,0));
	if (m_pApp->m_OKCor)
	{
		r=pDoc->pos_capteur(pDoc->m_Ep1.ux);
		r1=pDoc->pos_capteur(pDoc->m_Ep1.uy);
	}
	else
	{
		r=pDoc->pos_capteur1(pDoc->m_Ep1.ux);
		r1=pDoc->pos_capteur1(pDoc->m_Ep1.uy);
	}
	s.Format("h1(mm): %1.2f, ux1(V): %1.2f, uy1(V): %1.2f, px1(mm): %1.1f, py1(mm): %1.1f",pDoc->m_Ep1.h,pDoc->m_Ep1.ux,pDoc->m_Ep1.uy,r,r1);
	pDC->TextOut(l,h,s);h=h+15;
	pDC->SelectObject(&fnt1);
	pDC->SetTextColor(RGB(0,0,255));
	s.Format("Etalonnage - Point n2:");
	pDC->TextOut(l,h,s);h=h+15;
	pDC->SelectObject(&fnt);
	pDC->SetTextColor(RGB(0,0,0));
	if (m_pApp->m_OKCor)
	{
		r=pDoc->pos_capteur(pDoc->m_Ep2.ux);
		r1=pDoc->pos_capteur(pDoc->m_Ep2.uy);
	}
	else
	{
		r=pDoc->pos_capteur1(pDoc->m_Ep2.ux);
		r1=pDoc->pos_capteur1(pDoc->m_Ep2.uy);
	}

	s.Format("h2(mm): %1.2f, ux2(V): %1.2f, uy2(V): %1.2f, px2(mm): %1.1f, py2(mm): %1.1f",pDoc->m_Ep2.h,pDoc->m_Ep2.ux,pDoc->m_Ep2.uy,r,r1);
	pDC->TextOut(l,h,s);h=h+15;

	pDC->SelectObject(&fnt1);
	pDC->SetTextColor(RGB(0,0,255));
	s.Format("Rsultats mtrologiques:");
	pDC->TextOut(l,h,s);h=h+15;
	pDC->SelectObject(&fnt);
	pDC->SetTextColor(RGB(0,0,0));
	s.Format("TILT - alpha(rad): %1.3f, beta(rad): %1.3f",pDoc->m_fAlpha,pDoc->m_fBeta);
	pDC->TextOut(l,h,s);h=h+15;
	if (m_pApp->m_OKTilt) s.Format("Tilt supprim: NON"); else s.Format("Tilt supprim: OUI");
	pDC->TextOut(l,h,s);h=h+15;
	s.Format("Dfaut de paralllisme(mm): %1.3f",pDoc->m_fPara);
	pDC->TextOut(l,h,s);h=h+15;

	if (pDoc->m_fEcmax==1e10 || pDoc->m_fEcmin==1e10) r=0; else r=pDoc->m_fEcmax-pDoc->m_fEcmin;
	s.Format("Dfaut de planit(mm): %1.3f",r);
	pDC->TextOut(l,h,s);h=h+15;

	pDC->SelectObject(oldPen);        
	plume.DeleteObject();        
	pDC->SelectObject(oldFont);        
	fnt.DeleteObject();
	fnt1.DeleteObject();
	pDC->SetTextColor(clrOld);
}
//________________________________________
void CBkView::OnUpdateTilt(CCmdUI* pCmdUI) 
{
	if (m_pApp->m_OKTilt) pCmdUI->SetCheck(FALSE); else pCmdUI->SetCheck(TRUE);
}
//________________________________________
void CBkView::OnTilt() 
{
	if (m_pApp->m_OKTilt) SupprimerTilt(); else LaisserTilt();
}
//________________________________________
void CBkView::OnUpdateCapteur(CCmdUI* pCmdUI) 
{
	if (m_pApp->m_OKCor) pCmdUI->SetCheck(TRUE); else pCmdUI->SetCheck(FALSE);
}
//________________________________________
void CBkView::OnCapteur() 
{
	if (m_pApp->m_OKCor) CapteurPSDLineaire(); else CapteurPSD();
}
//Visu3D__________________________________
void CBkView::Init(CDC *pDC)
{
	PIXELFORMATDESCRIPTOR pfd;
	int         n;
	HGLRC       hrc;
	GLfloat     fMaxObjSize, fAspect;
	GLfloat     fNearPlane, fFarPlane;


	if (!bSetupPixelFormat(pDC))
		return;

	n=::GetPixelFormat(pDC->GetSafeHdc());
	::DescribePixelFormat(pDC->GetSafeHdc(),n,sizeof(pfd),&pfd);

	//CreateRGBPalette(pDC);

	hrc=wglCreateContext(pDC->GetSafeHdc());
	wglMakeCurrent(pDC->GetSafeHdc(),hrc);

	GetClientRect(&m_oldRect);
	glClearDepth(1.0f);
	glEnable(GL_DEPTH_TEST);

	if (m_oldRect.bottom)
		fAspect = (GLfloat)m_oldRect.right/m_oldRect.bottom;
	else    // don't divide by zero, not that we should ever run into that...
		fAspect = 1.0f;

	fNearPlane=3.0f;
	fFarPlane=7.0f;
	fMaxObjSize=3.0f;
	m_pApp->m_fRadius=fNearPlane + fMaxObjSize/2.0f;
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluPerspective(45.0f,fAspect,fNearPlane,fFarPlane);
  glMatrixMode(GL_MODELVIEW);
}
//________________________________________
void CBkView::Libere(CDC *pDC)
{
	HGLRC hrc;
	hrc=::wglGetCurrentContext();
	::wglMakeCurrent(NULL,NULL);
	if (hrc) ::wglDeleteContext(hrc);
	if (m_pOldPalette) pDC->SelectPalette(m_pOldPalette,FALSE);
}
//________________________________________
BOOL CBkView::bSetupPixelFormat(CDC *pDC)
{
	static PIXELFORMATDESCRIPTOR pfd =
	{
		sizeof(PIXELFORMATDESCRIPTOR),  // size of this pfd
		1,                              // version number
		PFD_DRAW_TO_WINDOW |            // support window
		  PFD_SUPPORT_OPENGL |          // support OpenGL
		  PFD_DOUBLEBUFFER,             // double buffered
		PFD_TYPE_RGBA,                  // RGBA type
		24,                             // 24-bit color depth
		0, 0, 0, 0, 0, 0,               // color bits ignored
		0,                              // no alpha buffer
		0,                              // shift bit ignored
		0,                              // no accumulation buffer
		0, 0, 0, 0,                     // accum bits ignored
		32,                             // 32-bit z-buffer
		0,                              // no stencil buffer
		0,                              // no auxiliary buffer
		PFD_MAIN_PLANE,                 // main layer
		0,                              // reserved
		0, 0, 0                         // layer masks ignored
	};
	int pixelformat;

	if ((pixelformat=ChoosePixelFormat(pDC->GetSafeHdc(),&pfd))==0)
	{
		AfxMessageBox("ChoosePixelFormat failed");
		return FALSE;
	}
	if (SetPixelFormat(pDC->GetSafeHdc(),pixelformat,&pfd)==FALSE)
	{
		AfxMessageBox("SetPixelFormat failed");
		return FALSE;
	}
	return TRUE;
}
//________________________________________
void CBkView::DrawScene()
{
	class CBkDoc *pDoc=GetDocument();
	short i,j,l,h;
	long w,w1;
	float r,v,b,H;

  if(m_pApp->m_bBusy==FALSE)
  {  
	m_pApp->m_bBusy=TRUE;
  //Couleur de vidage
	glClearColor(0.0f, 0.0f, 0.0f, 1.0f);
	//Vidage fentre
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	//Fait descendre d'un niveau toutes les matrices de la pile. Voir fonction OnSize
  glPushMatrix();

  glTranslatef(0.0f, 0.0f,-m_pApp->m_fRadius);
	glRotatef(m_pApp->m_fAngleX, 1.0f, 0.0f, 0.0f);
  glRotatef(m_pApp->m_fAngleY, 0.0f, 1.0f, 0.0f);
  glRotatef(m_pApp->m_fAngleZ, 0.0f, 0.0f, 1.0f);
	if (m_iPas<1) m_iPas=1;
	if (m_iPas>2) m_iPas=2;

	glBegin(GL_POINTS);

	l=pDoc->image->endx-pDoc->image->stx+1;
	h=pDoc->image->endy-pDoc->image->sty+1;

	for(i=5;i<l-5;i=i+m_iPas)
	{
		for (j=5;j<h-5;j=j+m_iPas)
		{
			H=pDoc->Altitude(pDoc->image,i,j,pDoc->m_fHmin,pDoc->m_fHmax);
			H=255.0*H/(pDoc->m_fHmax-pDoc->m_fHmin);
			w=getpixelcolor(pDoc->image,i,j);
			r=1.0*(w&255); 
			v=1.0*((w/256)&255); 
			b=1.0*((w/65536)&255);
			r=r/255;
			v=v/255;
			b=b/255;
			
			if (w==0)
				glColor3f(0,0,0);
			else
				glColor3f(r,v,b);

			glVertex3f((float)0.005*(i-l/2),(float) 0.005*(j-h/2),(float)0.0075*H);
		}
	}
	glEnd();
  glPopMatrix();
  glFinish();
  SwapBuffers(wglGetCurrentDC());
  m_pApp->m_bBusy=FALSE;
	}
}
//_________________________________________
void CBkView::CreateRGBPalette(CDC *pDC)
{
	PIXELFORMATDESCRIPTOR pfd;
	LOGPALETTE *pPal;
	int n,i;
	n=::GetPixelFormat(pDC->GetSafeHdc());
	::DescribePixelFormat(pDC->GetSafeHdc(), n, sizeof(pfd), &pfd);
	if (pfd.dwFlags & PFD_NEED_PALETTE)
	{
		n=1<<pfd.cColorBits;
		pPal=(PLOGPALETTE) new char[sizeof(LOGPALETTE) + n * sizeof(PALETTEENTRY)];
		ASSERT(pPal!=NULL);
		pPal->palVersion=0x300;
		pPal->palNumEntries=n;
		for (i=0; i<n; i++)
		{
			pPal->palPalEntry[i].peRed =
			ComponentFromIndex(i, pfd.cRedBits, pfd.cRedShift);
			pPal->palPalEntry[i].peGreen =
			ComponentFromIndex(i, pfd.cGreenBits, pfd.cGreenShift);
			pPal->palPalEntry[i].peBlue =
			ComponentFromIndex(i, pfd.cBlueBits, pfd.cBlueShift);
			pPal->palPalEntry[i].peFlags = 0;
		}
		/* fix up the palette to include the default GDI palette */
		if ((pfd.cColorBits == 8)                           &&
			(pfd.cRedBits   == 3) && (pfd.cRedShift   == 0) &&
			(pfd.cGreenBits == 3) && (pfd.cGreenShift == 3) &&
			(pfd.cBlueBits  == 2) && (pfd.cBlueShift  == 6)
		   )
		{
			for (i = 1 ; i <= 12 ; i++)
				pPal->palPalEntry[defaultOverride[i]] = defaultPalEntry[i];
		}
		m_cPalette.CreatePalette(pPal);
		delete pPal;
		m_pOldPalette = pDC->SelectPalette(&m_cPalette, FALSE);
		pDC->RealizePalette();
	}
}
//________________________________________
unsigned char CBkView::ComponentFromIndex(int i, UINT nbits, UINT shift)
{
	unsigned char val;
	val = (unsigned char) (i >> shift);
	switch (nbits)
	{

	case 1:
		val &= 0x1;
		return oneto8[val];
	case 2:
		val &= 0x3;
		return twoto8[val];
	case 3:
		val &= 0x7;
		return threeto8[val];
	default:
		return 0;
	}
}
//________________________________________
void CBkView::OnUpdateFicTxt(CCmdUI* pCmdUI) 
{
	//On invalide la rubrique si m_iNb1=0
	if (GetDocument()->m_iNb1==0)	pCmdUI->Enable(FALSE);
}
//________________________________________
void CBkView::OnFicTxt() 
{
	//Sauver fichier compatible Excel
	CString s;
	short k;
	CBkDoc* pDoc=GetDocument();
	static char BASED_CODE szFilter[] = "Fichiers texte (*.txt) | *.txt |Tous les fichiers (*.*) | *.* ||";
	//CFileDialog dlg(FALSE,"",pDoc->m_sNomFicTxt,0,szFilter,NULL) ;
	CFileDialog dlg(FALSE,"","*.txt",0,szFilter,NULL) ;

	if (dlg.DoModal()==IDOK)
	{
		//Affectation nom du fichier
		//pDoc->m_sNomFicTxt=dlg.GetPathName();
		//Ouverture du fichier
		CFile fic;
		BOOL ok;
		unsigned int j=IDYES;     
		CFileException p_Error;
		//On regarde si le fichier existe dj
		ok=fic.Open(/*pDoc->m_sNomFicTxt*/dlg.GetPathName(),CFile::modeRead,&p_Error);
		if (ok)
		{
			j=AfxMessageBox("Ce fichier existe dj. Voulez-vous le remplacer ?",MB_YESNO);
		} 
		if (j==IDYES)
		{
			if (ok) fic.Close();
			//Ouverture du fichier en mode CREATE			
			ok=fic.Open(dlg.GetPathName(),CFile::modeWrite|CFile::modeCreate,&p_Error);
			if (!ok)
			{
				AfxMessageBox("Erreur d'ouverture du fichier en mode cration !");
			}
			else
			{
				//Ecriture des donnes dans le fichier
				s.Format("Acquisition P.S.D.\r\n");
				fic.Write(s,s.GetLength());

				s.Format("%8s\t%5.1f\r\n\r\n","Alpha()",m_pApp->m_fAlpha);
				fic.Write(s,s.GetLength());

				s.Format("Etalonnage:\r\n");
				fic.Write(s,s.GetLength());
				s.Format("%8s\t%5.1f\r\n","Gamma",pDoc->m_fGamma);
				fic.Write(s,s.GetLength());
				s.Format("%6s\t%6s\t%6s\t%6s\t%6s\r\n","x1(mm)","y1(mm)","h1(mm)","u1x(V)","u1y(V)");
				fic.Write(s,s.GetLength());
				s.Format("%6.1f\t%6.1f\t%6.2f\t%6.3f\t%6.3f\r\n",pDoc->m_Ep1.x,pDoc->m_Ep1.y,pDoc->m_Ep1.h,pDoc->m_Ep1.ux,pDoc->m_Ep1.uy);
				fic.Write(s,s.GetLength());
				s.Format("%6s\t%6s\t%6s\t%6s\t%6s\r\n","x2(mm)","y2(mm)","h2(mm)","u2x(V)","u2y(V)");
				fic.Write(s,s.GetLength());
				s.Format("%6.1f\t%6.1f\t%6.2f\t%6.3f\t%6.3f\r\n\r\n",pDoc->m_Ep2.x,pDoc->m_Ep2.y,pDoc->m_Ep2.h,pDoc->m_Ep2.ux,pDoc->m_Ep2.uy);
				fic.Write(s,s.GetLength());

				s.Format("%6s\t%6s\t%6s\t%6s\t%6s\t%6s\r\n","N pt","x(mm)","y(mm)","ux(V)","uy(V)","h(mm)");
				fic.Write(s,s.GetLength());

				for (k=0;k<pDoc->m_iNb1;k++)
				{  
					if (k<pDoc->m_iNbMax1)
					{        
						s.Format("%6u\t%6.1f\t%6.1f\t%6.3f\t%6.3f\t%6.2f\r\n",k+1,pDoc->m_fM[k][0],pDoc->m_fM[k][1],pDoc->m_fM[k][2],pDoc->m_fM[k][3],pDoc->PointImage(pDoc->m_fM[k][2],pDoc->m_fM[k][3],pDoc->m_fGamma));
						if (pDoc->m_fM[k][1]!=1e10) fic.Write(s,s.GetLength());
					}
				}
			}	
			fic.Close();
		}
	}
}		
	

