// etaldlg.cpp : implementation file
#include "stdafx.h"
#include "bk.h"
#include "etaldlg.h"
#include "bkdoc.h"
#include "eurosmart.h"
#include "mm2000.h"
#include <math.h>

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CEtalDlg dialog
CEtalDlg::CEtalDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEtalDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEtalDlg)
	m_fH1 = 0;
	m_fH2 = 0;
	m_fGamma = 0;
	m_sTexte = _T("");
	m_fAlpha = 0.0f;
	//}}AFX_DATA_INIT
}
//________________________________________
void CEtalDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEtalDlg)
	DDX_Control(pDX, IDC_Y_PLUS, m_btnYplus);
	DDX_Control(pDX, IDCANCEL, m_btnCancel);
	DDX_Control(pDX, IDPOINT2, m_btnPt2);
	DDX_Control(pDX, IDPOINT1, m_btnPt1);
	DDX_Control(pDX, IDC_Y_MOINS, m_btnYmoins);
	DDX_Control(pDX, IDC_X_PLUS, m_btnXplus);
	DDX_Control(pDX, IDC_X_MOINS, m_btnXmoins);
	DDX_Control(pDX, IDC_STOP, m_btnStop);
	DDX_Control(pDX, IDAUTOMATIQUE, m_btnAuto);
	DDX_Text(pDX, IDC_H1, m_fH1);
	DDX_Text(pDX, IDC_H2, m_fH2);
	DDX_Text(pDX, IDC_GAMMA, m_fGamma);
	DDX_Text(pDX, IDC_STATIC_TEXTE, m_sTexte);
	DDX_Text(pDX, IDC_ALPHA, m_fAlpha);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CEtalDlg, CDialog)
	//{{AFX_MSG_MAP(CEtalDlg)
	ON_BN_CLICKED(IDAUTOMATIQUE, OnAutomatique)
	ON_EN_KILLFOCUS(IDC_GAMMA, OnKillfocusGamma)
	ON_EN_KILLFOCUS(IDC_H1, OnKillfocusH1)
	ON_EN_KILLFOCUS(IDC_H2, OnKillfocusH2)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_BN_CLICKED(IDC_X_MOINS, OnXMoins)
	ON_BN_CLICKED(IDC_X_PLUS, OnXPlus)
	ON_BN_CLICKED(IDC_Y_MOINS, OnYMoins)
	ON_BN_CLICKED(IDPOINT1, OnPoint1)
	ON_BN_CLICKED(IDPOINT2, OnPoint2)
	ON_BN_CLICKED(IDC_Y_PLUS, OnYplus)
	ON_WM_TIMER()
	ON_EN_KILLFOCUS(IDC_ALPHA, OnKillfocusAlpha)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CEtalDlg message handlers
BOOL CEtalDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	m_pApp=((CBkApp*)AfxGetApp());
	CMDIChildWnd *pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) m_pDoc=(CBkDoc*)pChild->GetActiveDocument(); else m_pDoc=NULL;
	m_pMM2000=new CMM2000();

	float u;
	m_pEuro=new CEurosmart();
  u=m_pEuro->LitTension(1,1,2);

	if (u==1e10 || m_pMM2000->TP(1)==1e10)
	{
		m_btnAuto.EnableWindow(FALSE);
		m_btnXplus.EnableWindow(FALSE);
		m_btnXmoins.EnableWindow(FALSE);
		m_btnYplus.EnableWindow(FALSE);
		m_btnYmoins.EnableWindow(FALSE);
		m_btnStop.EnableWindow(FALSE);
		m_btnPt1.EnableWindow(FALSE);
		m_btnPt2.EnableWindow(FALSE);
		m_sTexte="Erreur carte MM2000 ou/et Eurosmart dtecte !";
	}
	else
	{
		//On valide/invalide les boutons
		if (m_pDoc->m_iEtal==3) m_btnAuto.EnableWindow(TRUE); else m_btnAuto.EnableWindow(FALSE);
		m_btnXplus.EnableWindow(TRUE);
		m_btnXmoins.EnableWindow(TRUE);
		m_btnYplus.EnableWindow(TRUE);
		m_btnYmoins.EnableWindow(TRUE);
		//On invalide le bouton STOP
		m_btnStop.EnableWindow(FALSE);

		if (m_pDoc->m_iEtal==3)
			m_sTexte="Vous pouvez faire un talonnage\nautomatique...";
		else	
			m_sTexte=("- Se placer sur pts. d'talonnage,\n- Spcifier h1 et h2,\n- Cliquer valider point 1 et point 2.");
		//Pas d'axe en mouvement
		m_cNoAxeMvt=0;
		//On initialise
		m_pMM2000->SV(0,m_pMM2000->m_fVit);
	}
	//Paramtres par dfaut
	m_fGamma=m_pDoc->m_fGamma;  
	m_fH1=m_pDoc->m_Ep1.h;          
	m_fH2=m_pDoc->m_Ep2.h;          
	m_fAlpha=m_pApp->m_fAlpha;          
	UpdateData(FALSE);
	return TRUE;
}
//________________________________________
void CEtalDlg::OnAutomatique()
{
	//Etalonnage automatique, on n'y rentre pas avant 
	//d'avoir fait un talonnage manuel
	short i,j;
	float ux,uy;
	j=1;
	for (i=0;i<m_pApp->m_radioMoy;i++)
	{   
		j=j*2*2;
	}
	UpdateData(TRUE);
	//On valide/invalide les boutons
	m_btnXplus.EnableWindow(FALSE);
	m_btnXmoins.EnableWindow(FALSE);
	m_btnYplus.EnableWindow(FALSE);
	m_btnYmoins.EnableWindow(FALSE);
	m_btnCancel.EnableWindow(FALSE);      
	m_btnPt1.EnableWindow(FALSE);      
	m_btnPt2.EnableWindow(FALSE);      
	m_btnAuto.EnableWindow(FALSE);
	//Cycle d'talonnage
	m_pMM2000->MA(1,m_pDoc->m_Ep1.x);
	m_pMM2000->MA(2,m_pDoc->m_Ep1.y);
	m_pMM2000->WS(0);
  //Temporisation  
  Sleep(1500);
  //Lecture tension
  m_pDoc->m_Ep1.ux=m_pEuro->LitTension(0,1,j);
  m_pDoc->m_Ep1.uy=m_pEuro->LitTension(1,1,j);

	m_pMM2000->MA(1,m_pDoc->m_Ep2.x);
	m_pMM2000->MA(2,m_pDoc->m_Ep2.y);
	m_pMM2000->WS(0);

  //Temporisation  
  Sleep(1500);

  //Lecture tension
  m_pDoc->m_Ep2.ux=m_pEuro->LitTension(0,1,j);
  m_pDoc->m_Ep2.uy=m_pEuro->LitTension(1,1,j);

	//Calcul de gamma
	m_pDoc->m_fGamma=m_fGamma=m_pDoc->CalculGamma();

	m_btnXplus.EnableWindow(TRUE);
	m_btnXmoins.EnableWindow(TRUE);
	m_btnYplus.EnableWindow(TRUE);
	m_btnYmoins.EnableWindow(TRUE);
	m_btnCancel.EnableWindow(TRUE);      
	m_btnPt1.EnableWindow(TRUE);      
	m_btnPt2.EnableWindow(TRUE);      
	m_btnAuto.EnableWindow(TRUE);

	UpdateData(FALSE);
}
//________________________________________
void CEtalDlg::OnKillfocusGamma()
{
	UpdateData(TRUE);
	m_pDoc->m_fGamma=m_fGamma;	
}
//________________________________________
void CEtalDlg::OnKillfocusH1()
{
	UpdateData(TRUE);
	m_fH1=(float)(fabs(m_fH1));
	m_pDoc->m_Ep1.h=m_fH1;	
	UpdateData(FALSE);
}
//________________________________________
void CEtalDlg::OnKillfocusH2()
{
	UpdateData(TRUE);
	m_fH2=(float)(fabs(m_fH2));
	m_pDoc->m_Ep2.h=m_fH1;	
	UpdateData(FALSE);
}
//________________________________________
void CEtalDlg::OnStop()
{
	//Clic sur le bouton Stop
	//On supprime le timer d'affichage position
	KillTimer(3);
	//On arrte le dplacement en cours: Stop
	if (m_cNoAxeMvt!=0)
	{
		m_pMM2000->ST(0);
		//m_pMM2000->WS(0);
		Sleep(200);
		//Affichage de la position courante
		m_sTexte.Format("X(mm): %1.2f\nY(mm): %1.2f",m_pMM2000->TP(1),m_pMM2000->TP(2));
		//On invalide le bouton STOP		
		m_btnStop.EnableWindow(FALSE);      
		//On valide les autres boutons
		m_btnXplus.EnableWindow(TRUE);
		m_btnXmoins.EnableWindow(TRUE);
		m_btnYplus.EnableWindow(TRUE);
		m_btnYmoins.EnableWindow(TRUE);
		m_btnCancel.EnableWindow(TRUE);      
		m_btnPt1.EnableWindow(TRUE);      
		m_btnPt2.EnableWindow(TRUE);      
		UpdateData(FALSE);
	}
	//Plus d'axe en mouvement
	m_cNoAxeMvt=0;
}
//________________________________________
void CEtalDlg::OnXMoins()
{
	//On valide/invalide les boutons
	m_btnXplus.EnableWindow(FALSE);
	m_btnXmoins.EnableWindow(FALSE);
	m_btnYplus.EnableWindow(FALSE);
	m_btnYmoins.EnableWindow(FALSE);
	m_btnCancel.EnableWindow(FALSE);      
	m_btnPt1.EnableWindow(FALSE);      
	m_btnPt2.EnableWindow(FALSE);      
	m_btnStop.EnableWindow(TRUE);      
	//Axe 1 en mouvement
	m_cNoAxeMvt=1;
	//On se dplace             
	m_pMM2000->MR(1,-200.00);
	//Dmarre le temporisateur d'affichage position
	SetTimer(3,40,NULL);
}
//________________________________________
void CEtalDlg::OnXPlus()
{
	//On valide/invalide les boutons
	m_btnXplus.EnableWindow(FALSE);
	m_btnXmoins.EnableWindow(FALSE);
	m_btnYplus.EnableWindow(FALSE);
	m_btnYmoins.EnableWindow(FALSE);
	m_btnCancel.EnableWindow(FALSE);      
	m_btnPt1.EnableWindow(FALSE);      
	m_btnPt2.EnableWindow(FALSE);      
	m_btnStop.EnableWindow(TRUE);      
	//Axe 1 en mouvement
	m_cNoAxeMvt=1;
	//On se dplace             
	m_pMM2000->MR(1,200.00);
	//Dmarre le temporisateur d'affichage position
	SetTimer(3,40,NULL);
}
//________________________________________
void CEtalDlg::OnYMoins()
{
	//On valide/invalide les boutons
	m_btnXplus.EnableWindow(FALSE);
	m_btnXmoins.EnableWindow(FALSE);
	m_btnYplus.EnableWindow(FALSE);
	m_btnYmoins.EnableWindow(FALSE);
	m_btnCancel.EnableWindow(FALSE);      
	m_btnPt1.EnableWindow(FALSE);      
	m_btnPt2.EnableWindow(FALSE);      
	m_btnStop.EnableWindow(TRUE);      
	//Axe 2 en mouvement
	m_cNoAxeMvt=2;
	//On se dplace             
	m_pMM2000->MR(2,-200.00);
	//Dmarre le temporisateur d'affichage position
	SetTimer(3,40,NULL);
}
//________________________________________
void CEtalDlg::OnYplus()
{
	//On valide/invalide les boutons
	m_btnXplus.EnableWindow(FALSE);
	m_btnXmoins.EnableWindow(FALSE);
	m_btnYplus.EnableWindow(FALSE);
	m_btnYmoins.EnableWindow(FALSE);
	m_btnCancel.EnableWindow(FALSE);      
	m_btnPt1.EnableWindow(FALSE);      
	m_btnPt2.EnableWindow(FALSE);      
	m_btnStop.EnableWindow(TRUE);      
	//Axe 2 en mouvement
	m_cNoAxeMvt=2;
	//On se dplace             
	m_pMM2000->MR(2,200.00);
	//Dmarre le temporisateur d'affichage position
	SetTimer(3,40,NULL);
}
//________________________________________
void CEtalDlg::OnPoint1()
{
	//Clic sur point 1
	UpdateData(TRUE);
	short i,j;
	float ux,uy;
	j=1;
	for (i=0;i<m_pApp->m_radioMoy;i++)
	{   
		j=j*2*2;
	}
	//Lecture tension
  ux=m_pEuro->LitTension(0,1,j);
  uy=m_pEuro->LitTension(1,1,j);

  if (ux==1e10 || uy==1e10)
		m_sTexte="Erreur de lect. carte A/N !";
	else
	{	
	  m_pDoc->m_Ep1.ux=ux;
		m_pDoc->m_Ep1.uy=uy;
		m_pDoc->m_Ep1.x=m_pMM2000->TP(1);
		m_pDoc->m_Ep1.y=m_pMM2000->TP(2);
		m_pDoc->m_Ep1.h=m_fH1;

		m_sTexte.Format("Xpt1(mm): %1.2f\nYpt1(mm): %1.2f\nUx(V): %1.3f, Uy(V): %1.3f",m_pDoc->m_Ep1.x,m_pDoc->m_Ep1.y,ux,uy);
		m_pDoc->m_iEtal=m_pDoc->m_iEtal | 1;
		if (m_pDoc->m_iEtal==3) 
		{
			m_btnAuto.EnableWindow(TRUE); 
			m_pDoc->m_fGamma=m_fGamma=m_pDoc->CalculGamma();
		}
	}	
	UpdateData(FALSE);
}
//________________________________________
void CEtalDlg::OnPoint2()
{
	//Clic sur point 1
	UpdateData(TRUE);
	short i,j;
	float ux,uy;
	j=1;
	for (i=0;i<m_pApp->m_radioMoy;i++)
	{   
		j=j*2*2;
	}
	//Lecture tension
  ux=m_pEuro->LitTension(0,1,j);
  uy=m_pEuro->LitTension(1,1,j);

  //Tenir compte du convertisseur
  //u=u*m_pApp->m_fCanA+m_pApp->m_fCanB;
  if (ux==1e10 || uy==1e10)
		m_sTexte="Erreur de lect. carte A/N !";
	else
	{	
	  m_pDoc->m_Ep2.ux=ux;
		m_pDoc->m_Ep2.uy=uy;
		m_pDoc->m_Ep2.x=m_pMM2000->TP(1);
		m_pDoc->m_Ep2.y=m_pMM2000->TP(2);
		m_pDoc->m_Ep2.h=m_fH2;
		
		m_sTexte.Format("Xpt2(mm): %1.2f\nYpt2(mm): %1.2f\nUx(V): %1.3, Uy(V): %1.3f",m_pDoc->m_Ep2.x,m_pDoc->m_Ep2.y,ux,uy);
		m_pDoc->m_iEtal=m_pDoc->m_iEtal | 2;
		if (m_pDoc->m_iEtal==3) 
		{
			m_btnAuto.EnableWindow(TRUE); 
			m_pDoc->m_fGamma=m_fGamma=m_pDoc->CalculGamma();
		}
	}	
	UpdateData(FALSE);
}
//________________________________________
void CEtalDlg::OnTimer(UINT nIDEvent)
{
	
	CDialog::OnTimer(nIDEvent);
}
//________________________________________
void CEtalDlg::OnCancel()
{
	delete m_pMM2000;
	delete m_pEuro;
	m_pDoc->UpdateAllViews(NULL);
	CDialog::OnCancel();
}
//________________________________________
void CEtalDlg::OnOK()
{
	//CDialog::OnOK();
}
//________________________________________
void CEtalDlg::OnKillfocusAlpha() 
{
	UpdateData(TRUE);
	if (m_fAlpha<5) m_fAlpha=5;
	if (m_fAlpha>85) m_fAlpha=85;
	UpdateData(FALSE);
	m_pApp->m_fAlpha=m_fAlpha;
}