// Graphe.cpp
#include "stdafx.h"
#include "Bk.h"
#include "Graphe.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CGraphe
CGraphe::CGraphe(CDC *pDC,CRect R)
{
	m_iHautTexte=16;//Hauteur rfrence du TextOut en pixel
	m_fEchx=1.0f;
	m_fEchy=1.0f;
	m_fXori=0.0f;
	m_fYori=0.0f;
	m_fFactx=1.0f;
	m_fFacty=1.0f;
	m_fXmi=1e10f;
	m_fYmi=1e10f;
	m_fXma=-1e10f;
	m_fYma=-1e10f;
  m_sTitre="";
	m_sAbs="x";
	m_sOrd="y";
	m_iCurseurV1=m_iCurseurV2=0;
	m_iCurseurH1=m_iCurseurH2=0;
	//Pointeur sur le contexte de priphrique	
	m_pDC=pDC;
	//Rectangle en pixels contenant le graphe
	m_Rect=R;
	//Cadre autour du graphe
	CPen plume,*oldPen;
  plume.CreatePen(PS_SOLID,1,RGB(0,0,0));
	oldPen=m_pDC->SelectObject(&plume);
	CPoint HG=m_Rect.TopLeft(),BD=m_Rect.BottomRight();
	//Rectangle exterieur avec marge
	short marge=25;
	m_pDC->Rectangle(HG.x-marge,HG.y-marge,BD.x+marge,BD.y+marge);
	//Rectangle interieur
	m_pDC->Rectangle(R);
	m_pDC->SelectObject(oldPen);        
	plume.DeleteObject();        
}
//________________________________________
CGraphe::~CGraphe()
{
}
BEGIN_MESSAGE_MAP(CGraphe, CWnd)
	//{{AFX_MSG_MAP(CGraphe)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
// CGraphe message handlers
//________________________________________
void CGraphe::ParametresGraphe(float *P)
{
	//Retour des limites, chelles, dcalage d'origine, facteurs d'chelle
	//[0, 9]: 10 donnes
	P[0]=m_fXmi;
	P[1]=m_fYmi;
	P[2]=m_fXma;
	P[3]=m_fYma;  
	P[4]=m_fEchx;
	P[5]=m_fEchy;
	P[6]=m_fXori;
	P[7]=m_fYori;
	P[8]=m_fFactx;
	P[9]=m_fFacty;
}
//________________________________________
void CGraphe::LegendeGraphe(CString titre,CString abs,CString ord)
{
	m_sTitre=titre;
	m_sAbs=abs;
	m_sOrd=ord;
}
//________________________________________
void CGraphe::MetCurseurH(short no,short p,long coul)
{
	short 
		taille=12;
	CPen plume,*oldPen;
	CFont fnt,*oldFont;
	COLORREF clrOld;	
	float x,y,PI=4*atan(1),r;
	CString z;
	CPoint HG=m_Rect.TopLeft(),BD=m_Rect.BottomRight();
	//On trace le curseur  la position p
  plume.CreatePen(PS_SOLID,1,coul);
	oldPen=m_pDC->SelectObject(&plume);   
	fnt.CreateFont(m_iHautTexte,0,0,0,FW_MEDIUM,FALSE,FALSE,FALSE,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,"Arial");
	oldFont=m_pDC->SelectObject(&fnt);	  
	m_pDC->SetTextAlign(TA_RIGHT|TA_BASELINE);							
	clrOld=m_pDC->SetTextColor(coul);
	//Trac d'un triangle quilatral
	x=1.0*taille*tan(30.0*PI/180.0);
	y=1.0*taille;

	if(p==-1) p=BD.y;
	if (p>BD.y) p=BD.y;
	if (p<HG.y) p=HG.y;
	//Position curseur dans le repre du graphe
	r=(BD.y-p)/m_fEchy+m_fYmi;
	//z.Format("%d",p);AfxMessageBox(z);
	//Mmorisation de la position du curseur
	if (p>=HG.y-1 && p<=BD.y+1)
	{
		//Si position demande dans graphe
		if (no==0) m_iCurseurH1=p; else m_iCurseurH2=p;
		m_pDC->MoveTo(BD.x,p);
		m_pDC->LineTo(BD.x+y,p-x);
		m_pDC->LineTo(BD.x+y,p+x);
		m_pDC->LineTo(BD.x,p);
		//Ligne horizontale
		m_pDC->LineTo(HG.x,p);
		//Ecriture position curseur
 		z.Format("%1.3f",r*m_fFacty);
 		m_pDC->TextOut(BD.x-2,p+m_iHautTexte/2-2,z);  
		
	}
	m_pDC->SelectObject(oldPen);        
	plume.DeleteObject();        
	m_pDC->SelectObject(oldFont);        
	fnt.DeleteObject();
	m_pDC->SetTextColor(clrOld);
}
//________________________________________
void CGraphe::MarqueDePointage(CPoint P,long coul)
{
	short i;
	CPoint HG=m_Rect.TopLeft(),BD=m_Rect.BottomRight();
	CPen plume,*oldPen;
	CFont fnt,*oldFont;
	COLORREF clrOld;	
	CString z;
  plume.CreatePen(PS_SOLID,1,coul);
	oldPen=m_pDC->SelectObject(&plume);   
	fnt.CreateFont(m_iHautTexte,0,0,0,FW_MEDIUM,FALSE,FALSE,FALSE,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,"Arial");
	oldFont=m_pDC->SelectObject(&fnt);	  
	m_pDC->SetTextAlign(TA_CENTER);							
	clrOld=m_pDC->SetTextColor(coul);

	float X,Y,x,y;
	x=P.x/m_fEchx+m_fXmi;
	y=m_fYma-P.y/m_fEchy;
	
	
	X=P.x+HG.x;
	Y=P.y+HG.y;
	if (P.x!=-1)
	{
		/*
		m_pDC->MoveTo(X-3,Y-3);
		m_pDC->LineTo(X+3,Y-3);
		m_pDC->LineTo(X+3,Y+3);
		m_pDC->LineTo(X-3,Y+3);
		m_pDC->LineTo(X-3,Y-3);
		*/
		for (i=X-2;i<=X+2;i++)
		{
			m_pDC->MoveTo(i,Y-2);
			m_pDC->LineTo(i,Y+3);
		}
		z.Format("%1.3f, %1.3f",x*m_fFactx,y*m_fFacty);
		m_pDC->TextOut(X,Y-10-m_iHautTexte/2,z);  
	}
	m_pDC->SelectObject(oldPen);        
	plume.DeleteObject();        
	m_pDC->SelectObject(oldFont);        
	fnt.DeleteObject();
	m_pDC->SetTextColor(clrOld);
}
//________________________________________
void CGraphe::MetCurseurV(short no,short p,long coul)
{
	short 
		taille=12;
	CPen plume,*oldPen;
	CFont fnt,*oldFont;
	COLORREF clrOld;	
	float x,y,PI=4*atan(1),r;
	CString z;
	CPoint HG=m_Rect.TopLeft(),BD=m_Rect.BottomRight();
	//On trace le curseur  la position p
  plume.CreatePen(PS_SOLID,1,coul);
	oldPen=m_pDC->SelectObject(&plume);   
	fnt.CreateFont(m_iHautTexte,0,0,0,FW_MEDIUM,FALSE,FALSE,FALSE,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,"Arial");
	oldFont=m_pDC->SelectObject(&fnt);	  
	m_pDC->SetTextAlign(TA_CENTER);							
	clrOld=m_pDC->SetTextColor(coul);
	//Trac d'un triangle 
	x=1.0*taille*tan(30.0*PI/180.0);
	y=1.0*taille;
	if (p==-1) p=BD.x;
	if (p>BD.x) p=BD.x;
	if (p<HG.x) p=HG.x;
	//Position curseur dans le repre du graphe
	r=(p-HG.x)/m_fEchx+m_fXmi;

	//Mmorisation de la position du curseur
	if (p>=HG.x-1 && p<=BD.x+1)
	{
		//Si position demande dans graphe
		if (no==0) m_iCurseurV1=p; else m_iCurseurV2=p;
		m_pDC->MoveTo(p,HG.y);
		m_pDC->LineTo(p-x,HG.y-y);
		m_pDC->LineTo(p+x,HG.y-y);
		m_pDC->LineTo(p,HG.y);
		//Ligne verticale
		m_pDC->LineTo(p,BD.y);
		//Ecriture position curseur
 		z.Format("%1.3f",r*m_fFactx);
 		m_pDC->TextOut(p,HG.y+m_iHautTexte/2-2,z);  
	}
	m_pDC->SelectObject(oldPen);        
	plume.DeleteObject();        
	m_pDC->SelectObject(oldFont);        
	fnt.DeleteObject();
	m_pDC->SetTextColor(clrOld);
}
//________________________________________
short CGraphe::RenvoiCurseurH(short no)
{
	//Modification le 27/07/05 : Renvoi position curseur en pixel
	/*
	float r;
	CPoint HG=m_Rect.TopLeft(),BD=m_Rect.BottomRight();
	if (no==0)
	 r=(m_iCurseurH1-HG.x)/m_fEchx+m_fXmi;
	else
	 r=(m_iCurseurH2-HG.x)/m_fEchx+m_fXmi;
	return r;
	*/
	if (no==0)
	 return m_iCurseurH1;
	else
	 return m_iCurseurH2;
}
//________________________________________
short CGraphe::RenvoiCurseurV(short no)
{
	/*
	float r;
	CPoint HG=m_Rect.TopLeft(),BD=m_Rect.BottomRight();
	if (no==0)
	 r=(m_iCurseurV1-HG.x)/m_fEchx+m_fXmi;
	else
	 r=(m_iCurseurV2-HG.x)/m_fEchx+m_fXmi;
	return r;
	*/
	if (no==0)
		return m_iCurseurV1;
	else
		return m_iCurseurV2;

}
//________________________________________
float CGraphe::CotationH(long coul)
{
	//Cotation de la distance entre les curseurs et renvoi de cette valeur
	CPen plume,*oldPen;
	CFont fnt,*oldFont;
	LOGFONT lf;
	COLORREF clrOld;	
	float r,PI=4*atan(1);
	short j;
	CString z;
	CPoint HG=m_Rect.TopLeft(),BD=m_Rect.BottomRight();
	//On trace le curseur  la position p
  plume.CreatePen(PS_SOLID,1,coul);
	oldPen=m_pDC->SelectObject(&plume);  
	/*
	fnt.CreateFont(m_iHautTexte,0,0,0,FW_MEDIUM,FALSE,FALSE,FALSE,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,"Arial");
	*/
	ZeroMemory(&lf,sizeof(LOGFONT));
	lstrcpy(lf.lfFaceName,"Arial");
	lf.lfHeight=m_iHautTexte;
	//Cration de 180 fontes inclines
	lf.lfEscapement=10*90;
	fnt.CreateFontIndirect(&lf);

	oldFont=m_pDC->SelectObject(&fnt);	  
	m_pDC->SetTextAlign(TA_CENTER|TA_BOTTOM);							
	clrOld=m_pDC->SetTextColor(coul);
	//Trac cote au milieu de la fentre
	if (m_iCurseurH1>=HG.y && m_iCurseurH1<=BD.y && m_iCurseurH2>=HG.y && m_iCurseurH2<=BD.y && m_iCurseurH2!=m_iCurseurH1)
	{
		j=(HG.x+BD.x)/2-50;
		m_pDC->MoveTo(j,m_iCurseurH1);
		m_pDC->LineTo(j,m_iCurseurH2);
		//Cercle de rayon 2 pixels
		m_pDC->Arc(j-2,m_iCurseurH1-2,j+2,m_iCurseurH1+2,j,m_iCurseurH1-2,j,m_iCurseurH1-2);
		m_pDC->Arc(j-2,m_iCurseurH2-2,j+2,m_iCurseurH2+2,j,m_iCurseurH2-2,j,m_iCurseurH2-2);
		//Ecriture cote
		r=fabs(m_iCurseurH2-m_iCurseurH1)/m_fEchy;
 		z.Format("%1.3f",r*m_fFacty);
 		m_pDC->TextOut(j-1,(m_iCurseurH2+m_iCurseurH1)/2,z);  
	}
	m_pDC->SelectObject(oldPen);        
	plume.DeleteObject();        
	m_pDC->SelectObject(oldFont);        
	fnt.DeleteObject();
	m_pDC->SetTextColor(clrOld);
	return r/m_fFacty;
}
//________________________________________
float CGraphe::CotationV(long coul)
{
	//Cotation de la distance entre les curseurs et renvoi de cette valeur
	CPen plume,*oldPen;
	CFont fnt,*oldFont;
	COLORREF clrOld;	
	float r;
	short j;
	CString z;
	CPoint HG=m_Rect.TopLeft(),BD=m_Rect.BottomRight();
	//On trace le curseur  la position p
  plume.CreatePen(PS_SOLID,1,coul);
	oldPen=m_pDC->SelectObject(&plume);   
	fnt.CreateFont(m_iHautTexte,0,0,0,FW_MEDIUM,FALSE,FALSE,FALSE,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,"Arial");
	oldFont=m_pDC->SelectObject(&fnt);	  
	m_pDC->SetTextAlign(TA_CENTER|TA_BOTTOM);							
	clrOld=m_pDC->SetTextColor(coul);
	//Trac cote au milieu de la fentre
	if (m_iCurseurV1>=HG.x && m_iCurseurV1<=BD.x && m_iCurseurV2>=HG.x && m_iCurseurV2<=BD.x && m_iCurseurV2!=m_iCurseurV1)
	{
		j=(HG.y+BD.y)/2+50;
		m_pDC->MoveTo(m_iCurseurV1,j);
		m_pDC->LineTo(m_iCurseurV2,j);
		//Cercle de rayon 2 pixels
		m_pDC->Arc(m_iCurseurV1-2,j-2,m_iCurseurV1+2,j+2,m_iCurseurV1-2,j,m_iCurseurV1-2,j);
		m_pDC->Arc(m_iCurseurV2-2,j-2,m_iCurseurV2+2,j+2,m_iCurseurV2-2,j,m_iCurseurV2-2,j);
		//Ecriture cote
		r=fabs(m_iCurseurV2-m_iCurseurV1)/m_fEchx;
 		z.Format("%1.3f",r*m_fFactx);
 		m_pDC->TextOut((m_iCurseurV2+m_iCurseurV1)/2,j,z);  
	}
	m_pDC->SelectObject(oldPen);        
	plume.DeleteObject();        
	m_pDC->SelectObject(oldFont);        
	fnt.DeleteObject();
	m_pDC->SetTextColor(clrOld);
	return r/m_fFactx;
}
//________________________________________
short CGraphe::TraceGraphe(short abs,short ord,float (*t)[4],short nb,long coul)
{
	float
		x,y,x1,y1,
		pasx,pasy,
		echx,echy,
		factx,facty,
		xori,yori,
		xmin=1e10,ymin=1e10,xmax=-1e10,ymax=-1e10;
	short 
		err=0,
		larg=m_Rect.Width(),
		haut=m_Rect.Height(),
		i,j,k;
	CString z;
	CPoint HG=m_Rect.TopLeft(),BD=m_Rect.BottomRight();
	CPen plume,plumeN,plumeG,*oldPen;
	CFont 
		fnt1,  
		*oldFont;
	COLORREF clrOld;	

  plumeN.CreatePen(PS_SOLID,1,RGB(0,0,0));
  plume.CreatePen(PS_SOLID,2,coul);
  plumeG.CreatePen(PS_SOLID,1,RGB(127,127,127));
	oldPen=m_pDC->SelectObject(&plumeN);        
	fnt1.CreateFont(m_iHautTexte,0,0,0,FW_MEDIUM,FALSE,FALSE,FALSE,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,"Arial");
	oldFont=m_pDC->SelectObject(&fnt1);	  
	m_pDC->SetTextAlign(TA_CENTER);							
	clrOld=m_pDC->SetTextColor(RGB(0,0,0));

	for (i=0;i<nb;i++)
	{
		if (t[i][abs]!=1e10 && t[i][ord]!=1e10)
		{
			if (t[i][abs]<xmin) xmin=t[i][abs];
			if (t[i][abs]>xmax) xmax=t[i][abs];
			if (t[i][ord]<ymin) ymin=t[i][ord];
			if (t[i][ord]>ymax) ymax=t[i][ord];
		}
	}
	if (xmin==1e10 || ymin==1e10 || xmax==1e10 || ymax==1e10) 
	{
		err=1;
		goto fin;
	}
  //Si les valeurs sont constantes
	if (fabs(ymax-ymin)<1e-8)
	{
		ymax=ymax+0.01;
		ymin=ymin-0.01;
	}
	if (fabs(xmax-xmin)<1e-8)
	{
		xmax=xmax+0.01;
		xmin=xmin-0.01;
	}                                
	echx=1.0*(larg-0)/(xmax-xmin);                    
	echy=1.0*(haut-0)/(ymax-ymin);
	//Calcul pasx
	pasx=1e-10;
	do
	{
		pasx=pasx*10;
		k=(short)1.0*(xmax-xmin)/(echx*pasx);
		//z.Format("k:%d, pasx: %e",k,pasx);
		//AfxMessageBox(z);
	}                              
	while	(echx*pasx<=1);
	k=1.0*(xmax-xmin)/pasx;
	while (k>10)
	{
		pasx=pasx*10;
		k=1.0*(xmax-xmin)/pasx;
	}
	/*
	while (k<2)
	{
		pasx=pasx/2;
		k=1.0*(xmax-xmin)/pasx;
	}
	*/
	//Calcul pasy
	pasy=1e-10;
	do
	{
		pasy=pasy*10;
	}           
	while	(echy*pasy<=1);
	//pasy=pasy*50;	
	k=1.0*(ymax-ymin)/pasy;
	while (k>10)
	{
		pasy=pasy*10;
		k=1.0*(ymax-ymin)/pasy;
	}
	
	while (k<2)
	{
		pasy=pasy/2;
		k=1.0*(ymax-ymin)/pasy;
	}
	
	//z.Format("%d",k);
	//AfxMessageBox(z);

	//Recherche facteurs axes x et y
	if (fabs(xmin)>fabs(xmax))
		x=xmin;
	else
		x=xmax;
	if (x!=0)
	{
		factx=1e-10;
		do
		{
			factx=factx*10;
		}
		while (fabs(x*factx)<1.0);	
	}	                           
	else
		factx=1;

	if (fabs(ymin)>fabs(ymax))
		y=ymin;
	else
		y=ymax;

	if (y!=0)
	{
		facty=1e-10;
		do
		{
			facty=facty*10;
		}
		while (fabs(y*facty)<1.0);	
	}	                           
	else
		facty=1;

	//Calcul xori et yori
	xori=0;yori=0;
	if ((xmin<=0) && (xmax>=0))
		xori=0;
	else
	{
		//xori=xmin;	
		if (xmin>0)
		{
			//On encadre dans le sens positif
			xori=0;
			do
			{
				xori=xori+pasx;
			}
			while (xori<xmin);
			xori=xori-pasx;
		}
		else
		{
			//On encadre dans le sens ngatif
			xori=0;
			do
			{
				xori=xori-pasx;
			}
			while (xori>xmin);
			xori=xori+pasx;
		}
	}	
	if ((ymin<=0) && (ymax>=0))
		yori=0;
	else
	{
		if (ymin>0)
		{
			//On encadre dans le sens positif
			yori=0;
			do
			{
				yori=yori+pasy;
			}
			while (yori<ymin);
			yori=yori-pasy;
		}
		else
		{
			//On encadre dans le sens ngatif
			yori=0;
			do
			{
				yori=yori-pasy;
			}
			while (yori>ymin);
			yori=yori+pasy;
		}

  }
		
	//z.Format("%f, %f,yori: %f,pasx: %f",ymin,ymax,yori,pasy);
	//AfxMessageBox(z);
	
  //Division axe x
	m_pDC->SelectObject(&plumeG);
  x=xori;
  while (x<=xmax)
  {           
  	i=(short)((x-xmin)*echx);
		if (HG.x+i<=BD.x)
		{
	  	m_pDC->MoveTo(i+HG.x,HG.y);
			m_pDC->LineTo(i+HG.x,BD.y);
  		z.Format("%1.2f",x*factx);
  		m_pDC->TextOut(i+HG.x,BD.y+m_iHautTexte/2-2,z);  
		}
    x=x+pasx;
  }
	x=-pasx-xori;
  while (x>=xmin)
  {           
  	i=(short)((x-xmin)*echx);
		if (HG.x+i>=HG.x)
		{
	  	m_pDC->MoveTo(i+HG.x,HG.y);
			m_pDC->LineTo(i+HG.x,BD.y);
  		z.Format("%1.2f",x*factx);
  		m_pDC->TextOut(i+HG.x,BD.y+m_iHautTexte/2-2,z);  
		}
    x=x-pasx;
  }                      
  //Division axe y
	m_pDC->SetTextAlign(TA_LEFT);							
  y=yori;
  while (y<=ymax)
  {           
  	i=(short)((y-ymin)*echy);
		if (BD.y-i<=BD.y)
		{
  		m_pDC->MoveTo(HG.x,BD.y-i);
  		m_pDC->LineTo(BD.x,BD.y-i);
  		z.Format("%1.3f",y*facty);
  		m_pDC->TextOut(HG.x+6,BD.y-i-m_iHautTexte/2,z);  
		}
    y=y+pasy;
  }
  y=-pasy-yori;
  while (y>=ymin)
  {           
  	i=(short)((y-ymin)*echy);
		if (BD.y-i>=HG.y)
		{
  		m_pDC->MoveTo(HG.x,BD.y-i);
  		m_pDC->LineTo(BD.x,BD.y-i);
  		z.Format("%1.3f",y*facty);
  		m_pDC->TextOut(HG.x+6,BD.y-i-m_iHautTexte/2,z);  
		}
    y=y-pasy;
  }
	//Ecriture legendes
	m_pDC->SetTextColor(coul);
	z.Format("%s",m_sTitre);
 	m_pDC->TextOut(HG.x+6,HG.y+m_iHautTexte/2+2,z);  
	m_pDC->SetTextColor(RGB(0,0,0));
	z.Format("%s*%5.0e",m_sOrd,1.0/facty);
 	m_pDC->TextOut(HG.x+6,HG.y+m_iHautTexte/2+2+m_iHautTexte,z);  
	m_pDC->SetTextAlign(TA_RIGHT);							
	z.Format("%s*%5.0e",m_sAbs,1.0/factx);
 	m_pDC->TextOut(BD.x-2,BD.y-m_iHautTexte-3,z);  
		
	//Trac du graphe
	m_pDC->SelectObject(&plume);
	for (i=1;i<nb;i++)
	{
		x=t[i-1][abs];
		y=t[i-1][ord];
		x1=t[i][abs];
		y1=t[i][ord];
		if (x!=1e10 && y!=1e10 && x1!=1e10 && y1!=1e10)
		{
			x=(x-xmin)*echx;
			x1=(x1-xmin)*echx;
			y=(y-ymin)*echy;
			y1=(y1-ymin)*echy;
			m_pDC->MoveTo(x+HG.x,BD.y-y);
			m_pDC->LineTo(x1+HG.x,BD.y-y1);
		}
	}
	//Affectation des paramtres de trac___
	m_fXmi=xmin;m_fYmi=ymin;m_fXma=xmax;m_fYma=ymax;
	m_fEchx=echx;m_fEchy=echy;m_fXori=xori;m_fYori=yori;
	m_fFactx=factx;m_fFacty=facty;

	//______________________________________
	fin:
	m_pDC->SelectObject(oldPen);        
	plume.DeleteObject();        
	plumeN.DeleteObject();        
	plumeG.DeleteObject();        
	m_pDC->SelectObject(oldFont);        
	fnt1.DeleteObject();
	m_pDC->SetTextColor(clrOld);
	return err;
}
