// MainFrm.cpp : implementation of the CMainFrame class
#include "stdafx.h"
#include "Bk.h"
#include "MainFrm.h"
#include "Bkdoc.h"
#include "Bkview.h"
#include "AcqDlg.h"
#include "EtalDlg.h"
#include "VerifDlg.h"
#include "3dDlg.h"
#include "AcqAnDlg.h"
#include "DepDlg.h"
#include "Eurosmart.h"
#include "EchImDlg.h"
#include "Poly5Dlg.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CMainFrame
IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_ACQUISITION, OnAcquisition)
	ON_COMMAND(ID_ETALONNAGE, OnEtalonnage)
	ON_COMMAND(ID_VERIF_ETALONNAGE, OnVerifEtalonnage)
	ON_UPDATE_COMMAND_UI(ID_VISU_POINT_IMAGE, OnUpdateVisuPointImage)
	ON_COMMAND(ID_VISU_POINT_IMAGE, OnVisuPointImage)
	ON_WM_TIMER()
	ON_UPDATE_COMMAND_UI(ID_VISU_3D, OnUpdateVisu3d)
	ON_COMMAND(ID_VISU_3D, OnVisu3d)
	ON_UPDATE_COMMAND_UI(ID_FILE_SAVE, OnUpdateFileSave)
	ON_UPDATE_COMMAND_UI(ID_FILE_SAVE_AS, OnUpdateFileSaveAs)
	ON_COMMAND(ID_PARAMETRES, OnParametres)
	ON_UPDATE_COMMAND_UI(ID_FILE_NEW, OnUpdateFileNew)
	ON_UPDATE_COMMAND_UI(ID_FILE_OPEN, OnUpdateFileOpen)
	ON_COMMAND(ID_DEP_MANU, OnDepManu)
	ON_COMMAND(ID_ECH_IMP, OnEchImp)
	ON_COMMAND(ID_COURBE_LINEARITE, OnCourbeLinearite)
	//}}AFX_MSG_MAP
	//Coordonnes dfilantes de la souris
	//ON_UPDATE_COMMAND_UI(ID_BK, OnUpdateCoordonnees)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};
//________________________________________
// CMainFrame construction/destruction
CMainFrame::CMainFrame()
{
	m_pApp=((CBkApp*)AfxGetApp());
	m_pDocPSD=NULL;
	m_pEuro=new CEurosmart();
}
//________________________________________
CMainFrame::~CMainFrame()
{
	delete m_pEuro;
}
//________________________________________
int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	//Ouverture plein cran_________________
	ShowWindow(SW_SHOWMAXIMIZED);
	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}
//________________________________________
BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	return CMDIFrameWnd::PreCreateWindow(cs);
}
//________________________________________
// CMainFrame diagnostics
#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG
// CMainFrame message handlers
void CMainFrame::OnAcquisition() 
{
	//Si la fentre de visualisation du spot est ouverte, on la ferme
	if (m_pApp->m_OKPSD && m_pApp->m_pDocPSD!=NULL)
	{
		m_pDocPSD->m_pWnd->DestroyWindow();
	}
	CAcqDlg d;
	d.DoModal();
}
//________________________________________
void CMainFrame::OnEtalonnage() 
{
	CEtalDlg d;
	d.DoModal();
}
//________________________________________
void CMainFrame::OnVerifEtalonnage() 
{
	CVerifDlg d;
	d.DoModal();
}
//________________________________________
void CMainFrame::OnUpdateVisuPointImage(CCmdUI* pCmdUI) 
{
	if (m_pApp->m_OKPSD) pCmdUI->Enable(FALSE);	
}
//________________________________________
void CMainFrame::OnVisuPointImage() 
{
	CMDIChildWnd *pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	CBkDoc *pDoc;

	if (pChild) pDoc=(CBkDoc*)pChild->GetActiveDocument(); else pDoc=NULL;

	SendMessage(WM_COMMAND,ID_FILE_NEW,0);
	pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) 
	{
		m_pApp->m_pDocPSD=m_pDocPSD=(CBkDoc*)pChild->GetActiveDocument();
		m_pViewPSD=(CBkView*)pChild->GetActiveView();
	}
	else
	{
		m_pApp->m_pDocPSD=m_pDocPSD=NULL;
		m_pViewPSD=NULL;
	}

	if (m_pDocPSD)
	{
		m_pDocPSD->m_iType=1;
		m_pDocPSD->DimensionnerFenetre(200,200);
		m_pDocPSD->PositionnerFenetre(700,0);
		m_pDocPSD->DimensionnerScroll(200,200);
		freeimage(m_pDocPSD->image);
		allocimage(m_pDocPSD->image,200,200,8);
		m_pApp->m_OKPSD=TRUE;
		//Mise  jour fentre
		m_pViewPSD->Invalidate(FALSE);
		m_busy=FALSE;m_iNb=0;SetTimer(0,300,NULL);
	}
}
//________________________________________
void CMainFrame::OnTimer(UINT nIDEvent) 
{
	float ux,uy;
	if ((!m_busy) && m_pDocPSD && m_pApp->m_OKPSD)
	{
		m_busy=TRUE;
		ux=m_pEuro->LitTension(0,1,1);
		uy=m_pEuro->LitTension(1,1,1);

		if (ux==1e10 || uy==1e10)
		{
			short i=rand();i=i%9;//Bruit alatoire
			ux=(float)(0.0-0.005*i);
			uy=(float)(sin(0.02*m_iNb)+0.005*i);
			m_iNb++;
		}
		VisuSpot(ux,uy);
		m_busy=FALSE;
	}
	else
	{
		KillTimer(0);
	}
	CMDIFrameWnd::OnTimer(nIDEvent);
}
//________________________________________
void CMainFrame::VisuSpot(float ux,float uy)
{
	CString s;
	short 
		i,j;
	float 
		vcx=40.0f,
		vcy=40.0f,
		sigmax=15.0f,
		sigmay=15.0f,
		x,y,
		w;
	
	zeroimage(0,m_pDocPSD->image);
	if (fabs(ux<1.05) && fabs(uy<1.05))
	{
		for (i=0;i<80;i++)
		{
			for (j=0;j<80;j++)
			{
				w=255*GAUSS(i,vcx,sigmax)*GAUSS(j,vcy,sigmay);
				x=ux*(100-sigmax)+i+60;y=uy*(100-sigmay)+j+60;
				y=m_pDocPSD->image->endy-y;
				setpixelcolor(m_pDocPSD->image,(int)x,(int)y,(int)(w));
			}
		}
		s.Format("%3.0f,%3.0f",ux*1000,uy*1000);
		m_pDocPSD->SetTitle(s);
		//Raffichage vue
		m_pViewPSD->Invalidate(FALSE);
	}
}
//________________________________________
float CMainFrame::GAUSS(float i,float i0,float sigma)
{
	return (float)(exp(-pow(i-i0,2)/(2*pow(sigma,2))));
}
//________________________________________
void CMainFrame::OnUpdateVisu3d(CCmdUI* pCmdUI) 
{
	if (AfxGetApp()->m_pMainWnd)
	{
		CMDIChildWnd *pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
		CBkDoc *pDoc;
		if (pChild)
		{
			pDoc=(CBkDoc*)pChild->GetActiveDocument(); 
			if (pDoc->m_iType!=0)
			{
				pCmdUI->Enable(FALSE);
			}
		}
		else
			pCmdUI->Enable(FALSE);
	}
	else
		pCmdUI->Enable(FALSE);
}
//________________________________________
void CMainFrame::OnVisu3d() 
{
	//Si la fentre de visualisation du spot est ouverte, on la ferme
	if (m_pApp->m_OKPSD && m_pApp->m_pDocPSD!=NULL)
	{
		m_pDocPSD->m_pWnd->DestroyWindow();
	}
	C3dDlg d;
	d.DoModal();
}
//________________________________________
void CMainFrame::OnUpdateFileNew(CCmdUI* pCmdUI) 
{
	if (m_pApp->m_iNb>3) pCmdUI->Enable(FALSE);
}
//________________________________________
void CMainFrame::OnUpdateFileOpen(CCmdUI* pCmdUI) 
{
	if (m_pApp->m_iNb>3) pCmdUI->Enable(FALSE);
}
//________________________________________
void CMainFrame::OnUpdateFileSave(CCmdUI* pCmdUI) 
{
	if (AfxGetApp()->m_pMainWnd)
	{
		CMDIChildWnd *pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
		CBkDoc *pDoc=NULL;
		if (pChild)
		{
			pDoc=(CBkDoc*)pChild->GetActiveDocument(); 
			if (pDoc!=NULL)
			{
				if(pDoc->m_iType!=0) pCmdUI->Enable(FALSE);
			}
		}
	}
}
//________________________________________
void CMainFrame::OnUpdateFileSaveAs(CCmdUI* pCmdUI) 
{
	if (AfxGetApp()->m_pMainWnd)
	{
		CMDIChildWnd *pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
		CBkDoc *pDoc=NULL;
		if (pChild)
		{
			pDoc=(CBkDoc*)pChild->GetActiveDocument(); 
			if (pDoc!=NULL)
			{
				if(pDoc->m_iType!=0) pCmdUI->Enable(FALSE);
			}
		}
	}
}
//________________________________________
void CMainFrame::OnParametres() 
{
	CAcqAnDlg d;
	d.DoModal();
}
//________________________________________
void CMainFrame::OnDepManu() 
{
	CDepDlg d;
	d.DoModal();	
}
//________________________________________
void CMainFrame::OnEchImp() 
{
	CEchImDlg d;
	d.DoModal();
}
//________________________________________
void CMainFrame::OnCourbeLinearite() 
{
	CPoly5Dlg d;
	d.DoModal();	
}
