// MainFrm.h : interface of the CMainFrame class
//////////////////////////////////////////
class CMainFrame : public CMDIFrameWnd
{
	DECLARE_DYNAMIC(CMainFrame)
public:
	CMainFrame();

// Attributes
public:
	class CBkApp *m_pApp;
	class	CBkView *m_pViewPSD;
	class CBkDoc* m_pDocPSD;
	class CEurosmart *m_pEuro;
	BOOL m_busy;
	short m_iNb;

// Operations
public:
	void VisuSpot(float ux,float uy);
	float GAUSS(float i,float i0,float sigma);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainFrame)
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:  // control bar embedded members
	CStatusBar  m_wndStatusBar;
	CToolBar    m_wndToolBar;

// Generated message map functions
protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnAcquisition();
	afx_msg void OnEtalonnage();
	afx_msg void OnVerifEtalonnage();
	afx_msg void OnUpdateVisuPointImage(CCmdUI* pCmdUI);
	afx_msg void OnVisuPointImage();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnUpdateVisu3d(CCmdUI* pCmdUI);
	afx_msg void OnVisu3d();
	afx_msg void OnUpdateFileSave(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFileSaveAs(CCmdUI* pCmdUI);
	afx_msg void OnParametres();
	afx_msg void OnUpdateFileNew(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFileOpen(CCmdUI* pCmdUI);
	afx_msg void OnDepManu();
	afx_msg void OnEchImp();
	afx_msg void OnCourbeLinearite();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
//////////////////////////////////////////
