// MM2000.cpp : implementation file
//________________________________________
#include "stdafx.h"
#include "Bk.h"
#include "MM2000.h"
#include <conio.h>
#include <math.h>
#include <Windows.h>
#include "DlPortIO.h"
#include <sys/timeb.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CMM2000
CMM2000::CMM2000()
{
	//Valeurs par dfaut
	m_lCte=100; 	//Conversion pas -> mm 
	m_fVit=10;		//Vitesse par dfaut: 10 mm/min
	m_iAdr=0x340;	//Adresse carte
}

CMM2000::~CMM2000()
{
}
//________________________________________
BEGIN_MESSAGE_MAP(CMM2000, CWnd)
	//{{AFX_MSG_MAP(CMM2000)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CMM2000 message handlers
BOOL CMM2000::MMSendCmd(char *cmd,int mm_add)
{
	struct _timeb timebuffer;
  long double t,t1;
  char *i,cmd2[80];
	//strcat(strcpy(cmd2,cmd),"\r");
	strcpy(cmd2,cmd);
  i=cmd2;
	//CString z;z.Format("%s",i);AfxMessageBox(z);
  while(*i!=0)
  {
    //_enable();                   /* enable interrupt */
	  _ftime(&timebuffer);
		t=(long double)(timebuffer.time + 0.001*timebuffer.millitm);
		do
		{
		  _ftime(&timebuffer);
			t1=(long double)(timebuffer.time + 0.001*timebuffer.millitm);
		}
    while((in_port(mm_add+1)!=128) && (t1<=t+0.009));
		if (t1>=t+0.009) return FALSE;

    out_port(mm_add,*i);
    out_port(mm_add+1,128);
		do
		{
		}
    while(in_port(mm_add+1)!=0);
    //_disable();                  /* disable interrupt */
    out_port(mm_add+1,0);
    i+=1;
  }
	do
	{
	}
  while(in_port(mm_add+1)!=128);
  //_enable();                     /* enable interrupt */
	return TRUE;
}
//________________________________________
BOOL CMM2000::MMReadResp(char *resp,int mm_add)
{
	struct _timeb timebuffer;
  long double t,t1;
	char *i;
  i=resp;
  do
  {
	  _ftime(&timebuffer);
		t=(long double)(timebuffer.time + 0.001*timebuffer.millitm);
    do
		{
		  _ftime(&timebuffer);
			t1=(long double)(timebuffer.time + 0.001*timebuffer.millitm);
		} 
		while((in_port(mm_add+1)!=0) && (t1<=t+0.009));
		if (t1>=t+0.009) return FALSE;

    out_port(mm_add+1,128);
    while(in_port(mm_add+1)<128);
    *i=in_port(mm_add);
    i+=1;
    out_port(mm_add+1,0);
  }
  while(*(i-1)!=10);
  while(in_port(mm_add+1)!=128);
	return TRUE;
}
//________________________________________
void CMM2000::out_port(long a,unsigned char c)
{
	if (GetVersion() & 0x80000000)
	{
		//Sous W98...
		//Registre de donnes: Offset+0: criture de l'octet
		_outp((unsigned short)a,c);
	}
	else
	{
		//PortIO pour XP
	  DlPortWritePortUchar(a,c);
	}
}
//________________________________________
unsigned char CMM2000::in_port(long a)
{
	unsigned char k;
	if (GetVersion() & 0x80000000)
	{
		//Sous W98...
		k=_inp((unsigned short)a);
	}
	else
	{
		//PortIO pour XP
	  k=DlPortReadPortUchar(a);
	}
	return k;
}
//________________________________________
//MA: Dplacement absolu des axes
void CMM2000::MA(char axe,float x)
{
	char s[30];        
	long l;
	
	l=(long)(x*m_lCte);
	switch (axe)
	{
		case 1://Axe x
			sprintf(s,"1PA %ld\r",l);
			MMSendCmd(s,m_iAdr);
		break;
		case 2://Axe y
			sprintf(s,"2PA %ld\r",l);
			MMSendCmd(s,m_iAdr);
		break;
		case 0://Tous les axes
			sprintf(s,"1PA %ld\r",l);
			if (MMSendCmd(s,m_iAdr))
			{
				sprintf(s,"2PA %ld\r",l);
				MMSendCmd(s,m_iAdr);
			}
		break;
	}
}
//________________________________________
//MR: Dplacement relatif des axes (PR)
void CMM2000::MR(char axe,float x)
{
	char s[30];        
	long l;
	
	l=(long)(x*m_lCte);
	switch (axe)
	{
		case 1://Axe x
			sprintf(s,"1PR %ld\r",l);
			MMSendCmd(s,m_iAdr);
		break;
		case 2://Axe y
			sprintf(s,"2PR %ld\r",l);
			MMSendCmd(s,m_iAdr);
		break;
		case 0://Axe x et y
			sprintf(s,"1PR %ld\r",l);
			if (MMSendCmd(s,m_iAdr))
			{
				sprintf(s,"2PR %ld\r",l);
				MMSendCmd(s,m_iAdr);
			}
		break;
	}
}
//________________________________________
//SV: Set Velocity
void CMM2000::SV(char axe,float v)
{
	char s[30];        
	long l;
	
	l=(long)(v*m_lCte);
	switch (axe)
	{
		case 1://Axe x
			sprintf(s,"1VA%lu\r",l);
			MMSendCmd(s,m_iAdr);
		break;
		case 2://Axe y
			sprintf(s,"2VA%lu\r",l);
			MMSendCmd(s,m_iAdr);
		break;
		case 0://Tous les axes
			sprintf(s,"1VA%lu\r",l);
			if (MMSendCmd(s,m_iAdr))
			{
				sprintf(s,"2VA%lu\r",l);
				MMSendCmd(s,m_iAdr);
			}
		break;
	}
}
//________________________________________
//TP: Tell Position
float CMM2000::TP(char axe)
{
  char c,s[80],rep[80];
  float r;
  unsigned int i,j;
	BOOL ok;
	switch (axe)
	{
		case 1://Axe x
	  	ok=MMSendCmd("1TP\r",m_iAdr);
  		if (ok)
			{
				Sleep(50);
				MMReadResp(rep,m_iAdr);
			}
		break;
		case 2://Axe y
	  	ok=MMSendCmd("2TP\r",m_iAdr);
  		if (ok)
			{
				Sleep(50);
				MMReadResp(rep,m_iAdr);
			}
		break;
	}
	if (ok)
	{
		//Extraction des caractres numriques et conversion vers float
		j=0;
		for (i=0;i<strlen(rep);i++)
		{
			c=rep[i];
			if (c=='.' || c=='+' || c=='-' || (c>='0' && c<='9'))
			{
				s[j]=c;
				j++;
			}
		}
		s[j]='\n';
		i=sscanf(s,"%f",&r);
		if (i==1) 
			return (float)(r/m_lCte);
		else
			return 1e10;	
	}
	else
		return 1e10;	
}
//________________________________________
BOOL CMM2000::RT(char axe)
{
	char s[50];        
	BOOL ok;
	switch (axe)
	{
		case 1://Axe x
			sprintf(s,"1FI11\r");
			ok=MMSendCmd(s,m_iAdr);
			if (ok)
			{
				sprintf(s,"1VA1000;AC50000\r");
				MMSendCmd(s,m_iAdr);
				sprintf(s,"1FM3\r");
				MMSendCmd(s,m_iAdr);
				sprintf(s,"1DH\r");
				MMSendCmd(s,m_iAdr);
			}
		break;
		case 2://Axe y
			sprintf(s,"2FI11\r");
			ok=MMSendCmd(s,m_iAdr);
			if (ok)
			{
				sprintf(s,"2VA1000;AC50000\r");
				MMSendCmd(s,m_iAdr);
				sprintf(s,"2FM3\r");
				MMSendCmd(s,m_iAdr);
				sprintf(s,"2DH\r");
				MMSendCmd(s,m_iAdr);
			}
		break;
		case 0://Tous les axes
			sprintf(s,"1FI11\r");
			ok=MMSendCmd(s,m_iAdr);
			if (ok)
			{
				sprintf(s,"1VA1000;AC50000\r");
				MMSendCmd(s,m_iAdr);
				sprintf(s,"1FM03\r");
				MMSendCmd(s,m_iAdr);
				sprintf(s,"1DH\r");
				MMSendCmd(s,m_iAdr);
				sprintf(s,"2FI11\r");
				MMSendCmd(s,m_iAdr);
				sprintf(s,"2VA1000;AC50000\r");
				MMSendCmd(s,m_iAdr);
				sprintf(s,"2FM03\r");
				MMSendCmd(s,m_iAdr);
				sprintf(s,"2DH\r");
				MMSendCmd(s,m_iAdr);
			}
		break;
	}
	return ok;
}
//________________________________________
//Stop
void CMM2000::ST(char axe)
{
	char s[30];        
	switch (axe)
	{
		case 1://Axe x
			sprintf(s,"1ST\r");
			MMSendCmd(s,m_iAdr);
		break;
		case 2://Axe y
			sprintf(s,"2ST\r");
			MMSendCmd(s,m_iAdr);
		break;
		case 0://Axe x et y
			sprintf(s,"1ST\r");
			if (MMSendCmd(s,m_iAdr))
			{
				sprintf(s,"2ST\r");
				MMSendCmd(s,m_iAdr);
			}
		break;
	}
}
//________________________________________
//MT: Motor on Target: Mouvement termin
BOOL CMM2000::MT(char axe)
{
	BOOL ok;
	char rep[80];

	if (MMSendCmd("TS\r",m_iAdr))
	{
		Sleep(50);
		if(MMReadResp(rep,m_iAdr))
		{
			switch (axe)
			{
				case 1://Axe x
					if (rep[0]&1) ok=FALSE; else ok=TRUE;
				break;
				case 2://Axe y
					if (rep[0]&2) ok=FALSE; else ok=TRUE;
				break;
				case 0://Axe x et y
					if ((rep[0]&1) || (rep[0]&2)) ok=FALSE; else ok=TRUE;
				break;
			}
		}
		else
		{
			//Si carte pas OK, on considre le mouvement termin
			ok=FALSE;
		}
	}
	else
	{
		//Si carte pas OK, on considre le mouvement termin
		ok=FALSE;
	}
	return ok;
}
//________________________________________
//WS: Wait for Stop
void CMM2000::WS(char axe)
{
	switch (axe)
	{
		case 1://Axe x
			do ; while(!MT(1));
		break;
		case 2://Axe y
			do ; while(!MT(2));
		break;
		case 0://Axe x et y
			do ; while(!MT(0));
		break;
	}
}
//________________________________________
//DH: Dfinition home
void CMM2000::DH(char axe)
{
	char s[30];        
	switch (axe)
	{
		case 1://Axe x
			sprintf(s,"1DH\r");
			MMSendCmd(s,m_iAdr);
		break;
		case 2://Axe y
			sprintf(s,"2DH\r");
			MMSendCmd(s,m_iAdr);
		break;
		case 0://Axe x et y
			sprintf(s,"1DH\r");
			if (MMSendCmd(s,m_iAdr))
			{
				sprintf(s,"2DH\r");
				MMSendCmd(s,m_iAdr);
			}
		break;
	}
}
//________________________________________
//OR: Origine
void CMM2000::OR(char axe)
{
	char s[30];        
	switch (axe)
	{
		case 1://Axe x
			sprintf(s,"1OR1\r");
			MMSendCmd(s,m_iAdr);
		break;
		case 2://Axe y
			sprintf(s,"2OR1\r");
			MMSendCmd(s,m_iAdr);
		break;
		case 0://Axe x et y
			sprintf(s,"1OR1\r");
			if (MMSendCmd(s,m_iAdr))
			{
				sprintf(s,"2OR1\r");
				MMSendCmd(s,m_iAdr);
			}
		break;
	}
}
//________________________________________
//GH: Go Home
void CMM2000::GH(char axe)
{
	MA(axe,0);
}
