// verifdlg.cpp : implementation file
#include "stdafx.h"
#include "bk.h"
#include "verifdlg.h"
#include "bkdoc.h"
#include "eurosmart.h"
#include "mm2000.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
// CVerifDlg dialog
CVerifDlg::CVerifDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVerifDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVerifDlg)
	m_OKCor = FALSE;
	m_sTexte = _T("");
	//}}AFX_DATA_INIT
}
void CVerifDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVerifDlg)
	DDX_Control(pDX, IDC_Y_PLUS, m_btnYplus);
	DDX_Control(pDX, IDCANCEL, m_btnCancel);
	DDX_Control(pDX, IDC_Y_MOINS, m_btnYmoins);
	DDX_Control(pDX, IDC_X_PLUS, m_btnXplus);
	DDX_Control(pDX, IDC_X_MOINS, m_btnXmoins);
	DDX_Control(pDX, IDC_STOP, m_btnStop);
	DDX_Check(pDX, IDC_CORREC, m_OKCor);
	DDX_Text(pDX, IDC_STATIC_TEXTE, m_sTexte);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CVerifDlg, CDialog)
	//{{AFX_MSG_MAP(CVerifDlg)
	ON_BN_CLICKED(IDC_CORREC, OnCorrec)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_BN_CLICKED(IDC_X_MOINS, OnXMoins)
	ON_BN_CLICKED(IDC_X_PLUS, OnXPlus)
	ON_BN_CLICKED(IDC_Y_MOINS, OnYMoins)
	ON_BN_CLICKED(IDC_Y_PLUS, OnYplus)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//////////////////////////////////////////
// CVerifDlg message handlers
BOOL CVerifDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	m_pApp=((CBkApp*)AfxGetApp());
	CMDIChildWnd *pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) m_pDoc=(CBkDoc*)pChild->GetActiveDocument(); else m_pDoc=NULL;
	
	//On initialise  
	m_pMM2000=new CMM2000();
	m_pEuro=new CEurosmart();

	float u;
	u=m_pEuro->LitTension(1,1,2);
	if (u==1e10 || m_pMM2000->TP(1)==1e10)
	{
		m_btnXplus.EnableWindow(FALSE);
		m_btnXmoins.EnableWindow(FALSE);
		m_btnYplus.EnableWindow(FALSE);
		m_btnYmoins.EnableWindow(FALSE);
		m_btnStop.EnableWindow(FALSE);
		m_sTexte="Erreur carte MM2000 et/ou\nEurosmart !";
	}
	else
	if (m_pDoc->m_iEtal!=3)
	{
		m_btnXplus.EnableWindow(FALSE);
		m_btnXmoins.EnableWindow(FALSE);
		m_btnYplus.EnableWindow(FALSE);
		m_btnYmoins.EnableWindow(FALSE);
		m_btnStop.EnableWindow(FALSE);
		m_sTexte="Il faut faire pralablement un talonnage !";
	}
	else
	{
		m_pMM2000->SV(0,m_pMM2000->m_fVit);
		//On valide/invalide les boutons
		m_btnXplus.EnableWindow(TRUE);
		m_btnXmoins.EnableWindow(TRUE);
		m_btnYplus.EnableWindow(TRUE);
		m_btnYmoins.EnableWindow(TRUE);
		m_btnStop.EnableWindow(FALSE);
		//On dclenche le timer
		SetTimer(4,200,NULL);	
	}
	m_OKCor=m_pApp->m_OKCor;
	UpdateData(FALSE);
	return TRUE;
}
//________________________________________
void CVerifDlg::OnCorrec()
{
	UpdateData(TRUE);
	m_pApp->m_OKCor=m_OKCor;
	m_pDoc->m_fGamma=m_pDoc->CalculGamma();

	m_pDoc->Def_Plan(&(m_pDoc->m_fAlpha),&(m_pDoc->m_fBeta),&(m_pDoc->m_fOmega),&(m_pDoc->m_fEcmin),&(m_pDoc->m_fEcmax),&(m_pDoc->m_fPara));
	if (m_pApp->m_OKTilt)	m_pDoc->ConstructionImage(); else m_pDoc->ConstructionImageSansTilt(m_pDoc->m_fAlpha,m_pDoc->m_fBeta,m_pDoc->m_fOmega);
	m_pDoc->CalculProfils(m_pDoc->m_ptPF);

	m_pDoc->UpdateAllViews(NULL);
}
//________________________________________
void CVerifDlg::OnStop()
{
	if (m_cNoAxeMvt!=0)
	{
		m_pMM2000->ST(0);
		//m_pMM2000->WS(0);
		Sleep(200);
		//On invalide le bouton STOP		
		m_btnStop.EnableWindow(FALSE);      
		//On valide les autres boutons
		m_btnXplus.EnableWindow(TRUE);
		m_btnXmoins.EnableWindow(TRUE);
		m_btnYplus.EnableWindow(TRUE);
		m_btnYmoins.EnableWindow(TRUE);
		m_btnCancel.EnableWindow(TRUE);      
	}
	//Plus d'axe en mouvement
	m_cNoAxeMvt=0;
}
//________________________________________
void CVerifDlg::OnXMoins()
{
	//On valide/invalide les boutons
	m_btnXplus.EnableWindow(FALSE);
	m_btnXmoins.EnableWindow(FALSE);
	m_btnYplus.EnableWindow(FALSE);
	m_btnYmoins.EnableWindow(FALSE);
	m_btnCancel.EnableWindow(FALSE);      
	m_btnStop.EnableWindow(TRUE);      
	//Axe 1 en mouvement
	m_cNoAxeMvt=1;
	//On se dplace             
	m_pMM2000->MR(1,-200.00);
}
//________________________________________
void CVerifDlg::OnXPlus()
{
	//On valide/invalide les boutons
	m_btnXplus.EnableWindow(FALSE);
	m_btnXmoins.EnableWindow(FALSE);
	m_btnYplus.EnableWindow(FALSE);
	m_btnYmoins.EnableWindow(FALSE);
	m_btnCancel.EnableWindow(FALSE);      
	m_btnStop.EnableWindow(TRUE);      
	//Axe 1 en mouvement
	m_cNoAxeMvt=1;
	//On se dplace             
	m_pMM2000->MR(1,200.00);
}
//________________________________________
void CVerifDlg::OnYMoins()
{
	//On valide/invalide les boutons
	m_btnXplus.EnableWindow(FALSE);
	m_btnXmoins.EnableWindow(FALSE);
	m_btnYplus.EnableWindow(FALSE);
	m_btnYmoins.EnableWindow(FALSE);
	m_btnCancel.EnableWindow(FALSE);      
	m_btnStop.EnableWindow(TRUE);      
	//Axe 2 en mouvement
	m_cNoAxeMvt=2;
	//On se dplace             
	m_pMM2000->MR(2,-200.00);
}
//________________________________________
void CVerifDlg::OnYplus()
{
	//On valide/invalide les boutons
	m_btnXplus.EnableWindow(FALSE);
	m_btnXmoins.EnableWindow(FALSE);
	m_btnYplus.EnableWindow(FALSE);
	m_btnYmoins.EnableWindow(FALSE);
	m_btnCancel.EnableWindow(FALSE);      
	m_btnStop.EnableWindow(TRUE);      
	//Axe 2 en mouvement
	m_cNoAxeMvt=2;
	//On se dplace             
	m_pMM2000->MR(2,200.00);
}
//________________________________________
void CVerifDlg::OnTimer(UINT nIDEvent)
{
	float 
		ux,uy,h;
	short i,j;
	
	j=1;
	for (i=0;i<m_pApp->m_radioMoy;i++)
	{   
		j=j*2*2;
	}
  ux=m_pEuro->LitTension(0,1,j);
  uy=m_pEuro->LitTension(1,1,j);

  //Tenir compte du convertisseur
  //u=u*m_pApp->m_fCanA+m_pApp->m_fCanB;

	h=m_pDoc->PointImage(ux,uy,m_pDoc->m_fGamma);

	m_sTexte.Format("X(mm): %1.2f - Y(mm): %1.2f\nUx(V):%1.3f, Uy(V):%1.3f\nh(mm):%1.3f",m_pMM2000->TP(1),m_pMM2000->TP(2),ux,uy,h);
	UpdateData(FALSE);
	CDialog::OnTimer(nIDEvent);
}
//________________________________________
void CVerifDlg::OnCancel()
{
	//On supprime le timer
	KillTimer(4);	
	delete m_pMM2000;
	delete m_pEuro;
	m_pDoc->UpdateAllViews(NULL);
	CDialog::OnCancel();
}
//________________________________________
void CVerifDlg::OnOK()
{
	//CDialog::OnOK();
}
